/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpCfbNXRpCNX           */
/*      \            IndexCompiler                                         */
/*      pbP[W  jsd.compiler                                          */
/*      ŏIXV      2007/03/17(Sun)                                       */
/*      o[W      1.01.00                                               */
/*      쌠\      Copyright (C) 2006-2007 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * CfbNXRpCNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.compiler.IndexCompilerNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "jsd.compiler.IndexCompiler";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V XmlDocument Function jsd.xml.XmlDocument
  var XmlDocument = jsd.xml.XmlDocument;
  //:V Reference Function jsd.ref.Reference;
  var Reference = jsd.ref.Reference;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //:V PACKAGE_TOKEN String pbP[W؂蕶
  var PACKAGE_TOKEN = ".";
  //:V ROOT_NODE_NAME String [gm[h
  var ROOT_NODE_NAME = "jsd-index";
  //:V PACKAGE_NODE_NAME String pbP[Wm[h
  var PACKAGE_NODE_NAME = "index-package";
  //:V CLASS_NODE_NAME String NXm[h
  var CLASS_NODE_NAME = "index-class";
  //:V ID_ATTRIB_NAME String id
  var ID_ATTRIB_NAME = "id";
  //:V NAME_ATTRIB_NAME String id
  var NAME_ATTRIB_NAME = "name";
  //:V DEFINE_ATTRIB_NAME String pbP[W`t@C
  var DEFINE_ATTRIB_NAME = "definition";
  //:V HREF_ATTRIB_NAME String href
  var HREF_ATTRIB_NAME = "href";
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function getChildNode(parentNode, nodeName, childId)
   /**
    * em[h̒̎qm[hw̃m[h擾܂͐ĕԂ
    * @param parentNode jsd.xml.XmlNode em[h
    * @param nodeName String qm[h
    * @param childId String qm[hid
    * @return jsd.xml.XmlNode Ỹm[h
    */
    {
    log.trace("F:getChildNode - begin - ", parentNode, nodeName, childId);
    var children = parentNode.childNodes;
    var child = null;
    for(var i = 0; i < children.length; i++)
      {
      child = children[i];
      if(child && (child.nodeName == nodeName) && (child.getAttribute(ID_ATTRIB_NAME) == childId))
        {
        break;
        }
      child = null;
      }
    if(!child)
      {
      child = XmlDocument.createElement(nodeName);
      child.setAttribute(ID_ATTRIB_NAME, childId);
      parentNode.appendChild(child);
      }
    log.trace("F:getChildNode - end - ", child);
    return child;
    }
  //------------------------------------------------------------------------------
  function getPackageNode(xmlDoc, pkgName)
   /**
    * XMLhLgpbP[Wm[h擾
    * @notice ŶȂꍇ͐VɐB
    * @explanation w̃m[hɈvAidpbP[Włm[hԂB
    * @param xmlDoc jsd.xml.XmlDocument XMLhLg
    * @param pkgName String|null SCpbP[W(=id)
    * @return jsd.xml.XmlNode pbP[Wm[h
    */
    {
    log.trace("F:getPackageNode - begin - ", xmlDoc, pkgName);
    var pkgNode = xmlDoc.documentElement;
    if(!pkgNode)
      {
      pkgNode = XmlDocument.createElement(ROOT_NODE_NAME);
      xmlDoc.documentElement = pkgNode;
      }
    if(pkgName)
      {
      var pkgList = pkgName.split(PACKAGE_TOKEN);
      for(var i = 1; i <= pkgList.length; i++)
        {
        pkgName = pkgList.slice(0, i).join(PACKAGE_TOKEN);
        pkgNode = getChildNode(pkgNode, PACKAGE_NODE_NAME, pkgName);
        }
      if(!pkgNode.getAttribute(NAME_ATTRIB_NAME))
        {
        pkgNode.setAttribute(NAME_ATTRIB_NAME, pkgList[pkgList.length - 1]);
        }
      }
    log.trace("F:getPackageNode - end - ", pkgNode);
    return pkgNode;
    }
  //------------------------------------------------------------------------------
  function getClassNode(xmlDoc, clsName)
   /**
    * XMLhLgNXm[h擾
    * @notice ŶȂꍇ͐VɐB
    * @explanation w̃m[hɈvAidNXłm[hԂB
    * @param xmlDoc jsd.xml.XmlDocument XMLhLg
    * @param pkgName String|null SCNX(=id)
    * @return jsd.xml.XmlNode NXm[h
    */
    {
    log.trace("F:getClassNode - begin - ", xmlDoc, clsNode);
    var i = clsName.lastIndexOf(PACKAGE_TOKEN, clsName.length);
    var pkgName = (i >= 0) ? clsName.substring(0, i) : "";
    var pkgNode = getPackageNode(xmlDoc, pkgName);
    var clsNode = getChildNode(pkgNode, CLASS_NODE_NAME, clsName);
    if(!clsNode.getAttribute(NAME_ATTRIB_NAME))
      {
      clsNode.setAttribute(NAME_ATTRIB_NAME, clsName.substring((i + PACKAGE_TOKEN.length), clsName.length));
      }
    log.trace("F:getClassNode - end - ", clsNode);
    return clsNode;
    }
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S XMLNS_URI String XMLOURI
  Static.XMLNS_URI = "";
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  //:P compile undefined X[p[NXcompile\bhB
  Proto.compile = undefined;
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * NXRpCNX
    * @return jsd.compiler.IndexCompiler CX^X
    */
    {
    log.trace("F:Class - begin");
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v xmlDoc XmlDocument XML
    var xmlDoc = new XmlDocument(1.0);
    //:v refMap Object NXhref}bv(L[=SCNX, l=jsd.ref.Refence)
    var refMap = {};
    //:v defMap Object pbP[W`t@CƃpbP[W`ʒũ}bv(L[=`t@C, l=pbP[W`ʒu)
    var defMap = {};
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.putDefinition = function(pkgName, fileName)
     /**
      * pbP[W`t@C`ʒuɐݒ肷
      * @param pkgName String SCpbP[W
      * @param fileName String pbP[W`t@C
      * @throws StringFormatException s
      */
      {
      log.trace("I:putDefinition - begin - ", pkgName, fileName);
      if(!pkgName || ((typeof pkgName) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, pkgName, "pkgName", "NotEmptyString", "FAIL");
        }
      if(!fileName || ((typeof fileName) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, fileName, "fileName", "NotEmptyString", "FAIL");
        }
      var pkgNode = getPackageNode(xmlDoc, pkgName);
      defMap[fileName] = pkgName;
      pkgNode.setAttribute(DEFINE_ATTRIB_NAME, fileName);
      log.trace("I:putDefinition - end");
      };
    //------------------------------------------------------------------------------
    this.putClassLink = function(clsName, clsHref, defName)
     /**
      * NX̃N쐬
      * @param clsName String SCNX
      * @param clsHref String RpC̃t@C̎QƐ
      * @param defName [String|null] pbP[W`t@CiNXm[hɒڐݒ肷ꍇj
      * @throws StringFormatException s
      */
      {
      log.trace("I:putClassLink - begin - ", clsName, clsHref, defName);
      if(!clsName || ((typeof clsName) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, clsName, "clsName", "NotEmptyString", "FAIL");
        }
      if(!clsHref || ((typeof clsHref) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, clsHref, "clsHref", "NotEmptyString", "FAIL");
        }
      if((defName != null) && (defName != undefined) && (!defName || ((typeof defName) != "string")))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, defName, "defName", "NotEmptyString", "FAIL");
        }
      var node = getClassNode(xmlDoc, clsName);
      var href = new Reference(clsHref);
      refMap[clsName] = href;
      node.setAttribute(HREF_ATTRIB_NAME, href.toString());
      if(defName)
        {
        node.setAttribute(DEFINE_ATTRIB_NAME, defName);
        }
      log.trace("I:putClassLink - end");
      };
    //------------------------------------------------------------------------------
    this.putPackageLink = function(packName, packHref)
     /**
      * pbP[W̃N쐬
      * @param packName String SCpbP[W
      * @param packHref String RpC̃t@C̎QƐ
      * @throws StringFormatException s
      */
      {
      log.trace("I:putPackageLink - begin - ", packName, packHref);
      if(!packName || ((typeof packName) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, packName, "packName", "NotEmptyString", "FAIL");
        }
      if(!packHref || ((typeof packHref) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, packHref, "packHref", "NotEmptyString", "FAIL");
        }
      var node = getPackageNode(xmlDoc, packName);
      var href = new Reference(packHref);
      node.setAttribute(HREF_ATTRIB_NAME, href.toString());
      log.trace("I:putPackageLink - end");
      };
    //------------------------------------------------------------------------------
    this.putDefinitionLink = function(defName, defHref)
     /**
      * pbP[W`t@C̃N쐬
      * @param defName String pbP[W`t@C
      * @param defHref String RpC̃t@C̎QƐ
      * @condition defNameŎw肳pbP[W`t@ĆAputDefinition\bhɂĐݒ肳ꂽ̂łȂ΂ȂȂB
      * @throw ConditionException defNameŎw肳ꂽpbP[W`t@CAputDefinition\bhɂĐݒ肳ꂽ̂ł͂Ȃꍇ
      * @throws StringFormatException s
      */
      {
      log.trace("I:putDefinitionLink - begin - ", defName, defHref);
      if(!defName || ((typeof defName) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, defName, "defName", "NotEmptyString", "FAIL");
        }
      if(!defHref || ((typeof defHref) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, defHref, "defHref", "NotEmptyString", "FAIL");
        }
      var packName = defMap[defName];
      if(!packName)
        {
        throw new Error("ConditionException", Creator.CompleteName, "defNameŎw肳ꂽpbP[W`t@C͖ݒłB", defName);
        }
      this.putPackageLink(packName, defHref);
      log.trace("I:putDefinitionLink - end");
      };
    //------------------------------------------------------------------------------
    this.getXmlDocument = function()
     /**
      * XMLhLg擾
      * @return jsd.xml.XmlDocument XMLhLg
      */
      {
      log.trace("I:getXmlDocument - begin");
      log.trace("I:getXmlDocument - end - ", xmlDoc);
      return xmlDoc;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    xmlDoc.documentElement = XmlDocument.createElement(ROOT_NODE_NAME);
    log.trace("F:Class - end");
    return this;
    }
  
  return Class;
  }, jsd.compiler.AbstractCompiler);

