/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpeLXgt@C݃NX         */
/*      \            TextFileWriter                                        */
/*      pbP[W  jsd.io                                                */
/*      ŏIXV      2006/12/28(Wed)                                       */
/*      o[W      1.01.01                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * eLXgt@C݃NXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.io.TextFileWriterNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "jsd.io.TextFileWriter";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function createFolder(fso, path)
   /**
    * etH_쐬ď
    * @param fso Object FileSystemObject
    * @param path String t@C܂̓tH_̃pX
    * @return Boolean łĂ邩ǂ
    */
    {
    var isReady = false;
    try
      {
      var pf = fso.GetParentFolderName(path);
      if(pf && (pf != path))
        {
        if(fso.FolderExists(pf))
          {
          isReady = true;
          }
        else
          {
          if(arguments.callee(fso, pf))
            {
            fso.CreateFolder(pf);
            isReady = true;
            }
          }
        }
      }
    catch(e)
      {
      isReady = false;
      }
    return isReady;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  Class.copy = function(base, target)
   /**
    * t@C܂̓tH_Rs[
    * @param base String Rs[
    * @param target String Rs[
    * @return Boolean ǂ
    */
    {
    var isSuccess = false;
    if(base && ((typeof base) == "string") && target && ((typeof target) == "string"))
      {
      var fso = new ActiveXObject("Scripting.FileSystemObject");
      if(fso.FolderExists(base))
        {
        if(createFolder(fso, target))
          {
          fso.CopyFolder(base, target, true);
          isSuccess = true;
          }
        else
          {
          isSuccess = false;
          }
        }
      else if(fso.FileExists(base))
        {
        if(createFolder(fso, target))
          {
          fso.CopyFile(base, target, true);
          isSuccess = true;
          }
        else
          {
          isSuccess = false;
          }
        }
      }
    return isSuccess;
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.open = function(type, win)
   /**
    * o͂J
    * @param type String J("execCommand","FileSystemObject","ADODB.Stream")
    * @param win [Object] EBhEIuWFNg(execCommand̏ꍇ̂ݕKv)
    * @throws ParameterRangeException s
    */
    {
    if((type == "execCommand") && ((typeof win) == "object") && ((typeof win.document) == "object") && win.document.body)
      {
      var doc = win.document;
      var div = doc.createElement("div");
      div.style.cssText = "position:absolute;display:none;";
      doc.body.appendChild(div);
      var time = "_" + (new Date()).getTime() + Math.floor(Math.random() * 1000);
      var name = "frame" + time;
      div.innerHTML = '<iframe name="' + name + '" id="id' + time + '" src="about:blank" width="0" height="0"></iframe>';
      this.object = win[name];
      this.type = type;
      }
    else if(type == "FileSystemObject")
      {
      var fso = new ActiveXObject("Scripting.FileSystemObject");
      this.object = fso;
      this.type = type;
      }
    else if(type == "ADODB.Stream")
      {
      var ado = new ActiveXObject("ADODB.Stream");
      this.object = ado;
      this.type = type;
      }
    else
      {
      throw new Error("ParameterRangeException", Creator.CompleteName, null, type, "type", "\ߎw肳ꂽl", "FAIL");
      }
    };
  //------------------------------------------------------------------------------
  Proto.write = function(text)
   /**
    * 
    * @param text String ޓe
    */
    {
    if(!this.object || !this.type)
      {
      throw new Error("ConditionException", Creator.CompleteName, "ޏłĂ܂B", null);
      }
    else if((typeof text) != "string")
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, text, "text", "String", "FAIL");
      }
    else if(this.type == "execCommand")
      {
      var doc = this.object.document;
      var mime = this.getMimeType();
      var opts = (mime ? mime : "text/plain") + "; charset=" + this.getEncoding();
      doc.open(opts);
      doc.write(text);
      doc.close();
      doc.execCommand("SaveAs", false, this.getTarget());
      }
    else if(this.type == "FileSystemObject")
      {
      var encoding = this.getEncoding();
      switch(encoding.toUpperCase())
        {
        case "ASCII":
        case "SHIFT_JIS":
        case "SHIFT-JIS":
        case "SJIS":
          encoding = 0;
          break;
        case "Unicode":
        case "UTF-16":
          encoding = -1;
          break;
        default:
          encoding = -2;
        }
      createFolder(this.object, this.getTarget());
      var writer = this.object.CreateTextFile(this.getTarget(), true, encoding);
      writer.Write(text);
      writer.Close();
      }
    else if(this.type == "ADODB.Stream")
      {
      var encoding = this.getEncoding();
      var ado = this.object;
      if(ado)
        {
        var fso = new ActiveXObject("Scripting.FileSystemObject");
        if(fso)
          {
          createFolder(fso, this.getTarget());
          }
        }
      ado.charset = encoding;
      ado.type = 2;  // adTypeText
      ado.Open();
      ado.WriteText(text);
      ado.SaveToFile(this.getTarget(), 2);  // 1:adSaveCreateNotExist / 2:adSaveCreateOverWrite
      ado.Close();
      }
    else
      {
      throw new Error("ConditionException", Creator.CompleteName, "ݗpIuWFNgʂł܂B", null);
      }
    };
  //------------------------------------------------------------------------------
  Proto.close = function()
   /**
    * o͂
    */
    {
    if(this.object)
      {
      if(this.type == "execCommand")
        {
        var win = this.object.parent;
        var doc = win.document;
        var id = this.object.name;
        var div = doc.getElementById(id).parentNode;
        div.innerHTML = "";
        doc.body.removeChild(div);
        delete this.object;
        delete this.type;
        }
      else if(this.type == "FileSystemObject")
        {
        this.object = null;
        delete this.object;
        delete this.type;
        }
      else if(this.type == "ADODB.Stream")
        {
        this.object = null;
        delete this.object;
        delete this.type;
        }
      else
        {
        delete this.object;
        delete this.type;
        }
      }
    else if(this.type)
      {
      delete this.type;
      }
    };
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(target, encoding, mimeType)
   /**
    * eLXgt@C݃NX
    * @param target String o͑Ώې(URI,t@CȂ)
    * @param encoding String R[hEGR[fBO
    * @param mimeType [String] MIME^Cv
    * @return jsd.io.TextFileWriter CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.getMimeType = function()
     /**
      * MIME^Cv擾
      * @return String|null MIME^Cv
      */
      {
      if((typeof mimeType) == "string")
        {
        return mimeType;
        }
      else
        {
        return null;
        }
      };
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  }, jsd.io.AbstractIO);
