/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpXMLhLgNX                  */
/*      \            XmlDocument                                           */
/*      pbP[W  jsd.xml                                               */
/*      ŏIXV      2006/06/04(Sun)                                       */
/*      o[W      1.00.02                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * XMLhLgNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.xml.XmlDocumentNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.xml.XmlDocument";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V XmlNode Function jsd.xml.XmlNode
  var XmlNode = jsd.xml.XmlNode;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function getElementById(id, attribName)
   /**
    * idw肵ėvf擾
    * @condition ̃\bhthisjsd.xml.XmlNodeƂĎsȂ΂ȂȂB
    * @param id String id
    * @param attribName String idƂĂ݂鑮(ʏ"id"w肷)
    * @return XmlNode|null vm[h
    */
    {
    var node = null;
    if(this.hasAttribute(attribName))
      {
      var idValue = this.getAttribute(attribName);
      if(id == idValue)
        {
        node = this;
        }
      }
    if(!node && this.childNodes)
      {
      for(var i = 0; i < this.childNodes.length; i++)
        {
        var child = this.childNodes[i];
        node = arguments.callee.apply(child, arguments);
        if(node)
          {
          break;
          }
        }
      }
    return node;
    }
  //------------------------------------------------------------------------------
  function getElementsByTagName(nodeName)
   /**
    * m[hw肵ėvf̏W擾
    * @condition ̃\bhthisjsd.xml.XmlNodeƂĎsȂ΂ȂȂB
    * @param nodeName String m[h
    * @return Array vf(m[h̔z)
    */
    {
    var list = [];
    if(this.childNodes)
      {
      for(var i = 0; i < this.childNodes.length; i++)
        {
        var child = this.childNodes[i];
        if(child && (child.nodeName == nodeName))
          {
          list[list.length] = child;
          }
        if(child.childNodes && (child.childNodes.length > 0))
          {
          var gc = arguments.callee.call(child, nodeName);
          if(gc && (gc.length > 0))
            {
            for(var j = 0; j < gc.length; j++)
              {
              list[list.length] = gc[j];
              }
            }
          }
        }
      }
    return list;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  Class.createElement = function(nodeName)
   /**
    * vf(m[h)𐶐
    * @param nodeName String m[h
    * @return jsd.xml.XmlNode m[h
    * @throws StringFormatException s
    */
    {
    if(!nodeName || ((typeof nodeName) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, nodeName, "nodeName", "NotEmptyString", "FAIL");
      }
    return new XmlNode(nodeName);
    };
  //------------------------------------------------------------------------------
  Class.createProcessingInstruction = function(nodeName)
   /**
    * ߃m[h𐶐
    * @param nodeName String ^[Qbg
    * @return jsd.xml.XmlNode m[h
    * @throws StringFormatException s
    */
    {
    if(!nodeName || ((typeof nodeName) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, nodeName, "nodeName", "NotEmptyString", "FAIL");
      }
    return new XmlNode("?" + nodeName);
    };
  //------------------------------------------------------------------------------
  Class.createTextNode = function(text)
   /**
    * eLXgm[h𐶐
    * @param text [String] eLXg
    * @return jsd.xml.XmlNode m[h
    * @throws StringFormatException s
    */
    {
    if((nodeName !== undefined) || ((typeof nodeName) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, text, "text", "NotEmptyString", "FAIL");
      }
    var node = new XmlNode("#text");
    if((typeof text) != "string")
      {
      node.setValue(text);
      }
    return node;
    };
  //------------------------------------------------------------------------------
  Class.createComment = function(comment)
   /**
    * Rgm[h𐶐
    * @param comment [String] Rg
    * @return jsd.xml.XmlNode m[h
    * @throws StringFormatException s
    */
    {
    if((nodeName !== undefined) || ((typeof nodeName) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, comment, "comment", "NotEmptyString", "FAIL");
      }
    var node = new XmlNode("#comment");
    if((typeof comment) != "string")
      {
      node.setValue(comment);
      }
    return node;
    };
  //------------------------------------------------------------------------------
  Class.createCDATASection = function(cdata)
   /**
    * CDATAZNVm[h𐶐
    * @param cdata [String] e
    * @return jsd.xml.XmlNode m[h
    * @throws StringFormatException s
    */
    {
    if((nodeName !== undefined) || ((typeof nodeName) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, cdata, "cdata", "NotEmptyString", "FAIL");
      }
    var node = new XmlNode("#cdata-section");
    if((typeof cdata) != "string")
      {
      node.setValue(cdata);
      }
    return node;
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P documentDeclaration jsd.xml.XmlNode|null XML錾
  Proto.documentDeclaration = null;
  //:P documentType jsd.xml.XmlNode|null hLg^Cv
  Proto.documentType = null;
  //:P documentStyleSheet jsd.xml.XmlNode|null XMLX^CV[g
  Proto.documentStyleSheet = null;
  //:P documentElement jsd.xml.XmlNode|null [gm[h
  Proto.documentElement = null;
  
  //------------------------------------------------------------------------------
  Proto.setDocumentStyleSheet = function(href)
   /**
    * XMLX^CV[gݒ肷
    * @param href String|null XMLX^CV[gURI
    * @throws StringFormatException s
    */
    {
    if((href !== null) && (!href || ((typeof href) != "string")))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, href, "href", "NotEmptyString|null", "FAIL");
      }
    if(href)
      {
      this.documentStyleSheet = new XmlNode("?xml-stylesheet");
      this.documentStyleSheet.setAttribute("type", "text/xsl");
      this.documentStyleSheet.setAttribute("href", href);
      }
    else
      {
      this.documentStyleSheet = null;
      }
    };
  //------------------------------------------------------------------------------
  Proto.getElementById = function(id, attribName)
   /**
    * idw肵ėvf擾
    * @notice id͏dȂ͂Ȃ̂ŁAŏɔꂽm[hԂB
    * @param id String id
    * @param attribName [String] idƂĂ݂鑮"id"łȂꍇɁAw
    * @return XmlNode|null vm[h
    * @throws StringFormatException s
    */
    {
    if(!id || ((typeof id) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, id, "id", "NotEmptyString", "FAIL");
      }
    if((attribName !== undefined) && (attribName || ((typeof attribName) != "string")))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, attribName, "attribName", "[String]", "FAIL");
      }
    if(!attribName)
      {
      attribName = "id";
      }
      var node = null;
      var root = this.documentElement;
      if(root)
        {
        node = getElementById.call(root, id, attribName);
        }
      return node;
    };
  //------------------------------------------------------------------------------
  Proto.getElementsByTagName = function(nodeName)
   /**
    * m[hw肵ėvf̏W擾
    * @param nodeName String m[h
    * @return Array vf(m[h̔z)
    * @throws StringFormatException s
    */
    {
    if(!nodeName || ((typeof nodeName) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, nodeName, "nodeName", "NotEmptyString", "FAIL");
      }
    var list = [];
    var root = this.documentElement;
    if(root)
      {
      if(root.nodeName == nodeName)
        {
        list[list.length] = root;
        }
      list = list.concat(getElementsByTagName.call(root, nodeName));
      }
    return list;
    };
  //------------------------------------------------------------------------------
  Proto.toString = function(nestSpace, lineSeparator, minimizable)
   /**
    * ̃hLg̕\擾
    * @param nestSpace [String] lXgp̋󔒕(\tȂ)
    * @param lineSeparator [String] s(\r\n)
    * @param minimizable [Boolean] ŏ邩ǂ
    * @return String ̃hLg̕\
    */
    {
    var ns = ((typeof nestSpace) == "string") ? nestSpace : "";
    var fs = ((typeof lineSeparator) == "string") ? lineSeparator.replace(/[^\r\n]/, "") : "";
    var str = "";
    var dec = this.documentDeclaration;
    var dtd = this.documentType;
    var sts = this.documentStyleSheet;
    var elm = this.documentElement;
    if(dec && (dec instanceof XmlNode))
      {
      if((dec.nodeType == 7) && (dec.nodeName == "xml"))
        {
        if(!isNaN(dec.getAttribute("version")))
          {
          str += dec.toString(nestSpace, "", minimizable);
          }
        }
      }
    if(dtd && (dtd instanceof XmlNode))
      {
      if(dtd.nodeType == 10)
        {
        str += dtd.toString(nestSpace, lineSeparator, minimizable);
        }
      }
    if(sts && (sts instanceof XmlNode))
      {
      if(sts.nodeType == 7)
        {
        str += sts.toString(nestSpace, lineSeparator, minimizable);
        }
      }
    if(elm && (elm instanceof XmlNode))
      {
      if(elm.nodeType == 1)
        {
        str += elm.toString(nestSpace, lineSeparator, minimizable);
        }
      }
    return str;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(version, encoding, standalone)
   /**
    * XMLhLgNX
    * @param version Number XMLo[W
    * @param encoding [String|null] GR[fBO
    * @param standalone [Boolean] X^hA[
    * @return jsd.xml.XmlDocument CX^X
    * @throws NumberFormatException|StringFormatException|BooleanFormatException s
    */
    {
    if((typeof version) != "number")
      {
      throw new Error("NumberFormatException", Creator.CompleteName, null, version, "version", "Number", "FAIL");
      }
    if((encoding != null) && (encoding != undefined) && ((typeof encoding) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, encoding, "encoding", "[String|null]", "FAIL");
      }
    if((standalone !== undefined) && ((typeof standalone) != "boolean"))
      {
      throw new Error("BooleanFormatException", Creator.CompleteName, null, standalone, "standalone", "[Boolean]", "FAIL");
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //:i documentDeclaration jsd.xml.XmlNode XML錾
    this.documentDeclaration = new XmlNode("?xml");
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    version = ((version % 1) == 0) ? (version + ".0") : ("" + version);
    this.documentDeclaration.setAttribute("version", version);
    if((typeof encoding) == "string")
      {
      this.documentDeclaration.setAttribute("encoding", encoding);
      }
    if((typeof standalone) == "boolean")
      {
      this.documentDeclaration.setAttribute("standalone", (standalone ? "yes" : "no"));
      }
    return this;
    }
  
  return Class;
  });

