/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpXMLm[hNX                        */
/*      \            XmlNode                                               */
/*      pbP[W  jsd.xml                                               */
/*      ŏIXV      2006/10/08(Sun)                                       */
/*      o[W      1.01.00                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * XMLm[hNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.xml.XmlNodeNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.xml.XmlNode";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function escapeText(text, node)
   /**
    * GXP[v
    * @param text String Ώە
    * @param node [String] m[h(ȗ:)
    * @return String
    */
    {
    switch(node)
      {
      case "#cdata-section":
        if(text.indexOf("]]>", 0) < 0)
          {
          break;
          }
        text = text.replace(/&/, "&amp;");
        text = text.replace(/</, "&lt;");
        text = text.replace(/>/, "&gt;");
        break;
      case "#comment":
        if(text.indexOf("-->", 0) < 0)
          {
          break;
          }
        text = text.replace(/&/, "&amp;");
        text = text.replace(/</, "&lt;");
        text = text.replace(/>/, "&gt;");
        break;
      case "#text":
        text = text.replace(/&/, "&amp;");
        text = text.replace(/</, "&lt;");
        text = text.replace(/>/, "&gt;");
        break;
      case undefined:
      case null:
        text = text.replace(/&/, "&amp;");
        text = text.replace(/</, "&lt;");
        text = text.replace(/>/, "&gt;");
        text = text.replace(/"/, "&quot;");
        text = text.replace(/"/, "&apos;");
        break;
      default:
      }
    return text;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P attributes Object|null }bv
  Proto.attributes = null;
  //:P parentNode XmlNode|null em[h
  Proto.parentNode = null;
  //:P previousSibling XmlNode|null Õm[h
  Proto.previousSibling = null;
  //:P nextSibling XmlNode|null ̃m[h
  Proto.nextSibling = null;
  //:P childNodes Array|null qm[h̔z
  Proto.childNodes = null;
  //:P firstChild XmlNode|null ŏ̎qm[h
  Proto.firstChild = null;
  //:P lastChild XmlNode|null Ō̎qm[h
  Proto.lastChild = null;
  
  //------------------------------------------------------------------------------
  Proto.hasAttribute = function(attribName)
   /**
    * ǂ擾
    * @param attribName String 
    * @return Boolean|undefined ǂ
    */
    {
    if(!attribName || ((typeof attribName) != "string"))
      {
      return undefined;
      }
    return this.attributes.hasOwnProperty(attribName);
    };
  //------------------------------------------------------------------------------
  Proto.getAttribute = function(attribName)
   /**
    * ̒l擾
    * @param attribName String 
    * @return String|undefined l
    */
    {
    if(!attribName || ((typeof attribName) != "string"))
      {
      return undefined;
      }
    return this.attributes[attribName];
    };
  //------------------------------------------------------------------------------
  Proto.setAttribute = function(attribName, attribValue)
   /**
    * ɒlݒ肷
    * @param attribName String 
    * @param attribValue [String|null|undefined] l
    * @return Boolean ݒɐǂ
    */
    {
    if(!attribName || ((typeof attribName) != "string"))
      {
      return false;
      }
    if((/\s/).test(attribName))
      {
      return false;
      }
    if((typeof attribValue) != "string")
      {
      attribValue = "" + attribValue;
      }
    this.attributes[attribName] = attribValue;
    return true;
    };
  //------------------------------------------------------------------------------
  Proto.removeAttribute = function(attribName)
   /**
    * 폜
    * @param attribName String 
    * @return Boolean ̍폜ɐǂ
    */
    {
    if(!attribName || ((typeof attribName) != "string"))
      {
      return false;
      }
    if((/\s/).test(attribName))
      {
      return false;
      }
    delete this.attributes[attribName];
    return true;
    };
  //------------------------------------------------------------------------------
  Proto.hasChildNodes = function()
   /**
    * qm[hǂ擾
    * @return Boolean qm[hǂ
    */
    {
    return (this.childNodes && (this.childNodes.length > 0));
    };
  //------------------------------------------------------------------------------
  Proto.insertBefore = function(insertNode, targetNode)
   /**
    * m[hqm[hƂđ}
    * @param insertNode XmlNode }qm[h
    * @param targetNode [XmlNode|null] }ʒuɂ̎qm[h(̃m[h̑Oɑ})
    * @return Boolean }ɐǂ
    */
    {
    if(!insertNode || !(insertNode instanceof Class))
      {
      return false;
      }
    var len = this.childNodes.length;
    var shiftChild = null;
    if(targetNode && (targetNode instanceof Class))
      {
      for(var i = 0; i < len; i++)
        {
        if(shiftChild)
          {
          targetNode = this.childNodes[i];
          this.childNodes[i] = shiftChild;
          shiftChild = targetNode;
          }
        else if(this.childNodes[i] == targetNode)
          {
          this.childNodes[i] = insertNode;
          shiftChild = targetNode;
          if(i == 0)
            {
            this.firstChild = insertNode;
            insertNode.previousSibling = null;
            }
          else
            {
            insertNode.previousSibling = this.childNodes[i - 1];
            this.childNodes[i - 1].nextSibling = insertNode;
            }
          insertNode.parentNode = this;
          insertNode.nextSibling = shiftChild;
          shiftChild.previousSibling = insertNode;
          }
        }
      }
    if(shiftChild)
      {
      this.childNodes[len] = shiftChild;
      }
    else
      {
      this.childNodes[len] = insertNode;
      if(len == 0)
        {
        this.firstChild = insertNode;
        insertNode.previousSibling = null;
        }
      else
        {
        insertNode.previousSibling = this.childNodes[len - 1];
        this.childNodes[len - 1].nextSibling = insertNode;
        }
      this.lastChild = insertNode;
      insertNode.parentNode = this;
      insertNode.nextSibling = null;
      }
    return true;
    };
  //------------------------------------------------------------------------------
  Proto.appendChild = function(appendNode)
   /**
    * m[hqm[hƂĒǉ
    * @param appendNode XmlNode }qm[h
    * @return Boolean ǉɐǂ
    */
    {
    return this.insertBefore(appendNode);
    };
  //------------------------------------------------------------------------------
  Proto.replaceChild = function(replaceNode, targetNode)
   /**
    * qm[hu
    * @param replaceNode XmlNode um[h
    * @param targetNode XmlNode uqm[h
    * @return Boolean uɐǂ
    */
    {
    if(!replaceNode || !(replaceNode instanceof Class))
      {
      return false;
      }
    if(!targetNode || !(targetNode instanceof Class))
      {
      return false;
      }
    var next = targetNode.nextSibling;
    if(this.removeChild(targetNode))
      {
      if(this.insertBefore(replaceNode, next))
        {
        replaceNode = null;
        }
      }
    return !replaceNode;
    };
  //------------------------------------------------------------------------------
  Proto.removeChild = function(removeNode)
   /**
    * qm[h폜
    * @param removeNode XmlNode 폜m[h
    * @return Boolean 폜ɐǂ
    */
    {
    if(!removeNode || !(removeNode instanceof Class))
      {
      return false;
      }
    var ans = false;
    var len = this.childNodes.length;
    if(len > 0)
      {
      var idx = -1;
      for(var i = 0; i < len; i++)
        {
        if(this.childNodes[i] == removeNode)
          {
          idx = i;
          break;
          }
        }
      if(idx >= 0)
        {
        var max = len - 1;
        if(idx == 0)
          {
          this.firstChild = (len > 1) ? this.childNodes[1] : null;
          }
        if(idx == max)
          {
          this.lastChild = (len > 1) ? this.childNodes[max - 1] : null;
          }
        if(idx > 0)
          {
          this.childNodes[idx - 1].nextSibling = (idx < max) ? this.childNodes[idx + 1] : null;
          }
        if(idx < max)
          {
          this.childNodes[idx + 1].previousSibling = (idx > 0) ? this.childNodes[idx - 1] : null;
          }
        for(var i = idx; i < len; i++)
          {
          if(i < max)
            {
            this.childNodes[i] = this.childNodes[i + 1];
            }
          }
        this.childNodes.length = max;
        removeNode.parentNode = null;
        removeNode.previousSibling = null;
        removeNode.nextSibling = null;
        ans = true;
        }
      }
    return ans;
    };
  //------------------------------------------------------------------------------
  Proto.equals = function(node, withValueCompare)
   /**
    * m[h̓e
    * @param node [XmlNode|null] Ώۂ̃m[h(thisƔr)
    * @param withValueCompare [Boolean|null] m[h̔r@(false:rȂ,ȗ:==r,true:===r)
    * @return Boolean r
    */
    {
    var isMatch = false;
    if((this instanceof Class) && (node instanceof Class))
      {
      isMatch = true;
      isMatch &= (this.nodeName == node.nodeName);
      isMatch &= (this.nodeType == node.nodeType);
      if((withValueCompare == null) || (withValueCompare === undefined))
        {
        isMatch &= (this.value == node.value);
        }
      else if((typeof withValueCompare) == "boolean")
        {
        if(withValueCompare)
          {
          isMatch &= (this.value === node.value);
          }
        }
      if(isMatch)
        {
        var attrib = {};
        for(var name in this.attributes)
          {
          if(!node.attributes.hasOwnProperty(name) || (this.attributes[name] != node.attributes[name]))
            {
            isMatch &= false;
            break;
            }
          attrib[name] = true;
          }
        if(isMatch)
          {
          for(var name in node.attributes)
            {
            if(!attrib[name])
              {
              isMatch &= false;
              break;
              }
            }
          }
        }
      isMatch &= (this.childNodes.length == node.childNodes.length);
      if(isMatch)
        {
        for(var i = 0; i < this.childNodes.length; i++)
          {
          isMatch &= this.childNodes[i].equals(node.childNodes[i], withValueCompare);
          }
        }
      }
    return isMatch;
    };
  //------------------------------------------------------------------------------
  Proto.cloneNode = function()
   /**
    * m[hfB[vN[
    * @notice lȂǂv~eBu^łȂꍇ́AQƂRs[B
    * @return XmlNode ̃m[h̃N[
    */
    {
    var Constructor = this.constructor;
    if((Constructor != Class) && !(Constructor.prototype instanceof Class))
      {
      Constructor = Class;
      }
    var node = new Constructor();
    node.nodeName  = this.nodeName;
    node.nodeValue = this.nodeValue;
    node.nodeType  = this.nodeType;
    for(var i in this.attributes)
      {
      node.attributes[i] = this.attributes[i];
      }
    for(var i = 0; i < this.childNodes.length; i++)
      {
      node.appendChild(this.childNodes[i].cloneNode());
      }
    return node;
    };
  //------------------------------------------------------------------------------
  Proto.toString = function(nestSpace, firstSpace, minimizable)
   /**
    * ̃m[h̕\擾
    * @param nestSpace [String] lXgp̋󔒕(\tȂ)
    * @param firstSpace [String] ̋󔒕(\r\n)
    * @param minimizable [Boolean] ŏ邩ǂ
    * @return String ̃m[h̕\
    */
    {
    var ns = ((typeof nestSpace) == "string") ? nestSpace : "";
    var fs = ((typeof firstSpace) == "string") ? firstSpace : "";
    var str, val;
    switch(typeof this.nodeValue)
      {
      case "undefined":
      case "null":
        val = "";
        break;
      case "number":
        val = isNaN(this.nodeValue) ? "" : ("" + this.nodeValue);
        break;
      case "string":
        val = this.nodeValue;
        break;
      case "function":
      case "object":
      default:
        val = "" + this.nodeValue;
      }
    switch(this.nodeName)
      {
      case "#cdata-section":
        str = '<![CDATA[' + escapeText(val, this.nodeName) + ']]>';
        break;
      case "#comment":
        str = '<!--' + escapeText(val, this.nodeName) + '-->';
        break;
      case "#text":
        str = escapeText(val, this.nodeName);
        break;
      default:
        str = '<';
        if(this.nodeType == 7)
          {
          str += '?';
          }
        if(this.nodeType == 10)
          {
          str += '!';
          }
        str += this.nodeName;
        for(var i in this.attributes)
          {
          var val = this.attributes[i];
          if((typeof val) != "string")
            {
            val = "" + val;
            }
          str += ' ' + i + '="' + escapeText(val) + '"';
          }
        if((this.nodeType != 7) && (this.nodeType != 10))
          {
          if(!this.hasChildNodes() && minimizable)
            {
            str += '/';
            }
          }
        else if(this.nodeType == 7)
          {
          str += '?';
          }
        str += '>';
        if(this.nodeType != 7)
          {
          for(var i = 0; i < this.childNodes.length; i++)
            {
            var child = this.childNodes[i];
            if(child.hasOwnProperty("toString") && ((typeof child.toString) == "function"))
              {
              str += child.toString(nestSpace, (fs + ns), minimizable);
              }
            else
              {
              str += arguments.callee.call(child, nestSpace, (fs + ns), minimizable);
              }
            }
          }
        if((this.nodeType != 7) && (this.nodeType != 10))
          {
          if(this.hasChildNodes() || !minimizable)
            {
            if(this.lastChild && (this.lastChild.nodeName != "#text"))
              {
              str += fs;
              }
            str += '</' + this.nodeName + '>';
            }
          }
        //break;
      }
    if(this.nodeName != "#text")
      {
      if(!this.previousSibling || (this.previousSibling.nodeName != "#text"))
        {
        str = fs + str;
        }
      }
    return str;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(nodeName, nodeValue)
   /**
    * Xmlm[hNX
    * @param nodeName [String] m[h
    * @param nodeValue [String] m[hl
    * @return jsd.xml.XmlNode CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //:i attributes Object }bv
    this.attributes = {};
    //:i childNodes Array qm[h̔z
    this.childNodes = [];
    //:i nodeType Number m[h^Cv
    this.nodeType = 1;
    //:i nodeName String|null m[h
    this.nodeName = null;
    //:i nodeValue String|null|undefined m[h̒l(Variableł)
    this.nodeValue = undefined;
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    if(nodeName && ((typeof nodeName) == "string"))
      {
      switch(nodeName)
        {
        case "#cdata-section":
          this.nodeType = 4;
          break;
        case "#comment":
          this.nodeType = 8;
          break;
        case "#text":
          this.nodeType = 3;
          break;
        default:
          if(nodeName.charAt(0) == "?")
            {
            this.nodeType = 7;
            nodeName = nodeName.substring(1, nodeName.length);
            }
          else if(nodeName.charAt(0) == "!")
            {
            this.nodeType = 10;
            nodeName = nodeName.substring(1, nodeName.length);
            }
          else
            {
            this.nodeType = 1;
            }
          // break;
        }
      this.nodeName = nodeName;
      }
    if(arguments.length > 1)
      {
      this.nodeValue = nodeValue;
      }
    return this;
    }
  
  return Class;
  });

