/******************************************************************************/
/*                                                                            */
/*      ECMAScriptlCeBuIuWFNg̒`iJSDRpCpj         */
/*                                                                            */
/******************************************************************************/

//##############################################################################
(function()
  {
  var Array = ([]).constructor;
  var Boolean = (true).constructor;
  var NativeError = ((typeof js.cpt.Error) == "function") ? js.cpt.Error.Super : Error;
  var Function = (function(){}).constructor;
  var Number = (0).constructor;
  var Object = ({}).constructor;
  var RegExp = (/^$/).constructor;
  var String = ("").constructor;
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - Object
    * @param Super [Function|null] X[p[NX
    * @return Function ObjectNX
    * 
    * @explanation <p>̃NXECMAScriptɂNXłB
    *   ̃NXɑ΂钼ڂ̕ύX͑̑SẴIuWFNgɑ΂ĉeyڂ\B</p>
    * @example <p>ObjectIuWFNg̓RXgN^gpƂAeŋLq@B
    *   <kbd>{vpeB1:l1, vpeB2:l2, vpeB3:l3, ...}</kbd>ƋLq΂悢B</p>
    *   <p>ȉɁAvpeBkanjiɁu{vCvpeBkanaɁuɂق񂲁vCvpeBtoStringɂ
    *   kanjikanaȂĕ񉻂ĕԂ֐ݒ肳ꂽObjectIuWFNgeŋLqB</p>
    *   <pre><code>
    *   var obj = {
    *     kanji : "{",
    *     kana  : "ɂق",
    *     toString : function() {
    *       return this.kanji + "(" + this.kana + ")";
    *     }
    *   };
    *   </code></pre>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "Object";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    // _~[JSD[]
    /**
     * ObjectRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation <p>ObjectRXgN^FunctionIuWFNgł̂ŁA<var>length</var>vpeBB</p>
     */
    //:C prototype Object {DontEnum, DontDelete, ReadOnly} ObjectNX̃vg^CvIuWFNg
    //:P constructor Function ObjectRXgN^
    /**
     * IuWFNg̕\擾
     * @def P
     * @name toString
     * @type Function
     * @return String IuWFNg̕\
     * @explanation <p>IȃRXgN^{Class}ƂƁA<samp>[object {Class}]</samp>ԂB</p>
     */
    /**
     * ObjectNXɂĂtoStringƓʂԂ
     * @def P
     * @name toLocaleString
     * @type Function
     * @return String IuWFNg̕\iP[ˑj
     * @explanation <p>̃\bh̓TuNXP[ˑ̕\ԂƂł悤ɂ邽߂ɒ񋟂ĂB
     *   TuNXł̓P[ˑ̕\Ԃ\bhł̃\bhI[o[ChĎB</p>
     */
    /**
     * thisl擾
     * @def P
     * @name valueOf
     * @type Function
     * @return Object ̃\bhsthisl
     * @notice <p>RXgN^̈zXgIuWFNgłꍇ́AԂl͎ˑłB</p>
     */
    /**
     * w̃vpeB𒼐ڎǂ𔻒肷
     * @def P
     * @name hasOwnProperty
     * @type Function
     * @param V String|Object vpeB̖Oi񉻂j
     * @return Boolean VŎw肳ꂽvpeBthisڎǂ
     * @explanation <p>̃\bh̎sthisVŗ^ꂽvpeB̃vpeBǂB
     *   ̂ƂAthis̃vg^Cv`F[͍lꂸAthisڎvpeBΏۂƂȂB</p>
     */
    /**
     * w̃IuWFNgthisƃvg^Cv`F[ŌqĂ邩ǂ
     * @def P
     * @name isPrototypeOf
     * @type Function
     * @param V Object IuWFNg
     * @return Boolean Ṽvg^Cvkthis݂邩ǂ
     * @explanation <p>Ṽvg^CvIuWFNgċAIɎ擾AꂪthisƓłꍇtrueԂB</p>
     */
    /**
     * w̗񋓉\ȃvpeB𒼐ڎǂ𔻒肷
     * @def P
     * @name propertyIsEnumerable
     * @type Function
     * @param V String|Object vpeB̖Oi񉻂j
     * @return Boolean VŎw肳ꂽvpeBthisڎA񋓉\ǂ
     * @explanation <p>̃\bh̎sthisVŗ^ꂽvpeB̃vpeBǂB
     *   ̂ƂAthis̃vg^Cv`F[͍lꂸAthisڎvpeBΏۂƂȂB
     *   ɂ̃vpeB<kbd>for-in</kbd>\ɂė񋓉\łꍇɂ̂trueԂB</p>
     */
    /**
     * ObjectRXgN^
     * @def c
     * @name Object
     * @type Function
     * @param value [Object] ƂȂIuWFNg
     * @return Object IuWFNg
     * @explanation <p>valuelCeBuECMAScriptIuWFNgȂ΁Â܂valueԂB
     *   zXgIuWFNgȂ΁AzXgɂˑ̕@ŌʂԂB
     *   Boolean^܂Number^܂String^Ȃ΁AIuWFNgĕԂB
     *   ȊȌꍇ́AVKObjectIuWFNg𐶐ĕԂB</p>
     */
    // _~[JSD[܂]
    // RXgN^
    return Object;
    });
  
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - Function
    * @param Super [Function|null] X[p[NX
    * @return Function FunctionNX
    * 
    * @explanation <p>ECMAScriptɂ֐͑SẴNX̃CX^XłB
    *   ̃NXɑ΂钼ڂ̕ύX͑SĂ̊֐ɑ΂ĉeyڂ\B</p>
    * @example <p>֐iFunctionIuWFNgjFunctionRXgN^gpƂAeŋLq@B</p>
    *   <p>֐`F<kbd>function ֐ ( Xg ) { ֐\[X }</kbd>́A
    *   ̒`܂ރXR[ṽ\[XiO[oXR[vȂ΃\[XŚC֐Ȃ֐́jsꂽƂA
    *   ŏ̍s̎sOi\[X̉͂͌jɊ֐̂QƉ\ȏԂƂďĂB</p>
    *   <pre><code>
    *   var ans1 = calc(-4, 15);  // 11
    *   var ans2 = calc2(10, 6);  // 60 (16ł͂Ȃ)
    *   
    *   function calc(x, y) {
    *     return x + y;
    *   }
    *   
    *   function calc2(x, y) {
    *     
    *     return calc(x, y);
    *     
    *     function calc(x, y) {
    *       return x * y;
    *     }
    *   }
    *   </code></pre>
    *   <p>֐\LF<kbd>function ( Xg ) { ֐\[X }</kbd>́Â̕֐eƂĎQƂ^B
    *   ̕ۂɎsƂɊ֐̎QƂ^AϐɑÅ֐̈ɂAN[WƂĎs肵ĎgpB</p>
    *   <pre><code>
    *   // ϐ
    *   var ans1 = func(3);  // G[(ϐfuncɊ֐̎QƂ͂܂ĂȂ)
    *   
    *   var func = function(n) {
    *     return 2 * n * n;
    *   };
    *   
    *   var ans2 = func(3);  // 18
    *   </code></pre>
    *   <pre><code>
    *   // ̊֐̈ɂ
    *   var target = ["a", "b", "c"];
    *   var answer = [];
    *   
    *   visit(target, function(element) {
    *     answer[answer.length] = element.charCodeAt(0);
    *   });
    *   
    *   // ̎_ answer  [97, 98, 99] ƂȂĂB
    *   
    *   function visit(list, visiter) {
    *     for(var i = 0; i < list.length; i++) {
    *       visiter(list[i]);
    *     }
    *   }
    *   </code></pre>
    *   <pre><code>
    *   // N[W
    *   var ans = (function() {
    *     var sum = 0;
    *     for(var i = 0; i < arguments.length; i++) {
    *       sum += arguments[i];
    *     }
    *     return sum;
    *   })(1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
    *   
    *   // ̎_ ans  55 ƂȂĂB
    *   </code></pre>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "Function";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    Function.Super = Object;
    // _~[JSD[]
    /**
     * FunctionRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation <p>FunctionRXgN^FunctionIuWFNgł̂ŁA
     *   FunctionIuWFNgiFunctionCX^XjŗL̃vpeB<var>length</var>̎łB</p>
     */
    /**
     * Functionvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Object
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation <p>FunctionRXgN^FunctionIuWFNgł̂ŁA
     *   FunctionIuWFNgiFunctionCX^XjŗL̃vpeB<var>prototype</var>̎łB
     *   ilFunctionvg^CvIuWFNgj</p>
     */
    //:P constructor Function FunctionRXgN^
    /**
     * ֐̕\擾
     * @def P
     * @name toString
     * @type Function
     * @this Function thislFunctionIuWFNgłȂ΂ȂȂB
     * @return String ̊֐̕\
     * @throw TypeError sthislFunctionIuWFNgłȂꍇ
     * @notice <p>Ԃe͊֐\[XƂĂECMAScript̍\͖AȊO͎ˑłB
     *   ܂A󔒕CsCZ~RCRgɂĂ̓zXgɂقȂ錋ʂƂȂ邱ƂB</p>
     */
    /**
     * thislw肵Ċ֐s
     * @def P
     * @name apply
     * @type Function
     * @this Function thislFunctionIuWFNgłȂ΂ȂȂB
     * @param thisArg [Object|null] s֐thislƂIuWFNg
     * @param argArray [Array|Object|null] s֐̈(z܂argumentsIuWFNg܂null)
     * @return Object|null|undefined s֐̖߂l
     * @throw TypeError sthislFunctionIuWFNgłȂꍇ
     * @throw TypeError argArrayArray^łargumentsIuWFNgłnullł`łȂꍇ
     * @explanation <p>apply֐̎sthislFunctionIuWFNgłB
     *   FunctionIuWFNgAthisArgthislƂāAargArrayƂĎsB
     *   thisArgnull܂͖`̏ꍇAthislƂăO[oIuWFNgnB
     *   argArraynull܂͖`̏ꍇAFunctionIuWFNg͈ȂŎsB</p>
     */
    /**
     * thislw肵Ċ֐s
     * @def P
     * @name call
     * @type Function
     * @this Function thislFunctionIuWFNgłȂ΂ȂȂB
     * @param thisArg [Object|null] s֐thislƂIuWFNg
     * @params [Object|null] s֐̈
     * @return Object|null|undefined s֐̖߂l
     * @throw TypeError sthislFunctionIuWFNgłȂꍇ
     * @explanation <p>apply֐̎sthislFunctionIuWFNgłB
     *   FunctionIuWFNgAthisArgthislƂāAargArrayƂĎsB
     *   thisArgnull܂͖`̏ꍇAthislƂăO[oIuWFNgnB</p>
     */
    /**
     * FunctionRXgN^
     * @def c
     * @name Function
     * @type Function
     * @params [String] 
     * @param body [String] ei\[XR[hj
     * @return Function V֐
     * @throw SyntaxError ƂĎw肳ꂽ̒lAV֐̈Ƃĉߕs\ȏꍇ
     * @throw SyntaxError eƂĎw肳ꂽbody̒lAV֐̏eƂĉߕs\ȏꍇ
     * @notice XR[v`F[̓O[oIuWFNg^B
     * @example m̈͌ʂɗ^ĂA,(J})؂ŗ^Ă悢B
     *   ႦΈȉ̂R͂ǂʂ^B
     *   <pre><code>
     *   new Function("a", "b", "c", "return a+b+c");
     *   new Function("a, b, c", "return a+b+c");
     *   new Function("a, b", "c", "return a+b+c");
     *   </code></pre>
     */
    //:i length Number {DontEnum, DontDelete, ReadOnly} ꂼ̊֐iFunctionIuWFNgj̉̐
    /**
     * ꂼ̊֐iFunctionIuWFNgj̃vg^CvIuWFNg
     * @def i
     * @name prototype
     * @type Object
     * @attrib DontDelete
     * @notice <p>̊֐iFunctionIuWFNgjRXgN^ƂĐ
     *   VIuWFNg̓Iȃvg^CvIuWFNg̐ɎgpB
     *   ܂AIuWFNgɂ<var>prototype</var>vpeB̂ύXĂ
     *   ɐꂽCX^X̃vg^Cv`F[tւ邱Ƃ͂łȂB</p>
     */
    // _~[JSD[܂]
    // RXgN^
    return Function;
    });
  
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - Boolean
    * @param Super [Function|null] X[p[NX
    * @return Function BooleanNX
    * 
    * @explanation <p>̃NXECMAScriptɂu[Ai^Uj𐶐B
    *   u[Aɂ͓ނAPBooleanli΁uv~eBuBoolean^vj<kbd>typeof u[A</kbd><samp>"boolean"</samp>ƂȂB
    *   ЕBooleanIuWFNgi΁uBooleañbp[IuWFNgvj<kbd>typeof u[A</kbd><samp>"object"</samp>^B
    *   ECMAScriptɂẮAƂIuWFNgłÃNX̃CX^Xł邱Ƃ͕ς͂ȂB</p>
    *   <p>BooleanlBooleanIuWFNg̈Ⴂ́AEl̔ɂČƂȂB
    *   <table border="1" cellspacing="0">
    *     <caption>BooleanlBooleanIuWFNg̔riStrue܂͑Sfalsȅꍇj</caption>
    *     <thead>
    *       <tr style="background-color:#DDFFEE;">
    *         <th>rΏ</th>
    *         <th>==</th>
    *         <th>===</th>
    *       </tr>
    *     </thead>
    *     <tbody>
    *       <tr>
    *         <td>BooleanlBooleanl</td>
    *         <td>true</td>
    *         <td>true</td>
    *       </tr>
    *       <tr>
    *         <td>BooleanlBooleanIuWFNg</td>
    *         <td>true</td>
    *         <td>false</td>
    *       </tr>
    *       <tr>
    *         <td>BooleanIuWFNgǂiIuWFNgj</td>
    *         <td>true</td>
    *         <td>true</td>
    *       </tr>
    *       <tr>
    *         <td>BooleanIuWFNgǂiقȂIuWFNgj</td>
    *         <td>false</td>
    *         <td>false</td>
    *       </tr>
    *     </tbody>
    *   </table></p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "Boolean";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    Boolean.Super = Object;
    // _~[JSD[]
    /**
     * BooleanRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Booleanvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Boolean
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation <p><var>Boolean.prototype</var>͂ꎩgBooleanIuWFNgŁAlfalsełB</p>
     */
    //:P constructor Function BooleanRXgN^
    /**
     * Boolean̕\擾
     * @def P
     * @name toString
     * @type Function
     * @this Boolean thisl̓v~eBuBoolean^܂BooleanIuWFNgłȂ΂ȂȂB
     * @return String "true"܂"false"
     * @throw TypeError sthislv~eBuBoolean^łBooleanIuWFNgłȂꍇ
     */
    /**
     * Booleanl擾
     * @def P
     * @name valueOf
     * @type Function
     * @this Boolean thisl̓v~eBuBoolean^܂BooleanIuWFNgłȂ΂ȂȂB
     * @return Boolean thisl̎Booleanliv~eBuBoolean^j
     * @throw TypeError sthislv~eBuBoolean^łBooleanIuWFNgłȂꍇ
     */
    /**
     * BooleanRXgN^
     * @def c
     * @name Boolean
     * @type Function
     * @param value Object u[A̔f
     * @return Boolean BooleanIuWFNg܂Booleanliv~eBuBoolean^j
     * @explanation <p>RXgN^ƂĎsꂽꍇAvalueɐBooleanIuWFNgԂB
     *   ֐ƂĎsꂽꍇAvalueϊꂽBooleanliv~eBuBoolean^jԂB</p>
     */
    // _~[JSD[܂]
    // RXgN^
    return Boolean;
    });
  
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - Number
    * @param Super [Function|null] X[p[NX
    * @return Function NumberNX
    * 
    * @explanation <p>̃NXECMAScriptɂio[ij𐶐B
    *   io[ɂ͓ނAP͐li΁uv~eBuNumber^vjŁA<kbd>typeof io[</kbd><samp>"number"</samp>ƂȂB
    *   ЕNumberIuWFNgi΁uNumber̃bp[IuWFNgvjŁA<kbd>typeof io[</kbd><samp>"object"</samp>^B
    *   ECMAScriptɂẮAƂIuWFNgłÃNX̃CX^Xł邱Ƃ͕ς͂ȂB</p>
    *   <p>lNumberIuWFNg̈Ⴂ́AEl̔ɂČƂȂB
    *   <table border="1" cellspacing="0">
    *     <caption>lNumberIuWFNg̔riSē̏ꍇj</caption>
    *     <thead>
    *       <tr style="background-color:#DDFFEE;">
    *         <th>rΏ</th>
    *         <th>==</th>
    *         <th>===</th>
    *       </tr>
    *     </thead>
    *     <tbody>
    *       <tr>
    *         <td>lƐl</td>
    *         <td>true</td>
    *         <td>true</td>
    *       </tr>
    *       <tr>
    *         <td>lNumberIuWFNg</td>
    *         <td>true</td>
    *         <td>false</td>
    *       </tr>
    *       <tr>
    *         <td>NumberIuWFNgǂiIuWFNgj</td>
    *         <td>true</td>
    *         <td>true</td>
    *       </tr>
    *       <tr>
    *         <td>NumberIuWFNgǂiقȂIuWFNgj</td>
    *         <td>false</td>
    *         <td>false</td>
    *       </tr>
    *     </tbody>
    *   </table></p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "Number";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    Number.Super = Object;
    // _~[JSD[]
    /**
     * NumberRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Number^̗̐L̍ől
     * @def C
     * @name MAX_VALUE
     * @type Number
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation 悻<samp>1.7976931348623157~10<sup>308</sup></samp>łB
     */
    /**
     * Number^̐̍ŏl
     * @def C
     * @name MIN_VALUE
     * @type Number
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation 悻<samp>5~10<sup>-324</sup></samp>łB
     */
    //:C POSITIVE_INFINITY Number {DontEnum, DontDelete, ReadOnly} ̖
    //:C NEGATIVE_INFINITY Number {DontEnum, DontDelete, ReadOnly} ̖
    /**
     * NaNl
     * @def C
     * @name NaN
     * @type Number
     * @value NaN
     * @attrib DontEnum, DontDelete, ReadOnly
     * @notice <p>NaNlǂ̔Ɏgp邱Ƃ͂łȂB
     *   iNaNlǂ̔ɂ<var>isNaN()</var>\bhgpȂΐrʂ͓ȂBj</p>
     */
    /**
     * Numbervg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Number
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation <p><var>Number.prototype</var>͂ꎩgNumberIuWFNgŁAl+0łB</p>
     */
    //:P constructor Function NumberRXgN^
    /**
     * ̐w肵ŕ\擾
     * @def P
     * @name toString
     * @type Function
     * @this Number thisl̓v~eBuNumber^܂NumberIuWFNgłȂ΂ȂȂB
     * @param radix [Number] 
     * @return String thislradixƂĕ\
     * @throw TypeError sthislv~eBuNumber^łNumberIuWFNgłȂꍇ
     * @explanation <p>radix10܂͖`ł΁Athisl̐̂܂ܕƂĕԂB
     *   radix10236܂ł̐Ȃ΁AԂ镶͎ˑ̌ʂƂȂB</p>
     */
    /**
     * ̐s̃P[ɏ]\`̕Ŏ擾
     * @def P
     * @name toString
     * @type Function
     * @return String sizXgǰ݂̃P[ɏ]\`pthisl\
     */
    /**
     * l擾
     * @def P
     * @name valueOf
     * @type Function
     * @this Number thisl̓v~eBuNumber^܂NumberIuWFNgłȂ΂ȂȂB
     * @return Number thisl̎Numberliv~eBuNumber^j
     * @throw TypeError sthislv~eBuNumber^łNumberIuWFNgłȂꍇ
     */
    /**
     * _ȉ̌w肵ƂĐ擾
     * @def P
     * @name toFixed
     * @type Function
     * @param fractionDigits [Number] _ȉ̌iȗ0j
     * @return String thisl̐w肳ꂽ_ȉ̌܂ŁiKvȂ0𖄂߂āj\ꂽ
     * @throw RangeError fractionDigits̒l0܂20傫ꍇ
     */
    /**
     * _ȉ̌w肵w\L̕ƂĐ擾
     * @def P
     * @name toExponential
     * @type Function
     * @param fractionDigits [Number] w\LɂƂ̏_ȉ̌iȗ0j
     * @return String thisl̐w肳ꂽ_ȉ̌܂ŁiKvȂ0𖄂߂ājw\Lꂽ
     * @throw RangeError fractionDigits̒l0܂20傫ꍇ
     */
    /**
     * w肵iKvȂΎw\ĹjƂĐ擾
     * @def P
     * @name toPrecision
     * @type Function
     * @param precision [Number] _̂܂܂ȂŜ̌
     * @return String thisl̐w肳ꂽŕ\ꂽiKvȂΎw\Lꂽj
     * @throw RangeError precision̒l1܂21傫ꍇ
     * @notice precision`܂͏ȗꂽꍇÃ\bh͑<var>toString</var>̌ʂԂB
     */
    /**
     * NumberRXgN^
     * @def c
     * @name Number
     * @type Function
     * @param value [Object] 
     * @return Number NumberIuWFNg܂͐liv~eBuNumber^j
     * @explanation <p>RXgN^ƂĎsꂽꍇAvalue΂𐔒lɕϊ̂A
     *   Ȃ+0VNumberIuWFNg𐶐ĕԂB
     *   ֐ƂĎsꂽꍇAvalue΂𐔒lɕϊ̂AȂ+0ԂB</p>
     */
    // _~[JSD[܂]
    // RXgN^
    return Number;
    });
  
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - String
    * @param Super [Function|null] X[p[NX
    * @return Function StringNX
    * 
    * @explanation <p>̃NXECMAScriptɂXgOij𐶐B
    *   XgOɂ͓ނAP͕li΁uv~eBuString^vj<kbd>typeof XgO</kbd><samp>"string"</samp>ƂȂB
    *   ЕStringIuWFNgi΁uString̃bp[IuWFNgvj<kbd>typeof XgO</kbd><samp>"object"</samp>^B
    *   ECMAScriptɂẮAƂIuWFNgłÃNX̃CX^Xł邱Ƃ͕ς͂ȂB</p>
    *   <p>lStringIuWFNg̈Ⴂ́AEl̔ɂČƂȂB
    *   <table border="1" cellspacing="0">
    *     <caption>lStringIuWFNg̔riSēȅꍇj</caption>
    *     <thead>
    *       <tr style="background-color:#DDFFEE;">
    *         <th>rΏ</th>
    *         <th>==</th>
    *         <th>===</th>
    *       </tr>
    *     </thead>
    *     <tbody>
    *       <tr>
    *         <td>lƕl</td>
    *         <td>true</td>
    *         <td>true</td>
    *       </tr>
    *       <tr>
    *         <td>lStringIuWFNg</td>
    *         <td>true</td>
    *         <td>false</td>
    *       </tr>
    *       <tr>
    *         <td>StringIuWFNgǂiIuWFNgj</td>
    *         <td>true</td>
    *         <td>true</td>
    *       </tr>
    *       <tr>
    *         <td>StringIuWFNgǂiقȂIuWFNgj</td>
    *         <td>false</td>
    *         <td>false</td>
    *       </tr>
    *     </tbody>
    *   </table></p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "String";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    String.Super = Object;
    // _~[JSD[]
    /**
     * StringRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Stringvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type String
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation <p><var>String.prototype</var>͂ꎩgStringIuWFNgŁAl͋󕶎łB</p>
     */
    /**
     * R[h當𐶐
     * @def C
     * @name fromCharCode
     * @type Function
     * @params Number R[h
     * @return String ŕR[h^ꂽliv~eBuString^j
     * @explanation <p>̐Ɩ߂l̒̕i܂Ȃ̏ꍇ͋󕶎ԂjA
     *   ̃CfbNXƖ߂l̃̕CfbNXΉĂB</p>
     */
    //:P constructor Function StringRXgN^
    /**
     * lԂ
     * @def P
     * @name toString
     * @type Function
     * @this String thisl̓v~eBuString^܂StringIuWFNgłȂ΂ȂȂB
     * @return String liv~eBuString^j
     * @throw TypeError sthislv~eBuString^łStringIuWFNgłȂꍇ
     */
    /**
     * lԂ
     * @def P
     * @name valueOf
     * @type Function
     * @this String thisl̓v~eBuString^܂StringIuWFNgłȂ΂ȂȂB
     * @return String liv~eBuString^j
     * @throw TypeError sthislv~eBuString^łStringIuWFNgłȂꍇ
     */
    /**
     * wʒu̕擾
     * @def P
     * @name charAt
     * @type Function
     * @param pos Number 擾镶̃CfbNX
     * @return String liv~eBuString^j
     * @explanation <p>thisl̕iString^łȂΕ񉻂ĵA
     *   posŗ^ꂽCfbNX̕PԂB
     *   CfbNX͈̔͂̕ɂȂꍇ͋󕶎ԂB</p>
     */
    /**
     * wʒu̕̕R[h擾
     * @def P
     * @name charCodeAt
     * @type Function
     * @param pos Number 擾镶̃CfbNX
     * @return Number wʒu̕̕R[h
     * @explanation <p>thisl̕iString^łȂΕ񉻂ĵA
     *   posŗ^ꂽCfbNX̕̕R[hԂB
     *   CfbNX͈̔͂̕ɂȂꍇNaNԂB</p>
     */
    /**
     * O猟
     * @def P
     * @name indexOf
     * @type Function
     * @param searchString String iString^łȂΕ񉻂j
     * @param position [Number] JnCfbNXiȗ܂͖`Ȃ0Ƃj
     * @return Number ʁivCfbNX܂͕svȂ-1j
     * @explanation <p>thisl̕iString^łȂΕ񉻂jAsearchString̕A
     *   position̈ʒuiȗ܂͖`Ȃ0ƂjE֌A
     *   ŏɈv̍[̃CfbNXAv镔Ȃ-1ԂB</p>
     */
    /**
     * 猟
     * @def P
     * @name lastIndexOf
     * @type Function
     * @param searchString String iString^łȂΕ񉻂j
     * @param position [Number] JnCfbNXiȗ܂͖`Ȃthisl̕񒷂Ƃj
     * @return Number ʁivCfbNX܂͕svȂ-1j
     * @explanation <p>thisl̕iString^łȂΕ񉻂jAsearchString̕iString^łȂΕ񉻂jA
     *   position̈ʒuiȗ܂͖`Ȃthisl̕񒷂Ƃj獶֌A
     *   ŏɈv̍[̃CfbNXAv镔Ȃ-1ԂB</p>
     */
    /**
     * r
     * @def P
     * @name localeCompare
     * @type Function
     * @param that String riString^łȂΕ񉻂j
     * @return Number thisl̕ƈthat̕r
     * @explanation <p>thislyшthatɂāAꂼString^łȂΕ񉻂B
     *   thisthatP[Ɉˑ@ŏrAthisthatOɗ邩AAɗ邩ɂ
     *   ꂼꕉA0A̐lԂB</p>
     *   <p>͕̕lƂĔr̂ŁAStringIuWFNg̏ꍇł
     *   ̔rʂ͓IuWFNgǂɈˑȂB</p>
     * @notice <p>̊֐̂<var>Array.prototype.sort</var>\bḧƂ邱Ƃ͓K؂ł͂ȂB
     *   ͂̊֐͎sthislƑPr̂ɑ΂A<var>Array.prototype.sort</var>\bḧ
     *   ֐łƂɂ̊֐ɂ͑PƑQr邱Ƃ҂邽߂łB</p>
     */
    /**
     * ̕
     * @def P
     * @name concat
     * @type Function
     * @params String|Object 镶iString^łȂΕ񉻂j
     * @return String thislƈ𕶎ƂČʂ̕liv~eBuString^j
     * @explanation <p>thisl̕iString^łȂΕ񉻂jƁA
     *   SĂ̈iString^łȂΕ񉻂jԂB</p>
     */
    /**
     * w̕ŕ
     * @def P
     * @name split
     * @type Function
     * @param separator RegExp|String 镶i̖߂lɂ͂͂̕ǂɂ܂܂Ȃj
     * @param limit [Number] iȂ̂ł͂ȂAɔz񂪐؂l߂j
     * @return Array ̔̕z
     * @explanation <p>separator󕶎łꍇAthisl̕iString^łȂΕ񉻂j͂PɕB</p>
     *   <p>separatorRegExp^łꍇAK\Ƀ}b`eŕB
     *   K\󕶎̃}b`eĂꍇADIɋ󕶎}b`āA
     *   Xseparator󕶎łꍇƓlthisl͂̕PɕB
     *   p^[̒ɃO[sO܂ޏꍇ́ÃO[v̒lʒuɑ}ꂽz񂪕ԂB</p>
     */
    /**
     * ̈ꕔ؂o
     * @def P
     * @name slice
     * @type Function
     * @param start Number Jnʒu
     * @param end [Number] IʒuĩCfbNX͖̕߂lɊ܂܂Ȃj
     * @return String Jnʒu܂񂾂ȍ~AIʒu̎O܂ł̕l
     * @explanation <p>thislString^łȂΕ񉻂Bstart̐Ȃ΁A<kbd>thisl̕.length - start</kbd>ɒuB
     *   end̐Ȃ΁A<kbd>thisl̕.length - end</kbd>ɒuA`Ȃ<kbd>thisl̕.length</kbd>ɒuB</p>
     */
    /**
     * ̈ꕔ؂o
     * @def P
     * @name substring
     * @type Function
     * @param start Number Jnʒu
     * @param end [Number] IʒuĩCfbNX͖̕߂lɊ܂܂Ȃj
     * @return String Jnʒu܂񂾂ȍ~AIʒu̎O܂ł̕l
     * @explanation <p>thislString^łȂΕ񉻂Bend`Ȃthisl̕񒷂ɒuB
     *   start,endƂɁANaN܂͕̐Ȃ0ɒuA񒷂傫ȂΕ񒷂ɒuB
     *   startend傫Ȃ΁Astartend͌B</p>
     */
    /**
     * ɕϊʂ擾
     * @def P
     * @name toLowerCase
     * @type Function
     * @return String thisliString^łȂΕ񉻂ĵ啶ɕϊl
     */
    /**
     * 啶ɕϊʂ擾
     * @def P
     * @name toUpperCase
     * @type Function
     * @return String thisliString^łȂΕ񉻂ĵ啶ɕϊl
     */
    /**
     * P[Ɉˑɕϊʂ擾
     * @def P
     * @name toLocaleLowerCase
     * @type Function
     * @return String thisliString^łȂΕ񉻂ĵ啶ɁiP[Ɉˑjϊl
     */
    /**
     * P[Ɉˑ啶ɕϊʂ擾
     * @def P
     * @name toLocaleUpperCase
     * @type Function
     * @return String thisliString^łȂΕ񉻂ĵ啶ɁiP[Ɉˑjϊl
     */
    /**
     * K\Ɉv邩
     * @def P
     * @name match
     * @type Function
     * @param regexp RegExp 鐳K\IuWFNg
     * @return Array }b`̔z
     * @explanation <p>thislString^łȂΕ񉻂AregexpRegExp^łȂ<kbd>new RegExp(regexp)</kbd>̌ʂɒuB
     *   <var>RegExp.prototype.exec</var>\bhpʂL̒ʂɕԂB
     *   <dl>
     *     <dt><var>regexp.global</var><samp>false</samp>̏ꍇ</dt>
     *     <dd><p><kbd>regexp.exec(thisl̕)</kbd>̌ʂԂB</p></dd>
     *     <dt><var>regexp.global</var><samp>true</samp>̏ꍇ</dt>
     *     <dd><p>thisl̐̕擪疖܂ŁAv񐔂<kbd>regexp.exec(thisl̕)</kbd>sB
     *       ̌X̌ʂ͒1ȏ̔zł邪ǍX̌ʔz̐擪iCfbNX0́jvf݂̂W߂ĐVȔzƂArrayIuWFNgԂB</p>
     *     </dd>
     *   </dl></p>
     * @rel RegExp
     */
    /**
     * K\ŕ
     * @def P
     * @name search
     * @type Function
     * @param regexp RegExp 鐳K\IuWFNg
     * @return Number }b`̍ŏ̃̕CfbNXiȂꍇ-1j
     * @explanation <p>thislString^łȂΕ񉻂AregexpRegExp^łȂ<kbd>new RegExp(regexp)</kbd>̌ʂɒuB
     *   팟͂̐擪猟AregexpɃ}b`ŏ̕ɂČʂԂB</p>
     * @notice <p>̃\bh͈regexp<var>lastIndex</var>vpeB<var>global</var>vpeB𖳎B
     *   ܂AvpeBƂ̒lύX邱Ƃ͂ȂB</p>
     * @rel RegExp
     */
    /**
     * uʂ擾
     * @def P
     * @name replace
     * @type Function
     * @param searchValue RegExp|String ܂͂̐K\
     * @param replaceValue Function|String u܂͂Ԃ֐
     * @return String u
     * @explanation <p>thislString^łȂΕ񉻂B
     *   searchValueRegExp^łString^łȂΕ񉻂B
     *   replaceValue֐łString^łȂΕ񉻂B</p>
     *   <p>uΏۂ̌ɂĂ͈ȉ̒ʂ蓮삷B
     *   <dl>
     *     <dt>searchValueRegExp^łA<var>searchValue.global</var><samp>false</samp>łꍇ</dt>
     *     <dd><p>thisl̕ɑ΂<var>searchValue</var>ŏɃ}b`ӏAuΏۂƂB</p></dd>
     *     <dt>searchValueRegExp^łA<var>searchValue.global</var><samp>true</samp>łꍇ</dt>
     *     <dd><p>thisl̕ɑ΂<var>searchValue</var>}b`SẲӏAuΏۂƂB</p></dd>
     *     <dt>searchValueString^łꍇ</dt>
     *     <dd><p>thisl̕ɑ΂<var>searchValue</var>̍ŏ̏oӏAuΏۂƂB</p></dd>
     *   </dl></p>
     *   <p>uΏۂ̒uɂĂ͈ȉ̒ʂ蓮삷B
     *   <dl>
     *     <dt>replaceValue֐̏ꍇ</dt>
     *     <dd><p>uΏۂłeƂ<kbd>replaceValue(matchedString, *, offsetIndex, thisString)</kbd>sA
     *       ꂼ̖߂liString^łȂΕ񉻂jɒuB̂Ƃ̊eɂĂ͈ȉ̂ƂB
     *       <dl>
     *         <dt><var>matchedString</var></dt>
     *         <dd>}b`iuΏۂ́j</dd>
     *         <dt><var>*</var></dt>
     *         <dd>searchValueRegExp^̂Ƃ̊eN[vi܂<kbd>searchValue.exec(thisl̕)</kbd>̌ʔz̃CfbNX1ȍ~łj</dd>
     *         <dt><var>offsetIndex</var></dt>
     *         <dd>}b`iuΏۂ́jthisl̕ɂ擪̈ʒu</dd>
     *         <dt><var>thisString</var></dt>
     *         <dd>thisl̕i̕Śj</dd>
     *       </dl></p>
     *     </dd>
     *     <dt>replaceValueString^̏ꍇ</dt>
     *     <dd><p>uΏۂłeꂼɂāAreplaceValue̕ɒuB
     *       ̂ƂAreplaceValue̕Ɉȉ̕񂪊܂܂ꍇAuOɈreplaceValue̕񎩑̂uB
     *       <table border="1" cellspacing="0">
     *         <thead>
     *           <tr style="background-color:#FFEEDD;"><th></th><th>Ӗiuej</th></tr>
     *         </thead>
     *         <tbody>
     *           <tr><td><kbd>$$</kbd></td><td><samp>$</samp></td></tr>
     *           <tr><td><kbd>$&</kbd></td><td>}b`iuΏۂ́j</td></tr>
     *           <tr><td><kbd>$`</kbd></td><td>}b`iuΏۂ́jO̕</td></tr>
     *           <tr><td><kbd>$'</kbd></td><td>}b`iuΏۂ́j̕</td></tr>
     *           <tr><td><kbd>$n</kbd></td><td>n͂P̐1-9$nɐȂꍇŁAsearchValueRegExp^̏ꍇA}b`O[vnԖ</td></tr>
     *           <tr><td><kbd>$nn</kbd></td><td>nn͂Q̐01-99ŁAsearchValueRegExp^̏ꍇA}b`O[vnnԖ</td></tr>
     *         </tbody>
     *       </table></p>
     *     </dd>
     *   </dl></p>
     * @rel RegExp
     */
    /**
     * StringRXgN^
     * @def c
     * @name String
     * @type Function
     * @param value [Object] 
     * @return String StringIuWFNg܂͕liv~eBuString^j
     * @explanation <p>RXgN^ƂĎsꂽꍇAvalue΂𕶎lɕϊ̂A
     *   Ȃ΋󕶎VStringIuWFNg𐶐ĕԂB
     *   ֐ƂĎsꂽꍇAvalue΂𕶎lɕϊ̂AȂ΋󕶎ԂB</p>
     */
    //:i length Number {DontEnum, DontDelete, ReadOnly} ̕̕
    // _~[JSD[܂]
    // RXgN^
    return String;
    });
  
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - Array
    * @param Super [Function|null] X[p[NX
    * @return Function ArrayNX
    * 
    * @explanation <p>̃NXECMAScriptɂz\NXłB
    *   z̗vfɂ͂Ȃl݂邱Ƃ\łB
    *   ܂Az̃TCY<var>length</var>vpeB̒l͏ɓĂB</p>
    * @example <p>ObjectIuWFNg̓RXgN^gpƂAeŋLq@B
    *   <kbd>[vf1, vf2, vf3, ...]</kbd>ƋLq΂悢B</p>
    *   <p>ȉɁAvf14uStartvCnullCl3.14CfalsełzeŋLqB</p>
    *   <pre><code>
    *   var list = ["Start", null, 3.14, false];
    *   </code></pre>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "Array";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    Array.Super = Object;
    // _~[JSD[]
    /**
     * ArrayRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Arrayvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Array
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation ̔zł邪ACX^XŗL<var>valueOf</var>\bh͎<var>Object.prototype.valueOf</var>\bhpĂB
     */
    //:P constructor Function ArrayRXgN^
    /**
     * z̕\擾
     * @def P
     * @name toString
     * @type Function
     * @this Array thislArray^łȂ΂ȂȂB
     * @return String z̕\
     * @throw TypeError sthislArray^łȂꍇ
     * @explanation <p><var>Array.prototype.join</var>\bhȂŎsꍇƓʂԂB</p>
     */
    /**
     * P[Ɉˑz̕\擾
     * @def P
     * @name toLocaleString
     * @type Function
     * @this Array thislArray^łȂ΂ȂȂB
     * @return String P[Ɉˑz̕\
     * @throw TypeError sthislArray^łȂꍇ
     */
    /**
     * w̕ŗvfȂ𐶐
     * @def P
     * @name join
     * @type Function
     * @param separator [String] ؂蕶iȗ,j
     * @return String ؂蕶Ŋevfi𕶎񉻂́jȂl
     */
    /**
     * ̗vfo
     * @def P
     * @name pop
     * @type Function
     * @return Object|undefined ̗vf
     * @explanation <p>̃CX^X<var>length</var>vpeB̒lIɕύXB</p>
     */
    /**
     * ɗvfǉ
     * @def P
     * @name push
     * @type Function
     * @params [Object] ǉvfiPP̗vfƂĒǉj
     * @return Number ǉ̂̃CX^XlengthvpeB̒l
     * @explanation <p>̃CX^X<var>length</var>vpeB̒lIɕύXB</p>
     */
    /**
     * 擪̗vfo
     * @def P
     * @name shift
     * @type Function
     * @return Object|undefined 擪̗vf
     * @explanation <p>̃CX^X<var>length</var>vpeB̒lIɕύXB</p>
     */
    /**
     * 擪ɗvf}
     * @def P
     * @name unshift
     * @type Function
     * @params [Object] }vfiPP̗vfƂĒǉj
     * @return Number }̂̃CX^XlengthvpeB̒l
     * @explanation <p>̃CX^X<var>length</var>vpeB̒lIɕύXB</p>
     */
    /**
     * z̗vfu
     * @def P
     * @name splice
     * @type Function
     * @param start Number uΏ۔͈͂̊JnʒuĩCfbNX̗vfuΏ۔͈͂ƂȂj
     * @param deleteCount Number uΏۗvf̌
     * @params [Object] uVvfiKdeleteCountƓłKv͂Ȃj
     * @return Array uɂĎ菜ꂽÂvf̔ziTCYdeleteCountƓj
     * @notice <p>̃\bhthisl̔z𒼐ڒuAuɂĎoVȔzƂĕԂB</p>
     */
    /**
     * vf̏𔽓]
     * @def P
     * @name reverse
     * @type Function
     * @return Array thisl
     * @notice <p>̃\bhthisl̃IuWFNĝ̗vfבւB</p>
     */
    /**
     * z\[g
     * @def P
     * @name sort
     * @type Function
     * @param comparefn [Function] r֐
     * @return Array thisl
     * @explanation <p>comparefn֐̏ꍇÅ֐͂Q̈xyiƂz̗vfj^ĎsB
     *   ̊֐<kbd>x &lt; y</kbd>ȂΕ̐A<kbd>x = y</kbd>Ȃ0A<kbd>x &gt; y</kbd>Ȃΐ̐ԂKvB
     *   i̊֐́ȀւΌʂ]AƂƂ͂̏ɂ炸0ԂׂłBj</p>
     * @notice <p>\[g͕KIł͂ȂBi܂AƔrꂽvf̏ŎcƂ͌ȂBj</p>
     */
    /**
     * thislƑSĂ̈VȔz𐶐
     * @def P
     * @name concat
     * @type Function
     * @params [Array|Object] z
     * @return Array thislƑSĂ̈VȔz
     * @explanation <p>VArrayIuWFNgpӂAthislƑSĂ̔zɂďԂɂꂼA
     *   Array^ȂΊevfɂĂ̒liIuWFNg͂̎QƁjRs[A
     *   ȊOȂΕ񉻂ĂP̗vfƂĒǉB</p>
     * @notice <p>thisl̔zɑ΂ǉł͂ȂAVȔziArrayIuWFNgjĕԂB</p>
     */
    /**
     * z̈ꕔVȔzŎ擾
     * @def P
     * @name slice
     * @type Function
     * @param start Number Jnʒu
     * @param end [Number] IʒuĩCfbNX̗vf͖߂lɊ܂܂Ȃj
     * @return String Jnʒu܂񂾂ȍ~AIʒu̎O܂ł̗vfō\ꂽVȔz
     * @explanation <p>start̐Ȃ΁A<kbd>thisl̔z.length - start</kbd>ɒuB
     *   end̐Ȃ΁A<kbd>thisl̔z.length - end</kbd>ɒuA`Ȃ<kbd>thisl̔z.length</kbd>ɒuB</p>
     */
    /**
     * ArrayRXgN^
     * @def c
     * @name Array
     * @type Function
     * @params [Object] z̗vf
     * @return Array Vz
     * @throw RangeError B̈v~eBuNumber^łA̒l0܂͐̐łȂꍇ
     * @explanation <p>B̈liv~eBuNumber^jłꍇɌA
     *   ̒lz̃TCYƂĐVz𐶐ĕԂBîƂvf͑SĖ`ƂȂBj</p>
     */
    //:i length Number {DontEnum, DontDelete} z̃TCYivf̍ő̃CfbNX1傫lj
    // _~[JSD[܂]
    // RXgN^
    return Array;
    });
  
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - RegExp
    * @param Super [Function|null] X[p[NX
    * @return Function RegExpNX
    * 
    * @explanation <p>̃NXECMAScriptɂ鐳K\\NXłB</p>
    * @example <p>RegExpIuWFNg̓RXgN^gpƂAeŋLq@B
    *   <kbd>/K\p^[/IvV</kbd>ƋLq΂悢B
    *   ł́uK\p^[vƂ́AECMAScript(JavaScript)Ŏgp\ȕ@ɊÂK\łB
    *   ܂uIvVvƂ́A<samp>g</samp>iO[o}b`jC<samp>i</samp>i啶̖jC<samp>m</samp>isƂ̃}b`jCӂŎw肷B</p>
    *   <p>ȉɁAK\u^\d{4}/\d{1,2}/\d{1,2}$veŋLqB</p>
    *   <pre><code>
    *   var pattern = /^\d{4}\/\d{1,2}\/\d{1,2}$/;
    *   </code></pre>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "RegExp";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    RegExp.Super = Object;
    // _~[JSD[]
    /**
     * RegExpRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 2
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * RegExpvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Object
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function RegExpRXgN^
    /**
     * K\IuWFNg̕\擾
     * @def P
     * @name toString
     * @type Function
     * @this RegExp thislRegExp^łȂ΂ȂȂB
     * @return String K\eŃ\[XR[hɋLqꍇ̋L@̕
     * @throw TypeError sthislRegExp^łȂꍇ
     * @notice ̃IuWFNg𐶐Ƃ̃\[XƂ́A|ł邪SƂ͌ȂB
     */
    /**
     * K\̃}b`Os
     * @def P
     * @name exec
     * @type Function
     * @param string String Ώە
     * @return Array|null }b`ʂ̔zi}b`ȂꍇnullԂj
     * @explanation <p>̃\bh}b`ꍇɕԂźA
     *   CfbNX0̒l̓}b`Ŝ̕lłB
     *   K\p^[̒ɃO[sOꍇ́A
     *   ꂼɈv镔񂪏ԂɃCfbNX1ȍ~ɒǉB</p>
     */
    /**
     * K\}b`O邩肷
     * @def P
     * @name test
     * @type Function
     * @param string String Ώە
     * @return Boolean }b`邩ǂ
     * @explanation <p>̃\bh<kbd>RegExpIuWFNg.exec(string) != null</kbd>ƓlłB
     *   ܂A̐K\IuWFNgO[o}b`łꍇAvpeB<var>lastIndex</var>
     *   test\bhłexec\bhƓlɈړ邱ƂB</p>
     */
    /**
     * RegExpRXgN^
     * @def c
     * @name RegExp
     * @type Function
     * @param pattern String K\p^[
     * @param flags [String] IvV
     * @return RegExp K\IuWFNg
     * @explanation <p>IvV<samp>g</samp>,<samp>i</samp>,<samp>m</samp>CӂŎw肷B
     *   IvVSĕsv̏ꍇɂ́Aflagŝȗ邱ƂłB</p>
     * @explanation <p>̃RXgN^֐ƂĎsApatternRegExp^ňflags`̏ꍇA
     *   pattern̂ԂBȊO<kbd>new</kbd>ZqtẴRXgN^ŎsB</p>
     */
    //:i source String {DontEnum, DontDelete, ReadOnly} K\p^[\l
    //:i global Boolean {DontEnum, DontDelete, ReadOnly} O[o}b`ǂiIvVg܂ނǂj
    //:i ignoreCase Boolean {DontEnum, DontDelete, ReadOnly} 啶𖳎邩ǂiIvVi܂ނǂj
    //:i multiline Boolean {DontEnum, DontDelete, ReadOnly} sƂ̃}b`sǂiIvVm܂ނǂj
    //:i lastIndex Number {DontEnum, DontDelete} ̃}b`Jn镶ʒu
    // _~[JSD[܂]
    // RXgN^
    return RegExp;
    });
  
  //
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - Date
    * @param Super [Function|null] X[p[NX
    * @return Function DateNX
    * 
    * @explanation <p>̃NXECMAScriptɂ\NXłB
    *   1970N11000.0b(UTC)̃~bŊǗiuԒlvƌĂԁjĂB
    *   ARXgN^̈Ȃǂœ̉߂łȂꍇȂǂ́AԒlNaNƂ邱ƂB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "Date";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    Date.Super = Object;
    // _~[JSD[]
    /**
     * DateRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 7
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Datevg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Date
     * @attrib DontEnum, DontDelete, ReadOnly
     * @explanation <p>lNaNDateIuWFNg</p>
     */
    /**
     * Ɖ߂ł镶񂩂YUTCԒl擾
     * @def C
     * @name parse
     * @type Function
     * @param string String \i߂^C][͎ˑłj
     * @return Number YUTCԒl
     */
    /**
     * UTC̓w肵ĊYUTCԒl擾
     * @def C
     * @name UTC
     * @type Function
     * @param year Number N(UTC)
     * @param month Number (UTC)iۂ̌1Ȃlj
     * @param date [Number] (UTC)
     * @param houres [Number] (UTC)i24Ԑj
     * @param minutes [Number] (UTC)
     * @param seconds [Number] b(UTC)
     * @param ms [Number] ~b(UTC)i1b=1000~bj
     * @return Number YUTCԒl
     */
    //:P constructor Function DateRXgN^
    /**
     * ̕\擾
     * @def P
     * @name toString
     * @type Function
     * @return String ̕\
     * @explanation <p>̃\bhԂl݂͌̃^C][ł̂A\@͎ˑłB</p>
     * @explanation <p>̃\bh̖߂l<var>Date.prototype.parse</var>\bḧɂĎsꍇA
     *   ƂēlwIuWFNgԂ悤ɎĂ͂łB</p>
     */
    /**
     * (UTC)̕\擾
     * @def P
     * @name toUTCString
     * @type Function
     * @return String (UTC)̕\
     * @explanation <p>̃\bhԂlUTCɕϊ̂A\@͎ˑłB</p>
     */
    /**
     * t̕\擾
     * @def P
     * @name toDateString
     * @type Function
     * @return String t̕\
     * @explanation <p>̃\bhԂl݂͌̃^C][ł̂A\@͎ˑłB</p>
     */
    /**
     * ̕\擾
     * @def P
     * @name toTimeString
     * @type Function
     * @return String ̕\
     * @explanation <p>̃\bhԂl݂͌̃^C][ł̂A\@͎ˑłB</p>
     */
    /**
     * ݂̃^C][ł̓̕\擾
     * @def P
     * @name toLocaleString
     * @type Function
     * @return String sɂ錻݂̃^C][ł̓̕\
     * @explanation <p>̃\bhԂl݂͌̃^C][ł̂A\@݂͌̃P[ɍ킹̂łB</p>
     */
    /**
     * ݂̃^C][ł̓t̕\擾
     * @def P
     * @name toLocaleDateString
     * @type Function
     * @return String sɂ錻݂̃^C][ł̓t̕\
     * @explanation <p>̃\bhԂl݂͌̃^C][ł̂A\@݂͌̃P[ɍ킹̂łB</p>
     */
    /**
     * ݂̃^C][ł̎̕\擾
     * @def P
     * @name toLocaleTimeString
     * @type Function
     * @return String sɂ錻݂̃^C][ł̎̕\
     * @explanation <p>̃\bhԂl݂͌̃^C][ł̂A\@݂͌̃P[ɍ킹̂łB</p>
     */
    /**
     * IuWFNg̎ԒlԂ
     * @def P
     * @name valueOf
     * @type Function
     * @return Number ̃IuWFNg̎Ԓlł鐔l
     */
    /**
     * 1970N11(UTC)̃~bi=ԒljԂ
     * @def P
     * @name getTime
     * @type Function
     * @this Date thislDate^łȂ΂ȂȂB
     * @return Number 1970N11(UTC)̃~bi=̃IuWFNg̎Ԓlj
     * @throw TypeError sthislDate^łȂꍇ
     */
    /**
     * NԂ
     * @def P
     * @name getFullYear
     * @type Function
     * @return Number Nĩ݂^C][j
     */
    /**
     * Ԃ
     * @def P
     * @name getMonth
     * @type Function
     * @return Number ĩ݂^C][j
     * @notice ۂ̌1ȂlԂB
     */
    /**
     * Ԃ
     * @def P
     * @name getDate
     * @type Function
     * @return Number ĩ݂^C][j
     */
    /**
     * jԂ
     * @def P
     * @name getDay
     * @type Function
     * @return Number jĩ݂^C][j
     * @explanation ߂l̐ĺA06ꂼjyj\B
     */
    /**
     * Ԃ
     * @def P
     * @name getHours
     * @type Function
     * @return Number ĩ݂^C][j
     */
    /**
     * Ԃ
     * @def P
     * @name getMinutes
     * @type Function
     * @return Number ĩ݂^C][j
     */
    /**
     * bԂ
     * @def P
     * @name getSeconds
     * @type Function
     * @return Number bĩ݂^C][j
     */
    /**
     * ~bԂ
     * @def P
     * @name getMilliseconds
     * @type Function
     * @return Number ~bĩ݂^C][j
     */
    /**
     * ݂̃^C][Ԃ
     * @def P
     * @name getTimezoneOffset
     * @type Function
     * @return Number ݂̃^C][inUTCƂ̍𕪂ɊŹj
     */
    /**
     * N(UTC)Ԃ
     * @def P
     * @name getFullYear
     * @type Function
     * @return Number N(UTC)
     */
    /**
     * (UTC)Ԃ
     * @def P
     * @name getMonth
     * @type Function
     * @return Number (UTC)
     * @notice ۂ̌1ȂlԂB
     */
    /**
     * (UTC)Ԃ
     * @def P
     * @name getDate
     * @type Function
     * @return Number (UTC)
     */
    /**
     * j(UTC)Ԃ
     * @def P
     * @name getDay
     * @type Function
     * @return Number j(UTC)
     * @explanation ߂l̐ĺA06ꂼjyj\B
     */
    /**
     * (UTC)Ԃ
     * @def P
     * @name getHours
     * @type Function
     * @return Number (UTC)
     */
    /**
     * (UTC)Ԃ
     * @def P
     * @name getMinutes
     * @type Function
     * @return Number (UTC)
     */
    /**
     * b(UTC)Ԃ
     * @def P
     * @name getSeconds
     * @type Function
     * @return Number b(UTC)
     */
    /**
     * ~b(UTC)Ԃ
     * @def P
     * @name getMilliseconds
     * @type Function
     * @return Number ~b(UTC)
     */
    /**
     * 1970N11(UTC)̃~bi=Ԓljݒ肷
     * @def P
     * @name setTime
     * @type Function
     * @this Date thislDate^łȂ΂ȂȂB
     * @param time Number 1970N11(UTC)̃~bi=̃IuWFNg̎Ԓlj
     * @throw TypeError sthislDate^łȂꍇ
     */
    /**
     * Nݒ肷
     * @def P
     * @name setFullYear
     * @type Function
     * @param year Number Nĩ݂^C][j
     * @param month [Number] ĩ݂^C][j
     * @param date [Number] ĩ݂^C][j
     * @notice monthw肷ꍇ́Aۂ̌1ȂlnB
     */
    /**
     * ݒ肷
     * @def P
     * @name setMonth
     * @type Function
     * @param month Number ĩ݂^C][j
     * @param date [Number] ĩ݂^C][j
     * @notice monthɂ͎ۂ̌1ȂlnB
     */
    /**
     * ݒ肷
     * @def P
     * @name setDate
     * @type Function
     * @param date Number ĩ݂^C][j
     */
    /**
     * ݒ肷
     * @def P
     * @name setHours
     * @type Function
     * @param hour Number ĩ݂^C][j
     * @param min [Number] ĩ݂^C][j
     * @param sec [Number] bĩ݂^C][j
     * @param ms [Number] ~bĩ݂^C][j
     */
    /**
     * ݒ肷
     * @def P
     * @name setMinutes
     * @type Function
     * @param min Number ĩ݂^C][j
     * @param sec [Number] bĩ݂^C][j
     * @param ms [Number] ~bĩ݂^C][j
     */
    /**
     * bݒ肷
     * @def P
     * @name setSeconds
     * @type Function
     * @param sec Number bĩ݂^C][j
     * @param ms [Number] ~bĩ݂^C][j
     */
    /**
     * ~bݒ肷
     * @def P
     * @name setMilliseconds
     * @type Function
     * @param ms Number ~bĩ݂^C][j
     */
    /**
     * N(UTC)ݒ肷
     * @def P
     * @name setFullYear
     * @type Function
     * @param year Number N(UTC)
     * @param month [Number] (UTC)
     * @param date [Number] (UTC)
     * @notice monthw肷ꍇ́Aۂ̌1ȂlnB
     */
    /**
     * (UTC)ݒ肷
     * @def P
     * @name setMonth
     * @type Function
     * @param month Number (UTC)
     * @param date [Number] (UTC)
     * @notice monthɂ͎ۂ̌1ȂlnB
     */
    /**
     * (UTC)ݒ肷
     * @def P
     * @name setDate
     * @type Function
     * @param date Number (UTC)
     */
    /**
     * (UTC)ݒ肷
     * @def P
     * @name setHours
     * @type Function
     * @param hour Number (UTC)
     * @param min [Number] (UTC)
     * @param sec [Number] b(UTC)
     * @param ms [Number] ~b(UTC)
     */
    /**
     * (UTC)ݒ肷
     * @def P
     * @name setMinutes
     * @type Function
     * @param min Number (UTC)
     * @param sec [Number] b(UTC)
     * @param ms [Number] ~b(UTC)
     */
    /**
     * b(UTC)ݒ肷
     * @def P
     * @name setSeconds
     * @type Function
     * @param sec Number b(UTC)
     * @param ms [Number] ~b(UTC)
     */
    /**
     * ~b(UTC)ݒ肷
     * @def P
     * @name setMilliseconds
     * @type Function
     * @param ms Number ~b(UTC)
     */
    /**
     * DateRXgN^
     * @def c
     * @name Date
     * @type Function
     * @param year [Number|String] Nĩ݂^C][jA܂́iP̂Ƃɂ́jԒl(Number)\(String)
     * @param month [Number] ĩ݂^C][j
     * @param date [Number] ĩ݂^C][j
     * @param hour [Number] ĩ݂^C][j
     * @param min [Number] ĩ݂^C][j
     * @param sec [Number] bĩ݂^C][j
     * @param ms [Number] ~bĩ݂^C][j
     * @return Date|String ɂ苁߂ꂽDateIuWFNg܂͓\
     * @notice monthw肷ꍇ́Aۂ̌1ȂlnB
     * @explanation <p>̃RXgN^֐ƂĎsꂽꍇA
     *   Ŏsꂽ<kbd>(new Date(...)).toString()</kbd>Ɠʁi\ljԂB</p>
     * @explanation <p>newZqɂăRXgN^sꂽꍇ́ÄɂĈȉDateIuWFNgԂB
     *   <table border="1" cellspacing="0">
     *     <caption>̉</caption>
     *     <thead>
     *       <tr style="background-color:#FFEEDD;"><th></th><th>l</th></tr>
     *     </thead>
     *     <tbody>
     *       <tr><td>Ȃ</td><td>ݓ</td></tr>
     *       <tr><td>Pij</td><td>画f</td></tr>
     *       <tr><td>Pȋj</td><td>lłȂΐlƂAԒlƂ</td></tr>
     *       <tr><td>Qȏ</td><td>P珇ɁAyear,month,...Ƃĉ</td></tr>
     *     </tbody>
     *   </table></p>
     *   <p>݂̃P[Ƃ͈قȂ^C][œw肵ꍇ́A
     *   ͂Pŕ̒Ƀ^C][̏܂߂邩AԒlƂ邩̉ꂩ̕@ƂB
     *   ȀꍇłDateIuWFNg̃^C][݂͌̃P[̃^C][ƂȂĂB</p>
     */
    // _~[JSD[܂]
    // RXgN^
    return Date;
    });
  
  //
  Error = NativeError;  // ZpFErrorlCeBuErrorɖ߂ȂƃX[p[NX̉ɖ[vɂȂB
  //------------------------------------------------------------------------------
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - Error
    * @param Super [Function|null] X[p[NX
    * @return Function ErrorNX
    * 
    * @explanation <p>̃NXECMAScriptɂG[̊NXłB
    *   ECMAScript̃lCeBuG[͑SẴNX̃TuNX̃IuWFNgłB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "Error";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    NativeError.Super = Object;
    // _~[JSD[]
    /**
     * ErrorRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Errorvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Error
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function ErrorRXgN^
    /**
     * G[
     * @def P
     * @name name
     * @type String
     * @value "Error"
     */
    /**
     * G[bZ[W
     * @def P
     * @name message
     * @type String
     * @value il͎ˑj
     */
    /**
     * G[̕\擾
     * @def P
     * @name toString
     * @type Function
     * @return String G[i̓e͎ˑj
     */
    /**
     * ErrorRXgN^
     * @def c
     * @name Error
     * @type Function
     * @param message [String] G[bZ[W
     * @return Error ErrorIuWFNgi֐ƂĎsĂVIuWFNgԂj
     */
    // _~[JSD[܂]
    // RXgN^
    return NativeError;
    });
  //------------------------------------------------------------------------------
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - EvalError
    * @param Super [Function|null] X[p[NX
    * @return Function EvalErrorNX
    * 
    * @explanation <p>̃NXECMAScriptɂlCeBuG["EvalError"̃NXłB
    *   `ɉȂ@ŃO[o֐<var>eval</var>gpꂽƂG[łB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "EvalError";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    EvalError.Super = NativeError;
    // _~[JSD[]
    /**
     * EvalErrorRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * EvalErrorvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Error
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function EvalErrorRXgN^
    /**
     * G[
     * @def P
     * @name name
     * @type String
     * @value "EvalError"
     */
    /**
     * G[bZ[W
     * @def P
     * @name message
     * @type String
     * @value il͎ˑj
     */
    /**
     * EvalErrorRXgN^
     * @def c
     * @name EvalError
     * @type Function
     * @param message [String] G[bZ[W
     * @return EvalError EvalErrorIuWFNgi֐ƂĎsĂVIuWFNgԂj
     */
    // _~[JSD[܂]
    // RXgN^
    return EvalError;
    });
  //------------------------------------------------------------------------------
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - RangeError
    * @param Super [Function|null] X[p[NX
    * @return Function RangeErrorNX
    * 
    * @explanation <p>̃NXECMAScriptɂlCeBuG["RangeError"̃NXłB
    *   lꂽ͈͂𒴉߂ƂG[łB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "RangeError";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    RangeError.Super = NativeError;
    // _~[JSD[]
    /**
     * RangeErrorRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * RangeErrorvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Error
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function RangeErrorRXgN^
    /**
     * G[
     * @def P
     * @name name
     * @type String
     * @value "RangeError"
     */
    /**
     * G[bZ[W
     * @def P
     * @name message
     * @type String
     * @value il͎ˑj
     */
    /**
     * RangeErrorRXgN^
     * @def c
     * @name RangeError
     * @type Function
     * @param message [String] G[bZ[W
     * @return RangeError RangeErrorIuWFNgi֐ƂĎsĂVIuWFNgԂj
     */
    // _~[JSD[܂]
    // RXgN^
    return RangeError;
    });
  //------------------------------------------------------------------------------
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - ReferenceError
    * @param Super [Function|null] X[p[NX
    * @return Function ReferenceErrorNX
    * 
    * @explanation <p>̃NXECMAScriptɂlCeBuG["ReferenceError"̃NXłB
    *   sȎQƐ悪oꂽƂG[łB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "ReferenceError";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    ReferenceError.Super = NativeError;
    // _~[JSD[]
    /**
     * ReferenceErrorRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * ReferenceErrorvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Error
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function ReferenceErrorRXgN^
    /**
     * G[
     * @def P
     * @name name
     * @type String
     * @value "ReferenceError"
     */
    /**
     * G[bZ[W
     * @def P
     * @name message
     * @type String
     * @value il͎ˑj
     */
    /**
     * ReferenceErrorRXgN^
     * @def c
     * @name ReferenceError
     * @type Function
     * @param message [String] G[bZ[W
     * @return ReferenceError ReferenceErrorIuWFNgi֐ƂĎsĂVIuWFNgԂj
     */
    // _~[JSD[܂]
    // RXgN^
    return ReferenceError;
    });
  //------------------------------------------------------------------------------
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - SyntaxError
    * @param Super [Function|null] X[p[NX
    * @return Function SyntaxErrorNX
    * 
    * @explanation <p>̃NXECMAScriptɂlCeBuG["SyntaxError"̃NXłB
    *   ̓G[ƂG[łB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "SyntaxError";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    SyntaxError.Super = NativeError;
    // _~[JSD[]
    /**
     * SyntaxErrorRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * SyntaxErrorvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Error
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function SyntaxErrorRXgN^
    /**
     * G[
     * @def P
     * @name name
     * @type String
     * @value "SyntaxError"
     */
    /**
     * G[bZ[W
     * @def P
     * @name message
     * @type String
     * @value il͎ˑj
     */
    /**
     * SyntaxErrorRXgN^
     * @def c
     * @name SyntaxError
     * @type Function
     * @param message [String] G[bZ[W
     * @return SyntaxError SyntaxErrorIuWFNgi֐ƂĎsĂVIuWFNgԂj
     */
    // _~[JSD[܂]
    // RXgN^
    return SyntaxError;
    });
  //------------------------------------------------------------------------------
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - TypeError
    * @param Super [Function|null] X[p[NX
    * @return Function TypeErrorNX
    * 
    * @explanation <p>̃NXECMAScriptɂlCeBuG["TypeError"̃NXłB
    *   Zq̌^҂ꂽ̂ƈقȂ邱ƂG[łB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "TypeError";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    TypeError.Super = NativeError;
    // _~[JSD[]
    /**
     * TypeErrorRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * TypeErrorvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Error
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function TypeErrorRXgN^
    /**
     * G[
     * @def P
     * @name name
     * @type String
     * @value "TypeError"
     */
    /**
     * G[bZ[W
     * @def P
     * @name message
     * @type String
     * @value il͎ˑj
     */
    /**
     * TypeErrorRXgN^
     * @def c
     * @name TypeError
     * @type Function
     * @param message [String] G[bZ[W
     * @return TypeError TypeErrorIuWFNgi֐ƂĎsĂVIuWFNgԂj
     */
    // _~[JSD[܂]
    // RXgN^
    return TypeError;
    });
  //------------------------------------------------------------------------------
  Class.create(function(Super)
   /**
    * ECMAScriptlCeBuNX - URIError
    * @param Super [Function|null] X[p[NX
    * @return Function URIErrorNX
    * 
    * @explanation <p>̃NXECMAScriptɂlCeBuG["URIError"̃NXłB
    *   O[oURInhO֐̈A`ɉȂ@ŎgpꂽƂG[łB</p>
    */
    {
    // SCNX
    arguments.callee.CompleteName = "URIError";
    // _~[p
    arguments.callee.inherit(function(){}, Super);
    URIError.Super = NativeError;
    // _~[JSD[]
    /**
     * URIErrorRXgN^̉̐
     * @def C
     * @name length
     * @type Number
     * @value 1
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * URIErrorvg^CvIuWFNg
     * @def C
     * @name prototype
     * @type Error
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    //:P constructor Function URIErrorRXgN^
    /**
     * G[
     * @def P
     * @name name
     * @type String
     * @value "URIError"
     */
    /**
     * G[bZ[W
     * @def P
     * @name message
     * @type String
     * @value il͎ˑj
     */
    /**
     * URIErrorRXgN^
     * @def c
     * @name URIError
     * @type Function
     * @param message [String] G[bZ[W
     * @return URIError URIErrorIuWFNgi֐ƂĎsĂVIuWFNgԂj
     */
    // _~[JSD[܂]
    // RXgN^
    return URIError;
    });
  //------------------------------------------------------------------------------
  Error = js.cpt.Error;  // ZpFł Error = NativeError; ̖߂
  //
  })();

//##############################################################################
(function(Class)
 /**
  * NG[^[擾\bhƃNX擾\bhbvECMAScriptlCeBu̒`Ԃ悤ɕύX
  * @param Class Function js.cpt.ClassNX
  */
  {
  var getCreator = Class.getCreator;
  var getClass   = Class.getClass;
  Class.getCreator = function(completeName)
    {
    switch(completeName)
      {
      case "this":
        return Global;
      case "Math":
        return Math;
      default:
        return getCreator.apply(Class, arguments);
      }
    };
  Class.getClass = function(completeName)
    {
    switch(completeName)
      {
      case "this":
        return new Global();
      case "Math":
        return new Math();
      case "Error":
        return (Error == js.cpt.Error) ? js.cpt.Error.Super : Error;
      default:
        return getClass.apply(Class, arguments);
      }
    };
  //------------------------------------------------------------------------------
  function Global()
   /**
    * ECMAScriptlCeBuIuWFNg - Global
    * 
    * @explanation <p>ECMAScriptɂXR[v̊ƂȂO[oIuWFNgłB
    *   ̃IuWFNgɑ΂钼ڂ̕ύX͑̑SẴXR[vɑ΂ĉeyڂ\B</p>
    * @explanation <p>̃O[oIuWFNgɃANZX\ȓ̕ϐ́AECMAScriptɂĂ͊蓖ĂĂ͂ȂB
    *   is蓖Ăꍇ邪AECMAScript̎dlϐ<var>Global</var>ŕKANZXłƂ͉߂łȂBj
    *   AO[oR[hɂthislƁAthisl̎w肪ȂJnꂽ֐R[hɂthisl̓O[oIuWFNgɂȂB</p>
    * @notice <p>ECMAScript̎dlłAlXȉ̒ɂĂAO[oIuWFNg"Global"ƋLq邪A
    *   ۂɃ\[XR[hォ<kbd>this</kbd>ƂăANZXB܂Aϐ<var>Global</var>͒`\ϐ<var>this</var>͒`s\Ȃ߁A
    *   ̃O[oIuWFNg̉ł͖O"Global"ł邪AIuWFNgƂĂ"this"ƋLqĂB</p>
    */
    {
    //:I NaN Number {DontEnum, DontDelete} NaNl
    //:I Infinity Number {DontEnum, DontDelete} ̖l
    //:I undefined undefined {DontEnum, DontDelete} `l
    /**
     * \[XR[hƂĎs
     * @def I
     * @name eval
     * @type Function
     * @param x String|Variant \[XR[h
     * @return [Variant] xlłȂx́AłȂx\[XR[hƂĕ]
     * @throw SyntaxError x̒l\[XR[hƂĉ͂łȂꍇ
     * @throw EvalError ̃\bhI<var>eval</var>ƂĎsȂꍇ
     */
    /**
     * 񂩂琮lɕϊ
     * @def I
     * @name parseInt
     * @type Function
     * @param string String 񉻂ꂽl
     * @param radix [Number] ߂
     * @return Number ϊꂽl
     */
    /**
     * 񂩂珬lɕϊ
     * @def I
     * @name parseInt
     * @type Function
     * @param string String 񉻂ꂽl
     * @param radix [Number] ߂
     * @return Number ϊꂽl
     */
    /**
     * NaNǂ
     * @def I
     * @name isNaN
     * @type Function
     * @param number Number|String|Object ΏہilNaNƔrj
     * @return Boolean NaNǂ
     * @notice <p>NaNlƂ̔r<kbd>==</kbd>͊҂錋ʂԂȂB
     *   Ⴆ΁A<kbd>(NaN == NaN)</kbd>̌ʂ<samp>false</samp>łB
     *   NaNlǂ̌͂̃\bhł̂݉\łB</p>
     */
    /**
     * Lǂ
     * @def I
     * @name isFinite
     * @type Function
     * @param number Number|String|Object ΏہilNaNCƔrj
     * @return Boolean LǂiNaNł̖ł̖łȂǂj
     */
    /**
     * URIGR[h
     * @def I
     * @name encodeURI
     * @type Function
     * @param uri String ̕
     * @return String GR[hꂽ
     * @explanation <p><var>encodeURI</var>͗\񕶎<samp>;/?:@&amp;=+$,</samp><samp>#</samp>̓GR[hsȂB</p>
     */
    /**
     * URIGR[h
     * @def I
     * @name encodeURIComponent
     * @type Function
     * @param uriComponent String ̕
     * @return String GR[hꂽ
     * @explanation <p><var>encodeURIComponent</var>͗\񕶎<samp>;/?:@&amp;=+$,</samp><samp>#</samp>܂߂ăGR[hsB</p>
     */
    /**
     * URIGR[hꂽfR[h
     * @def I
     * @name decodeURI
     * @type Function
     * @param encodedURI String GR[hꂽ
     * @return String ̕
     * @explanation <p><var>decodeURI</var>͗\񕶎<samp>;/?:@&amp;=+$,</samp><samp>#</samp>GR[hĂĂfR[hsȂB</p>
     */
    /**
     * URIGR[hꂽfR[h
     * @def I
     * @name decodeURIComponent
     * @type Function
     * @param encodedURIComponent String GR[hꂽ
     * @return String ̕
     * @explanation <p><var>decodeURIComponent</var>͗\񕶎<samp>;/?:@&amp;=+$,</samp><samp>#</samp>GR[hĂ΃fR[hsB</p>
     */
    /**
     * ObjectRXgN^
     * @def I
     * @name Object
     * @type Function
     * @rel Object
     */
    /**
     * FunctionRXgN^
     * @def I
     * @name Function
     * @type Function
     * @rel Function
     */
    /**
     * BooleanRXgN^
     * @def I
     * @name Boolean
     * @type Function
     * @rel Boolean
     */
    /**
     * NumberRXgN^
     * @def I
     * @name Number
     * @type Function
     * @rel Number
     */
    /**
     * StringRXgN^
     * @def I
     * @name String
     * @type Function
     * @rel String
     */
    /**
     * ArrayRXgN^
     * @def I
     * @name Array
     * @type Function
     * @rel Array
     */
    /**
     * RegExpRXgN^
     * @def I
     * @name RegExp
     * @type Function
     * @rel RegExp
     */
    /**
     * ErrorRXgN^
     * @def I
     * @name Error
     * @type Function
     * @rel Error
     */
    /**
     * EvalErrorRXgN^
     * @def I
     * @name EvalError
     * @type Function
     * @rel EvalError
     */
    /**
     * RangeErrorRXgN^
     * @def I
     * @name RangeError
     * @type Function
     * @rel RangeError
     */
    /**
     * ReferenceErrorRXgN^
     * @def I
     * @name ReferenceError
     * @type Function
     * @rel ReferenceError
     */
    /**
     * SyntaxErrorRXgN^
     * @def I
     * @name SyntaxError
     * @type Function
     * @rel SyntaxError
     */
    /**
     * TypeErrorRXgN^
     * @def I
     * @name TypeError
     * @type Function
     * @rel TypeError
     */
    /**
     * URIErrorRXgN^
     * @def I
     * @name URIError
     * @type Function
     * @rel URIError
     */
    /**
     * MathIuWFNg
     * @def I
     * @name Math
     * @type Object
     * @rel Math
     */
    }
  //------------------------------------------------------------------------------
  function Math()
   /**
    * ECMAScriptlCeBuIuWFNg - Math
    * 
    * @explanation <p>ECMAScriptɂălCeBuŗpӂĂ鐔w֐IuWFNgłB</p>
    */
    {
    /**
     * ~
     * @def C
     * @name PI
     * @type Number
     * @value 悻 3.1415926535897932
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Rΐ̒e
     * @def C
     * @name E
     * @type Number
     * @value 悻 2.7182818284590452354
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * 2̎Rΐ
     * @def C
     * @name LN2
     * @type Number
     * @value 悻 0.6931471805599453
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * 10̎Rΐ
     * @def C
     * @name LN10
     * @type Number
     * @value 悻 2.302585092994046
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * 2ƂeiRΐ̒j̑ΐ
     * @def C
     * @name LOG2E
     * @type Number
     * @value 悻 1.4426950408889634
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * 10ƂeiRΐ̒j̑ΐ
     * @def C
     * @name LOG10E
     * @type Number
     * @value 悻 0.4342944819032518
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * 2̕
     * @def C
     * @name SQRT2
     * @type Number
     * @value 悻 1.4142135623730951
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * 1/2̕
     * @def C
     * @name SQRT1_2
     * @type Number
     * @value 悻 0.7071067811865476
     * @attrib DontEnum, DontDelete, ReadOnly
     */
    /**
     * Ԃ
     * @def C
     * @name random
     * @type Function
     * @return Number 0ȏ1̗
     */
    /**
     * őlԂ
     * @def C
     * @name max
     * @type Function
     * @params Number l
     * @return Number ̒̍ől
     */
    /**
     * ŏlԂ
     * @def C
     * @name min
     * @type Function
     * @params Number l
     * @return Number ̒̍ŏl
     */
    /**
     * ΒlԂ
     * @def C
     * @name abs
     * @type Function
     * @param x Number l
     * @return Number Βl
     */
    /**
     * _ȉ̐؂̂
     * @def C
     * @name floor
     * @type Function
     * @param x Number l
     * @return Number _ȉ؂̂Ăl
     * @notice <p>mɂ́Ax傫ȂwIƓAő́i̖ɋ߂jlԂB
     *   xɐȂ΁Aʂx̂܂܂łB</p>
     */
    /**
     * _ȉ̐؂グ
     * @def C
     * @name ceil
     * @type Function
     * @param x Number l
     * @return Number _ȉ؂グl
     * @notice <p>mɂ́Ax菬ȂwIƓAŏ́i̖ɋ߂jlԂB
     *   xɐȂ΁Aʂx̂܂܂łB</p>
     */
    /**
     * ľܓ
     * @def C
     * @name round
     * @type Function
     * @param x Number l
     * @return Number ľܓl
     * @notice <p>mɂ́Axɍł߂wIƓlԂB
     *   Q̐lxɋ߂Ȃ΁A̖ɋ߂lԂB
     *   xɐȂ΁Aʂx̂܂܂łB</p>
     */
    /**
     * w֐Ԃ
     * @def C
     * @name exp
     * @type Function
     * @param x Number l
     * @return Number Rΐ̒ex
     */
    /**
     * RΐԂ
     * @def C
     * @name log
     * @type Function
     * @param x Number l
     * @return Number x̎Rΐ
     */
    /**
     * ݏԂ
     * @def C
     * @name pow
     * @type Function
     * @param x Number l
     * @param y Number l
     * @return Number xy
     */
    /**
     * i[gjԂ
     * @def C
     * @name sqrt
     * @type Function
     * @param x Number l
     * @return Number x̕i[gxj
     */
    /**
     * TCԂ
     * @def C
     * @name sin
     * @type Function
     * @param x Number liWAj
     * @return Number TC
     */
    /**
     * RTCԂ
     * @def C
     * @name cos
     * @type Function
     * @param x Number liWAj
     * @return Number RTC
     */
    /**
     * ^WFgԂ
     * @def C
     * @name tan
     * @type Function
     * @param x Number liWAj
     * @return Number ^WFg
     */
    /**
     * A[NTCԂ
     * @def C
     * @name asin
     * @type Function
     * @param x Number l
     * @return Number A[NTCiWAj
     */
    /**
     * A[NRTCԂ
     * @def C
     * @name acos
     * @type Function
     * @param x Number l
     * @return Number A[NRTCiWAj
     */
    /**
     * A[N^WFgԂ
     * @def C
     * @name atan
     * @type Function
     * @param x Number l
     * @return Number A[N^WFgiWAj
     */
    /**
     * A[N^WFgԂ
     * @def C
     * @name atan2
     * @type Function
     * @param y Number ly
     * @param x Number lx
     * @return Number y/x̃A[N^WFgiWAj
     */
    }
  //------------------------------------------------------------------------------
  }
)(js.cpt.Class);

//##############################################################################
(function(Class)
 /**
  * `擾\bhbvECMAScriptlCeBu̒`Ԃ悤ɕύX
  * @param Class Function js.cpt.ClassNX
  */
  {
  var getDefinition = Class.getDefinition;
  Class.getDefinition = function(completeName)
    {
    switch(completeName)
      {
      case "this":
        return new Class("Global", null, null);
      case "Array":
      case "Boolean":
      case "Date":
      case "Error":
      case "Function":
      case "Math":
      case "Number":
      case "Object":
      case "RegExp":
      case "String":
      case "EvalError":
      case "RangeError":
      case "ReferenceError":
      case "SyntaxError":
      case "TypeError":
      case "URIError":
        return new Class(completeName, null, null);
      default:
        return getDefinition.apply(Class, arguments);
      }
    };
  }
)(js.cpt.Class);

//##############################################################################
(function(Package)
 /**
  * `擾\bhbvECMAScriptlCeBu̒`Ԃ悤ɕύX
  * @param Package Function js.cpt.PackageNX
  */
  {
  var getDefinition = Package.getDefinition;
  var getClassNamesByDefinition = Package.getClassNamesByDefinition;
  Package.getDefinition = function(definitionName)
    {
    switch(definitionName)
      {
      case "this":
        return ECMAScript;
      default:
        return getDefinition.apply(Package, arguments);
      }
    };
  Package.getClassNamesByDefinition = function(defineFunc)
    {
    if(defineFunc == ECMAScript)
      {
      return ["this", "Object", "Function", "Boolean", "Number", "String", "Array", "RegExp", "Date", "Error", "EvalError", "RangeError", "ReferenceError", "TypeError", "SyntaxError", "URIError", "Math"];
      }
    else
      {
      return getClassNamesByDefinition.apply(Package, arguments);
      }
    };
  //------------------------------------------------------------------------------
  function ECMAScript()
   /**
    * ECMAScriptlCeBu
    * 
    * @version 3
    * 
    * @explanation <p>̃pbP[W`ECMAScriptɂlCeBuIuWFNg[Iɒ`̂łB
    *   ̃pbP[W̒łECMAScriptlCeBuIuWFNg[IȁuNXvƂĒ`ĂB</p>
    */
    {
    }
  }
)(js.cpt.Package);

