/**
 * Cxg̐ݒ
 */
(function()
  {
  //##############################################################################
  //
  // ʒ萔
  //
  //------------------------------------------------------------------------------
  // NXpX
  var Log = js.cpt.Log;
  var Reference  = jsd.ref.Reference;
  var Path       = jsd.ref.Path;
  var File       = jsd.ref.File;
  var EventState = jsd.container.EventState;
  var TreeMenu   = jsd.container.TreeMenu;
  var SelectTree = jsd.container.SelectTree;
  var DisplayControl = jsd.container.DisplayControl;
  var ElementControl = jsd.container.ElementControl;
  var NodeControl    = jsd.container.NodeControl;
  var SelectOption   = jsd.container.SelectOption;
  var SelectBox      = jsd.container.SelectBox;
  var TextFileWriter = jsd.io.TextFileWriter;
  var WindowWriter   = jsd.io.WindowWriter;
  var XmlDocument    = jsd.xml.XmlDocument;
  var XmlNode        = jsd.xml.XmlNode;
  
  //------------------------------------------------------------------------------
  // O
  var logGui = new Log("JsdCompilerGUI");
  var logEvt = new Log("JsdCompileEvent");
  
  //------------------------------------------------------------------------------
  // ʒ萔
  
  // O[oIuWFNg
  var GLOBAL_OBJ = (function() { return this; })();
  
  // EBhE
  var WINDOW_MENU = "MENU";
  var WINDOW_TREE = "TREE";
  var WINDOW_COND = "COND";
  var WINDOW_EXEC = "EXEC";
  var WINDOW_LOGS = "LOGS";
  
  //##############################################################################
  //
  // ǗIuWFNg
  //
  //------------------------------------------------------------------------------
  // Xe[^XǗ
  
  // 
  var stateInit = new EventState();
  // S
  var stateAll = new EventState();
  // RpC
  var stateCompile = new EventState();
  // RlNV
  var stateConnect = new EventState();
  // N
  var stateLink = new EventState();
  // 
  var stateWrite = new EventState();
  // ϊ
  var stateXsl = new EventState();
  
  //------------------------------------------------------------------------------
  // NXpbP[Wc[
  
  // id
  var TREE_FRAME_ID = "TreeMenuFrame";
  // bZ[W
  var TREE_INIT_MSG = "o...";
  // c[
  var selectTree = new SelectTree("selectTree", WINDOW_TREE, TREE_FRAME_ID, TREE_INIT_MSG);
  // NbN̉WJ\bh
  function expandCheckedDown(obj)
    {
    logGui.trace("expandCheckedDown() - begin - ", obj);
    if(obj.children instanceof Array)
      {
      var isChecked = obj.isSelected();
      for(var i = 0; i < obj.children.length; i++)
        {
        var child = obj.children[i];
        if((child instanceof TreeMenu) && !child.getDisabled())
          {
          child.setSelected(isChecked);
          arguments.callee(child);
          }
        }
      }
    logGui.trace("expandCheckedDown() - end - ");
    }
  // NbN̏WJ\bh
  function expandCheckedUp(obj, base)
    {
    logGui.trace("expandCheckedUp() - begin - ", obj, base);
    if(obj == base)
      {
      logGui.trace("expandCheckedUp() - end - ", true);
      return true;
      }
    else
      {
      var containBase = false;
      if(obj.children instanceof Array)
        {
        var sumChecked = "";
        for(var i = 0; i < obj.children.length; i++)
          {
          var child = obj.children[i];
          if((child instanceof TreeMenu) && !child.getDisabled())
            {
            if(arguments.callee(child, base))
              {
              containBase = true;
              }
            sumChecked += child.isSelected();
            }
          }
        if(containBase && (obj instanceof TreeMenu))
          {
          sumChecked = (/^(?:true)+$/i).test(sumChecked);
          if(sumChecked != obj.isSelected())
            {
            obj.setSelected(sumChecked);
            }
          }
        }
      logGui.trace("expandCheckedUp() - end - ", containBase);
      return containBase;
      }
    }
  // pbP[WƃNX̒o
  selectTree.judgeMenu = function(withECMAScript)
    {
    logGui.trace("selectTree.judgeMenu() - begin - ");
    // onclick
    function onclick()
      {
      expandCheckedDown(this);
      expandCheckedUp(selectTree, this);
      rootPackage.judgeOptions();
      rootPackage.flash();
      }
    // Ώےo\bh
    function getTarget(obj, prefix)
      {
      logGui.trace("selectTree.judgeMenu().getTarget() - begin - ", obj, prefix);
      var children = [];
      for(var i in obj)
        {
        try
          {
          var menu = null;
          var name = prefix + i;
          if(((typeof obj[i]) == "function") && obj[i].Static)
            {
            menu = new TreeMenu(name, WINDOW_TREE, name, false, false, false, i, true);
            }
          else if(obj[i] instanceof js.cpt.Class)
            {
            menu = new TreeMenu(name, WINDOW_TREE, name, false, false, true, i, true);
            }
          else if(obj[i] instanceof js.cpt.Package)
            {
            menu = new TreeMenu(name, WINDOW_TREE, name, false, false, false, i, false);
            menu.children = arguments.callee(obj[i], (prefix + i + "."));
            }
          if(menu)
            {
            menu.onclick = onclick;
            children[children.length] = menu;
            }
          }
        catch(e)
          {
          // ignore.
          }
        }
      logGui.trace("selectTree.judgeMenu().getTarget() - end - ", children);
      return children;
      }
    // 񊈐WJ\bh
    function expandDisabled(obj, parentDisabled)
      {
      logGui.trace("selectTree.judgeMenu().expandDisabled() - begin - ", obj, parentDisabled);
      var isDisabled = obj.getDisabled();
      if(parentDisabled && !isDisabled)
        {
        obj.setDisabled(true);
        isDisabled = true;
        }
      if(obj.children instanceof Array)
        {
        var childDisabled = true;
        for(var i = 0; i < obj.children.length; i++)
          {
          if(!arguments.callee(obj.children[i], isDisabled))
            {
            if(childDisabled)
              {
              childDisabled = false;
              }
            }
          }
        if(childDisabled && !isDisabled)
          {
          obj.setDisabled(true);
          isDisabled = true;
          }
        }
      logGui.trace("selectTree.judgeMenu().expandDisabled() - end - ", isDisabled);
      return isDisabled;
      }
    // Q\bhs
    this.children = getTarget(GLOBAL_OBJ, "");
    // ECMAScriptlCeBu
    if(withECMAScript)
      {
      var menu = new TreeMenu("ECMAScript", WINDOW_TREE, null, false, false, false, "ECMAScript", false);
      menu.onclick = onclick;
      menu.children = [
        new TreeMenu("Global"  , WINDOW_TREE, "this"    , false, false, false, "Global"  , true),
        new TreeMenu("Object"  , WINDOW_TREE, "Object"  , false, false, false, "Object"  , true),
        new TreeMenu("Function", WINDOW_TREE, "Function", false, false, false, "Function", true),
        new TreeMenu("Boolean" , WINDOW_TREE, "Boolean" , false, false, false, "Boolean" , true),
        new TreeMenu("Number"  , WINDOW_TREE, "Number"  , false, false, false, "Number"  , true),
        new TreeMenu("String"  , WINDOW_TREE, "String"  , false, false, false, "String"  , true),
        new TreeMenu("Array"   , WINDOW_TREE, "Array"   , false, false, false, "Array"   , true),
        new TreeMenu("RegExp"  , WINDOW_TREE, "RegExp"  , false, false, false, "RegExp"  , true),
        new TreeMenu("Date"    , WINDOW_TREE, "Date"    , false, false, false, "Date"    , true),
        new TreeMenu("Error"   , WINDOW_TREE, "Error"   , false, false, false, "Error"   , true),
        new TreeMenu("EvalError"     , WINDOW_TREE, "EvalError"     , false, false, false, "EvalError"     , true),
        new TreeMenu("RangeError"    , WINDOW_TREE, "RangeError"    , false, false, false, "RangeError"    , true),
        new TreeMenu("ReferenceError", WINDOW_TREE, "ReferenceError", false, false, false, "ReferenceError", true),
        new TreeMenu("TypeError"     , WINDOW_TREE, "TypeError"     , false, false, false, "TypeError"     , true),
        new TreeMenu("SyntaxError"   , WINDOW_TREE, "SyntaxError"   , false, false, false, "SyntaxError"   , true),
        new TreeMenu("URIError"      , WINDOW_TREE, "URIError"      , false, false, false, "URIError"      , true),
        new TreeMenu("Math"    , WINDOW_TREE, "Math"    , false, false, false, "Math"    , true)
        ];
      for(var i = 0; i < menu.children.length; i++)
        {
        menu.children[i].onclick = onclick;
        }
      this.children = ([menu]).concat(this.children);
      }
    for(var c = 0; c < this.children.length; c++)
      {
      expandDisabled(this.children[c]);
      }
    logGui.trace("selectTree.judgeMenu() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // RpC - Tvt@C
  
    //  폜
  
  //------------------------------------------------------------------------------
  // RpC - ڍ׃t@C
  
    //  폜
    
  //------------------------------------------------------------------------------
  // RpC - XMLO
  
  // id
  var XMLNS_USE_ID   = "xmlnsUsing";
  var XMLNS_INPUT_ID = "XmlnsInput";
  var XMLNS_NAME_ID  = "xmlnsName";
  var XMLNS_URI_ID   = "xmlnsUri";
  
  // CX^X
  var xmlnsUsing = new ElementControl(XMLNS_USE_ID, WINDOW_COND, XMLNS_USE_ID, false, false, false);
  var xmlnsInput = new NodeControl(XMLNS_INPUT_ID, WINDOW_COND, XMLNS_INPUT_ID, null, true, false);
  var xmlnsName  = new ElementControl(XMLNS_NAME_ID, WINDOW_COND, XMLNS_NAME_ID, "", false, false);
  var xmlnsUri   = new ElementControl(XMLNS_URI_ID, WINDOW_COND, XMLNS_URI_ID, "", false, false);
  
  // Ԕ
  xmlnsInput.judgeState = function()
    {
    logGui.trace("xmlnsInput.judgeState() - begin - ");
    var isUsing = xmlnsUsing.getValue();
    this.setDisplay(isUsing);
    logGui.trace("xmlnsInput.judgeState() - end - ");
    };
  
  xmlnsName.judgeState = function()
    {
    logGui.trace("xmlnsName.judgeState() - begin - ");
    var isUsing = xmlnsUsing.getValue();
    this.setDisabled(!isUsing);
    logGui.trace("xmlnsName.judgeState() - end - ");
    };
  
  xmlnsUri.judgeState = function()
    {
    logGui.trace("xmlnsUri.judgeState() - begin - ");
    var isUsing = xmlnsUsing.getValue();
    this.setDisabled(!isUsing);
    logGui.trace("xmlnsUri.judgeState() - end - ");
    };
  
  // Cxg
  xmlnsUsing.onclick = function()
    {
    logGui.trace("xmlnsUsing.onclick() - begin - ");
    xmlnsInput.judgeState();
    xmlnsName.judgeState();
    xmlnsUri.judgeState();
    logGui.trace("xmlnsUsing.onclick() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // RpC - link^O
  
  // id
  var LINK_APPEND_ID = "linkNodes.append";
  var LINK_NODES_ID  = "linkNodes";
  
  // CX^X
  var buttonLinkAppend = new ElementControl(LINK_APPEND_ID, WINDOW_COND, LINK_APPEND_ID, "ǉ", false, false);
  
  // JE^
  var linkCounter = 0;
  
  // NIuWFNgz
  var linkNodes = [];
  
  // Nǉ
  function appendLink()
    {
    logGui.trace("appendLink() - begin - ");
    var linkObj = null;
    var linkFrame = NodeControl.Static.getElement(WINDOW_COND, LINK_NODES_ID);
    if(linkFrame)
      {
      var count = linkCounter++;
      var setId = "linkNodes[" + count + "]";
      // t[
      var linkNode = NodeControl.Static.createElement(WINDOW_COND, "div");
      linkNode.id = setId;
      linkNode.className = "ListFrame";
      linkFrame.appendChild(linkNode);
      // Rg[
      var linkCtrl = NodeControl.Static.createElement(WINDOW_COND, "div");
      linkCtrl.id = setId + ".Ctrl";
      linkCtrl.className = "ListCtrl";
      var tags  = '<span class="ListTitle">&lt;link&gt;^O</span>';
          tags += '<input id="' + setId + '.enable" type="checkbox" /><label for="' + setId + '.enable">L</label>';
          tags += '<input id="' + setId + '.delete" type="button" value="폜" />';
      linkCtrl.innerHTML = tags;
      linkNode.appendChild(linkCtrl);
      // f[^
      var linkData = NodeControl.Static.createElement(WINDOW_COND, "div");
      linkData.id = setId + ".Data";
      linkData.className = "ListData";
      var tags  = '<span class="CodeSamp">rel=&quot;<input id="' + setId + '.rel" type="text" size="16" />&quot;&nbsp;rev=&quot;<input id="' + setId + '.rev" type="text" size="16" />&quot;&nbsp;</span>';
          tags += '<span class="CodeSamp">type=&quot;<input id="' + setId + '.type" type="text" size="16" />&quot;&nbsp;media=&quot;<input id="' + setId + '.media" type="text" size="16" />&quot;&nbsp;</span>';
          tags += '<span class="CodeSamp">href=&quot;<input id="' + setId + '.href" type="text" size="64" />&quot;&nbsp;</span>';
          tags += '<span class="CodeSamp">target=&quot;<input id="' + setId + '.target" type="text" size="8" />&quot;&nbsp;charset=&quot;<input id="' + setId + '.charset" type="text" size="8" />&quot;&nbsp;hreflang=&quot;<input id="' + setId + '.hreflang" type="text" size="4" />&quot;&nbsp;</span>';
      linkData.innerHTML = tags;
      linkNode.appendChild(linkData);
      logGui.debug("N͗ǉ܂B", "setId=", setId);
      // IuWFNg
      linkObj = new NodeControl(setId, WINDOW_COND, setId, null, true, true);
      linkObj.count  = count;
      linkObj.Ctrl   = new NodeControl(setId + ".Ctrl", WINDOW_COND, setId + ".Ctrl", null, true, true);
      linkObj.Data   = new NodeControl(setId + ".Data", WINDOW_COND, setId + ".Data", null, true, true);
      linkObj.btnDel = new ElementControl(setId + ".delete", WINDOW_COND, setId + ".delete", "폜", false, false);
      linkObj.enable = new ElementControl(setId + ".enable", WINDOW_COND, setId + ".enable", true, false, false);
      linkObj.rel    = new ElementControl(setId + ".rel"   , WINDOW_COND, setId + ".rel"   , "", false, false);
      linkObj.rev    = new ElementControl(setId + ".rev"   , WINDOW_COND, setId + ".rev"   , "", false, false);
      linkObj.type   = new ElementControl(setId + ".type"  , WINDOW_COND, setId + ".type"  , "", false, false);
      linkObj.media  = new ElementControl(setId + ".media" , WINDOW_COND, setId + ".media" , "", false, false);
      linkObj.href   = new ElementControl(setId + ".href"  , WINDOW_COND, setId + ".href"  , "", false, false);
      linkObj.target = new ElementControl(setId + ".target", WINDOW_COND, setId + ".target", "", false, false);
      linkObj.charset  = new ElementControl(setId + ".charset" , WINDOW_COND, setId + ".charset" , "", false, false);
      linkObj.hreflang = new ElementControl(setId + ".hreflang", WINDOW_COND, setId + ".hreflang", "", false, false);
      linkObj.judgeState = function()
        {
        var using = this.enable.getValue();
        this.rel.setDisabled(!using);
        this.rev.setDisabled(!using);
        this.type.setDisabled(!using);
        this.media.setDisabled(!using);
        this.href.setDisabled(!using);
        this.target.setDisabled(!using);
        this.charset.setDisabled(!using);
        this.hreflang.setDisabled(!using);
        };
      linkObj.enable.onclick = function()
        {
        linkObj.judgeState();
        };
      linkObj.btnDel.onclick = function()
        {
        linkNodes[linkObj.count] = null;
        linkObj.Ctrl = null;
        linkObj.Data = null;
        linkObj.btnDel = null;
        linkObj.enable = null;
        linkObj.rel = null;
        linkObj.rev = null;
        linkObj.type = null;
        linkObj.media = null;
        linkObj.href = null;
        linkObj.target = null;
        linkObj.charset = null;
        linkObj.hreflang = null;
        var obj = linkObj.getObject();
        linkFrame.removeChild(obj);
        linkObj = null;
        };
      linkObj.init();
      linkObj.Ctrl.init();
      linkObj.Data.init();
      linkObj.btnDel.init();
      linkObj.enable.init();
      linkObj.rel.init();
      linkObj.rev.init();
      linkObj.type.init();
      linkObj.media.init();
      linkObj.href.init();
      linkObj.target.init();
      linkObj.charset.init();
      linkObj.hreflang.init();
      }
    // o^ƃ{^߂
    if(linkObj)
      {
      linkNodes[linkNodes] = linkObj;
      }
    buttonLinkAppend.setValue("ǉ");
    buttonLinkAppend.setDisabled(false);
    logGui.trace("appendLink() - end - ", linkObj);
    return linkObj;
    }
  
  // Cxg
  buttonLinkAppend.onclick = function()
    {
    logGui.trace("buttonLinkAppend.onclick() - begin - ");
    this.setValue("ǉ...");
    this.setDisabled(true);
    setTimeout(appendLink, 0);
    logGui.trace("buttonLinkAppend.onclick() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // RpC - pbP[W`t@C
  
  // id
  var DEF_FILE_APPEND_ID = "defFileNodes.append";
  var DEF_FILE_NODES_ID  = "defFileNodes";
  
  // pbP[WIvV
  var defPackageOptions = null;
  
  // pbP[WIvV擾
  function getDefPackageOptions()
    {
    logGui.trace("getDefPackageOptions() - begin - ");
    if(!defPackageOptions)
      {
      var packages = selectTree.getItems(null, false);
      if(packages && (packages.length > 0))
        {
        defPackageOptions = [];
        defPackageOptions[0] = new SelectOption("pbP[WI", "", true);
        for(var i = 0; i< packages.length; i++)
          {
          var menu = packages[i];
          if(menu instanceof TreeMenu)
            {
            var text = menu.getValue();
            if(text)
              {
              defPackageOptions[defPackageOptions.length] = new SelectOption(text, text, true);
              }
            }
          }
        }
      }
    logGui.trace("getDefPackageOptions() - end - ", defPackageOptions);
    return defPackageOptions;
    }
  
  // CX^X
  var buttonDefFileAppend = new ElementControl(DEF_FILE_APPEND_ID, WINDOW_COND, DEF_FILE_APPEND_ID, "ǉ", false, false);
  
  // JE^
  var defFileCounter = 0;
  
  // `t@CIuWFNgz
  var defFileNodes = [];
  
  // Nǉ
  function appendDefFile()
    {
    logGui.trace("appendDefFile() - begin - ");
    var defFile = null;
    var defFileFrame = NodeControl.Static.getElement(WINDOW_COND, DEF_FILE_NODES_ID);
    if(defFileFrame)
      {
      var count = defFileCounter++;
      var setId = "defFileNodes[" + count + "]";
      // t[
      var defFileNode = NodeControl.Static.createElement(WINDOW_COND, "div");
      defFileNode.id = setId;
      defFileNode.className = "ListFrame";
      defFileFrame.appendChild(defFileNode);
      // Rg[
      var defFileCtrl = NodeControl.Static.createElement(WINDOW_COND, "div");
      defFileCtrl.id = setId + ".Ctrl";
      defFileCtrl.className = "ListCtrl";
      var tags  = '<span class="ListTitle">pbP[W`t@C</span>';
          tags += '<input id="' + setId + '.enable" type="checkbox" /><label for="' + setId + '.enable">L</label>';
          tags += '<input id="' + setId + '.delete" type="button" value="폜" />';
      defFileCtrl.innerHTML = tags;
      defFileNode.appendChild(defFileCtrl);
      // f[^
      var defFileData = NodeControl.Static.createElement(WINDOW_COND, "div");
      defFileData.id = setId + ".Data";
      defFileData.className = "ListData";
      var tags  = '<table><tbody>';
          tags += '<tr><th>pbP[Wʒu</th><td><select id="' + setId + '.pkg"></select></td></tr>';
          tags += '<tr><th>`t@C</th><td><input id="' + setId + '.fileName" type="text" size="48" /></td></tr>';
          tags += '<tr><th>IvV</th><td><input id="' + setId + '.options" type="text" size="48" /></td></tr>';
          tags += '</tbody></table>';
      defFileData.innerHTML = tags;
      defFileNode.appendChild(defFileData);
      logGui.debug("pbP[W`t@C͗ǉ܂B", "setId=", setId);
      // IuWFNg쐬
      defFile = new NodeControl(setId, WINDOW_COND, setId, null, true, true);
      defFile.count  = count;
      defFile.Ctrl   = new NodeControl(setId + ".Ctrl", WINDOW_COND, setId + ".Ctrl", null, true, true);
      defFile.Data   = new NodeControl(setId + ".Data", WINDOW_COND, setId + ".Data", null, true, true);
      defFile.btnDel = new ElementControl(setId + ".delete", WINDOW_COND, setId + ".delete", "폜", false, false);
      defFile.enable = new ElementControl(setId + ".enable", WINDOW_COND, setId + ".enable", true, false, false);
      defFile.pkg      = new SelectBox(setId + ".pkg", WINDOW_COND, setId + ".pkg", "", false, false);
      defFile.fileName = new ElementControl(setId + ".fileName", WINDOW_COND, setId + ".fileName", "", false, false);
      defFile.fileName.setPattern(/^\w+\.(?:js|vbs)$/i);
      defFile.options  = new ElementControl(setId + ".options", WINDOW_COND, setId + ".options", "", false, false);
      var options = getDefPackageOptions();
      if(options)
        {
        for(var i = 0; i < options.length; i++)
          {
          defFile.pkg.addOption(options[i]);
          }
        }
      defFile.judgeState = function()
        {
        var using = this.enable.getValue();
        this.pkg.setDisabled(!using);
        this.fileName.setDisabled(!using);
        this.options.setDisabled(!using);
        var undel = this.btnDel.getDisabled();
        this.fileName.setReadOnly(undel);
        this.options.setReadOnly(undel);
        };
      defFile.enable.onclick = function()
        {
        defFile.judgeState();
        };
      defFile.btnDel.onclick = function()
        {
        defFileNodes[defFile.count] = null;
        defFile.Ctrl = null;
        defFile.Data = null;
        defFile.btnDel = null;
        defFile.enable = null;
        defFile.pkg = null;
        defFile.fileName = null;
        defFile.options = null;
        var obj = defFile.getObject();
        defFileFrame.removeChild(obj);
        defFile = null;
        };
      defFile.init();
      defFile.Ctrl.init();
      defFile.Data.init();
      defFile.btnDel.init();
      defFile.enable.init();
      defFile.pkg.init();
      defFile.fileName.init();
      defFile.options.init();
      }
    // o^ƃ{^߂
    if(defFile)
      {
      defFileNodes[defFileNodes.length] = defFile;
      }
    buttonDefFileAppend.setValue("ǉ");
    buttonDefFileAppend.setDisabled(false);
    logGui.trace("appendDefFile() - end - ", defFile);
    return defFile;
    }
  
  // Cxg
  buttonDefFileAppend.onclick = function()
    {
    this.setValue("ǉ...");
    this.setDisabled(true);
    setTimeout(appendDefFile, 0);
    };
  
  //------------------------------------------------------------------------------
  // RpC - fvCx[XfBNg
  
  // id
  var DEPLOY_APPEND_ID = "deployNodes.append";
  var DEPLOY_NODES_ID  = "deployNodes";
  
  // pbP[WIvV
  var deployPackageOptions = null;
  
  // pbP[WIvV擾
  function getDeployPackageOptions()
    {
    logGui.trace("getDeployPackageOptions() - begin - ");
    if(!deployPackageOptions)
      {
      var packages = selectTree.getItems(null, false);
      if(packages && (packages.length > 0))
        {
        deployPackageOptions = [];
        deployPackageOptions[0] = new SelectOption("pbP[WI", "", true);
        deployPackageOptions[1] = new SelectOption("O[oIuWFNg", "this", true);
        for(var i = 0; i < packages.length; i++)
          {
          var menu = packages[i];
          if(menu instanceof TreeMenu)
            {
            var text = menu.getValue();
            deployPackageOptions[deployPackageOptions.length] = new SelectOption(text, text, true);
            }
          }
        }
      }
    logGui.trace("getDeployPackageOptions() - end - ", deployPackageOptions);
    return deployPackageOptions;
    }
  
  // CX^X
  var buttonDeployAppend = new ElementControl(DEPLOY_APPEND_ID, WINDOW_COND, DEPLOY_APPEND_ID, "ǉ", false, false);
  
  // JE^
  var deployCounter = 0;
  
  // `t@CIuWFNgz
  var deployNodes = [];
  
  // Nǉ
  function appendDeploy()
    {
    logGui.trace("appendDeploy() - begin - ");
    var deploy = null;
    var deployFrame = NodeControl.Static.getElement(WINDOW_COND, DEPLOY_NODES_ID);
    if(deployFrame)
      {
      var count = deployCounter++;
      var setId = "deployNodes[" + count + "]";
      // t[
      var deployNode = NodeControl.Static.createElement(WINDOW_COND, "div");
      deployNode.id = setId;
      deployNode.className = "ListFrame";
      deployFrame.appendChild(deployNode);
      // Rg[
      var deployCtrl = NodeControl.Static.createElement(WINDOW_COND, "div");
      deployCtrl.id = setId + ".Ctrl";
      deployCtrl.className = "ListCtrl";
      var tags  = '<span class="ListTitle">fvCx[XfBNg</span>';
          tags += '<input id="' + setId + '.enable" type="checkbox" /><label for="' + setId + '.enable">L</label>';
          tags += '<input id="' + setId + '.delete" type="button" value="폜" />';
      deployCtrl.innerHTML = tags;
      deployNode.appendChild(deployCtrl);
      // f[^
      var deployData = NodeControl.Static.createElement(WINDOW_COND, "div");
      deployData.id = setId + ".Data";
      deployData.className = "ListData";
      var tags  = '<table><tbody>';
          tags += '<tr><th>pbP[Wʒu</th><td><select id="' + setId + '.pkg"></select></td></tr>';
          tags += '<tr><th>ΉfBNg</th><td><input id="' + setId + '.directory" type="text" size="72" title="΃pXōŌ/܂œ" /></td></tr>';
          tags += '<tr><th>t@Cgq</th><td><input id="' + setId + '.extension" type="text" size="8" /></td></tr>';
          tags += '</tbody></table>';
      deployData.innerHTML = tags;
      deployNode.appendChild(deployData);
      logGui.debug("fvCx[XfBNg͗ǉ܂B", "setId=", setId);
      // IuWFNg쐬
      deploy = new NodeControl(setId, WINDOW_COND, setId, null, true, true);
      deploy.count  = count;
      deploy.Ctrl   = new NodeControl(setId + ".Ctrl", WINDOW_COND, setId + ".Ctrl", null, true, true);
      deploy.Data   = new NodeControl(setId + ".Data", WINDOW_COND, setId + ".Data", null, true, true);
      deploy.btnDel = new ElementControl(setId + ".delete", WINDOW_COND, setId + ".delete", "폜", false, false);
      deploy.enable = new ElementControl(setId + ".enable", WINDOW_COND, setId + ".enable", true, false, false);
      deploy.pkg       = new SelectBox(setId + ".pkg", WINDOW_COND, setId + ".pkg", "", false, false);
      deploy.directory = new ElementControl(setId + ".directory", WINDOW_COND, setId + ".directory", "", false, false);
      deploy.extension = new ElementControl(setId + ".extension", WINDOW_COND, setId + ".extension", "xml", false, false);
      deploy.directory.setPattern(/^(?:(?:http:|https:|file:)\/\/(?:[\w_\-\.]+(?::\d+)?)?\/)?(?:[\w\d_\-\.~\:]+\/)*$/);
      deploy.extension.setPattern(/^[\w\d]+$/);
      var options = getDeployPackageOptions();
      if(options)
        {
        for(var i = 0; i < options.length; i++)
          {
          deploy.pkg.addOption(options[i]);
          }
        }
      deploy.judgeState = function()
        {
        var using = this.enable.getValue();
        this.pkg.setDisabled(!using);
        this.directory.setDisabled(!using);
        this.extension.setDisabled(!using);
        };
      deploy.enable.onclick = function()
        {
        deploy.judgeState();
        };
      deploy.btnDel.onclick = function()
        {
        deployNodes[deploy.count] = null;
        deploy.Ctrl = null;
        deploy.Data = null;
        deploy.btnDel = null;
        deploy.enable = null;
        deploy.pkg = null;
        deploy.directory = null;
        deploy.extension = null;
        var obj = deploy.getObject();
        deployFrame.removeChild(obj);
        deploy = null;
        };
      deploy.init();
      deploy.Ctrl.init();
      deploy.Data.init();
      deploy.btnDel.init();
      deploy.enable.init();
      deploy.pkg.init();
      deploy.directory.init();
      deploy.extension.init();
      }
    // o^ƃ{^߂
    if(deploy)
      {
      deployNodes[deployNodes.length] = deploy;
      }
    buttonDeployAppend.setValue("ǉ");
    buttonDeployAppend.setDisabled(false);
    logGui.trace("appendDeploy() - end - ", deploy);
    return deploy;
    }
  
  // Cxg
  buttonDeployAppend.onclick = function()
    {
    this.setValue("ǉ...");
    this.setDisabled(true);
    setTimeout(appendDeploy, 0);
    };
  
  //------------------------------------------------------------------------------
  // s - [gpbP[W
  
  // id
  var ROOT_PACKAGE = "rootPackage";
  
  // pbP[WIvV
  var rootPackageOptions = null;
  
  // pbP[WIvV擾
  function getRootPackageOptions()
    {
    logGui.trace("getRootPackageOptions() - begin - ");
    if(!rootPackageOptions)
      {
      var packages = selectTree.getItems(null, false);
      if(packages)
        {
        rootPackageOptions = [];
        rootPackageOptions[0] = new SelectOption("O[oIuWFNg", "this", true);
        for(var i = 0; i < packages.length; i++)
          {
          var menu = packages[i];
          if(menu instanceof TreeMenu)
            {
            var text = menu.getValue();
            rootPackageOptions[rootPackageOptions.length] = new SelectOption(text, text, checkOptionDisplay);
            }
          }
        }
      }
    logGui.trace("getRootPackageOptions() - end - ", rootPackageOptions);
    return rootPackageOptions;
    }
  
  // IvV\胁\bh
  function checkOptionDisplay(map)
    {
    logGui.trace("checkOptionDisplay() - begin - ");
    var answer = false;
    if((typeof map) == "object")
      {
      var value = this.value;
      if(value)
        {
        var isDisplay = map[value];
        answer = (((typeof isDisplay) == "boolean") ? isDisplay : (isDisplay ? true : false));
        }
      }
    logGui.trace("checkOptionDisplay() - end - ", answer);
    return answer;
    }
  
  // CX^X
  var rootPackage = new SelectBox(ROOT_PACKAGE, WINDOW_EXEC, ROOT_PACKAGE, "this", false, false);
  
  // IvV\bh
  var initRootPackageOptions = function()
    {
    logGui.trace("initRootPackageOptions() - begin - ");
    var options = getRootPackageOptions();
    if(options)
      {
      initRootPackageOptions = function()
        {
        };
      for(var i = 0; i < options.length; i++)
        {
        rootPackage.addOption(options[i]);
        }
      }
    logGui.trace("initRootPackageOptions() - end - ");
    };
  
  // IvVݒ胁\bh
  rootPackage.judgeOptions = function()
    {
    logGui.trace("rootPackage.judgeOptions() - begin - ");
    initRootPackageOptions();
    var cond = {};
    var menus = selectTree.getRootNodes();
    for(var i = 0; i < menus.length; i++)
      {
      if(menus[i] instanceof TreeMenu)
        {
        var value = menus[i].getValue();
        if(value)
          {
          cond[value] = true;
          }
        }
      }
    this.setCondValue(cond);
    logGui.trace("rootPackage.judgeOptions() - end - ");
    };
  
  // Ԕ
  rootPackage.judgeState = function()
    {
    };
  
  //------------------------------------------------------------------------------
  // s - zufBNg
  
  // id
  var ROOT_DIRECTORY = "rootDirectory";
  var OPEN_DIRECTORY = "openDirectory";
  
  // CX^X
  var rootDirectory = new ElementControl(ROOT_DIRECTORY, WINDOW_EXEC, ROOT_DIRECTORY, "", false, false);
  var openDirectory = new ElementControl(OPEN_DIRECTORY, WINDOW_EXEC, OPEN_DIRECTORY, "J", false, false);
  
  openDirectory.setPattern(/^(?:\w:)?\\(?:[\w\d_]+\\)*$/);
  
  // ԊǗ
  rootDirectory.judgeState = function()
    {
    };
  openDirectory.judgeState = function()
    {
    };
  
  // Cxg
  openDirectory.onclick = function()
    {
    logGui.trace("openDirectory.onclick() - begin - ");
    var dir = null;
    try
      {
      var Shell = new ActiveXObject("Shell.Application");
      var msg = "zufBNg̎w";
      var opt = 0x0001 + 0x0002 + 0x0010 + 0x0040;
      var top = 17;
      var folder = Shell.BrowseForFolder(0, msg, opt, top);
      dir = folder ? folder.Items().Item().Path : null;
      if(dir && (dir.indexOf("::", 0) >= 0))
        {
        dir = null;
        }
      }
    catch(e)
      {
      dir = null;
      this.setDisabled(true);
      Msg("݂̊ł́Ã{^͎gpł܂B");
      }
    if((typeof dir) == "string")
      {
      rootDirectory.setValue(dir);
      }
    logGui.trace("openDirectory.onclick() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - 񓯊
  
  // id
  var ASYNC_EXEC = "async";
  
  // CX^X
  var asyncCheck = new ElementControl(ASYNC_EXEC, WINDOW_EXEC, ASYNC_EXEC, true, false, true);
  
  // 
  asyncCheck.judgeState = function()
    {
    };
  
  //------------------------------------------------------------------------------
  // s - VKRpC
  
  // id
  var NEW_COMPILE = "newCompile";
  
  // CX^X
  var newCompile = new ElementControl(NEW_COMPILE, WINDOW_EXEC, NEW_COMPILE, true, false, false);
  
  // 
  newCompile.judgeState = function()
    {
    };
  
  // Cxg
  newCompile.onclick = function()
    {
    logGui.trace("newCompile.onclick() - begin - ");
    execCompileCheck.judgeState();
    logGui.trace("newCompile.onclick() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - ۑ@
  
  // id
  var SAVING_WAY = "saving";
  
  // CX^X
  var savingWay = new SelectBox(SAVING_WAY, WINDOW_EXEC, SAVING_WAY, "execCommand", false, false);
  savingWay.addOption(new SelectOption("ۑȂ", "", true));
  savingWay.addOption(new SelectOption("execCommand", "execCommand", true));
  savingWay.addOption(new SelectOption("ADODB.Stream", "ADODB.Stream", true));
  savingWay.addOption(new SelectOption("FileSystemObject", "FileSystemObject", true));
  
  // 
  savingWay.judgeOptions = function()
    {
    };
  savingWay.judgeState = function()
    {
    logGui.trace("savingWay.judgeState() - begin - ");
    var saving = execWriteCheck.getValue();
    this.setDisabled(!saving);
    logGui.trace("savingWay.judgeState() - end - ");
    };
  savingWay.judgeValue = function()
    {
    logGui.trace("savingWay.judgeValue() - begin - ");
    var saving = execWriteCheck.getValue();
    if(!saving)
      {
      this.setValue("");
      }
    logGui.trace("savingWay.judgeValue() - end - ");
    };
  
  // Cxg
  savingWay.onchange = function()
    {
    logGui.trace("savingWay.onchange() - begin - ");
    encoding.judgeOptions();
    encoding.flashOptions();
    fileExtension.judgeState();
    execXslTypeO.judgeState();
    execXslTypeR.judgeState();
    execXslTypeO.judgeValue();
    execXslTypeR.judgeValue();
    logGui.trace("savingWay.onchange() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - R[h
  
  // id
  var CHARSET = "charset";
  
  // CX^X
  var encoding = new SelectBox(CHARSET, WINDOW_EXEC, CHARSET, "UTF-16", false, false);
  encoding.addOption(new SelectOption("UTF-16", "UTF-16", ["ADODB.Stream", "FileSystemObject", "execCommand", ""]));
  encoding.addOption(new SelectOption("UTF-8", "UTF-8", ["ADODB.Stream"]));
  encoding.addOption(new SelectOption("Shift_JIS", "Shift_JIS", ["ADODB.Stream", "FileSystemObject"]));
  encoding.addOption(new SelectOption("EUC-JP", "EUC-JP", ["ADODB.Stream"]));
  
  // 
  encoding.judgeOptions = function()
    {
    logGui.trace("encoding.judgeOptions() - begin - ");
    this.setCondValue(savingWay.getValue());
    logGui.trace("encoding.judgeOptions() - end - ");
    };
  encoding.judgeState = function()
    {
    };
  
  //------------------------------------------------------------------------------
  // s - sR[h
  
  // id
  var SEPARATOR = "lineSeparator";
  
  // CX^X
  var lineSeparator = new SelectBox(SEPARATOR, WINDOW_EXEC, SEPARATOR, "CR+LF", false, false);
  lineSeparator.addOption(new SelectOption("CR+LF", "CR+LF", true));
  lineSeparator.addOption(new SelectOption("LF", "LF", true));
  lineSeparator.addOption(new SelectOption("CR", "CR", true));
  
  // 
  lineSeparator.judgeOptions = function()
    {
    };
  lineSeparator.judgeState = function()
    {
    };
  
  //------------------------------------------------------------------------------
  // s - gq
  
  // id
  var FILE_EXTENSION = "fileExtension";
  
  // CX^X
  var fileExtension = new ElementControl(FILE_EXTENSION, WINDOW_EXEC, FILE_EXTENSION, "xml", false, false);
  fileExtension.setPattern(/^[\w\d]+$/);
  
  // 
  fileExtension.judgeState = function()
    {
    logGui.trace("fileExtension.judgeState() - begin - ");
    var saving = execWriteCheck.getValue() && savingWay.getValue();
    this.setDisabled(!saving);
    logGui.trace("fileExtension.judgeState() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - Ox
  
  // id
  var LOG_LEVEL = "logLevel";
  
  // CX^X
  var logLevel = new SelectBox(LOG_LEVEL, WINDOW_MENU, LOG_LEVEL, Log.Static.level, false, false);
  logLevel.addOption(new SelectOption("o͂Ȃ", "-1", true));
  logLevel.addOption(new SelectOption("FATAL", "0", true));
  logLevel.addOption(new SelectOption("ERROR", "1", true));
  logLevel.addOption(new SelectOption("WARN", "2", true));
  logLevel.addOption(new SelectOption("INFO", "3", true));
  logLevel.addOption(new SelectOption("DEBUG", "4", true));
  logLevel.addOption(new SelectOption("TRACE", "5", true));
  
  // 
  logLevel.judgeOptions = function()
    {
    };
  logLevel.judgeState = function()
    {
    };
  
  // Cxg
  logLevel.onchange = function()
    {
    var lev = null;
    try
      {
      lev = parseInt(this.getValue());
      if(((typeof lev) == "number") && !isNaN(lev))
        {
        Log.Static.level = lev;
        }
      }
    catch(e)
      {
      // ignore.
      }
    };
  
  //------------------------------------------------------------------------------
  // s - RpCsI
  
  // id
  var EXEC_COMPILE_CHECK = "execCompile";
  var EXEC_COMPILE_COUNT = "countCompile";
  var EXEC_COMPILE_PRGRS = "progressCompileBar";
  
  // CX^X
  var execCompileCheck = new ElementControl(EXEC_COMPILE_CHECK, WINDOW_EXEC, EXEC_COMPILE_CHECK, true, false, true);
  var execCompileCount = new NodeControl(EXEC_COMPILE_COUNT, WINDOW_EXEC, EXEC_COMPILE_COUNT, "0", true, true);
  var execCompilePrgrs = new NodeControl(EXEC_COMPILE_PRGRS, WINDOW_EXEC, EXEC_COMPILE_PRGRS, "", true, true);
  
  // 
  execCompileCheck.judgeState = function()
    {
    logGui.trace("execCompileCheck.judgeState() - begin - ");
    var isNew = newCompile.getValue();
    if(isNew)
      {
      this.setValue(true);
      this.setDisabled(true);
      }
    else
      {
      this.setDisabled(false);
      }
    logGui.trace("execCompileCheck.judgeState() - end - ");
    };
  // 
  execCompileCount.judgeValue = function()
    {
    logGui.trace("execCompileCount.judgeValue() - begin - ");
    var state = stateCompile.getState();
    var value = "";
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "0";
        break;
      case EventState.Static.STATE_READY:
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        value = stateCompile.getLength() + "";
        break;
      default:
        value = "0";
      }
    this.setValue(value);
    logGui.trace("execCompileCount.judgeValue() - end - ");
    };
  // 
  execCompilePrgrs.judgeValue = function()
    {
    logGui.trace("execCompilePrgrs.judgeValue() - begin - ");
    var state = stateCompile.getState();
    var value = "";
    var range = 0;
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "";
        break;
      case EventState.Static.STATE_READY:
        value = "0%";
        break;
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        range = stateCompile.getRange();
        value = Math.floor(range * 100) + "%";
        break;
      default:
        value = "";
      }
    this.setValue(value);
    // o[̒𒲐
    var obj = this.getObject();
    if(obj)
      {
      obj.style.width = Math.floor(range * 200) + "px";
      }
    logGui.trace("execCompilePrgrs.judgeValue() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - RlNVsI
  
  // id
  var EXEC_CONNECT_CHECK = "execConnection";
  var EXEC_CONNECT_COUNT = "countConnection";
  var EXEC_CONNECT_PRGRS = "progressConnectionBar";
  
  // CX^X
  var execConnectCheck = new ElementControl(EXEC_CONNECT_CHECK, WINDOW_EXEC, EXEC_CONNECT_CHECK, true, false, false);
  var execConnectCount = new NodeControl(EXEC_CONNECT_COUNT, WINDOW_EXEC, EXEC_CONNECT_COUNT, "0", true, true);
  var execConnectPrgrs = new NodeControl(EXEC_CONNECT_PRGRS, WINDOW_EXEC, EXEC_CONNECT_PRGRS, "", true, true);
  
  // 
  execConnectCount.judgeValue = function()
    {
    logGui.trace("execConnectCount.judgeValue() - begin - ");
    var state = stateConnect.getState();
    var value = "";
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "0";
        break;
      case EventState.Static.STATE_READY:
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        value = stateConnect.getLength() + "";
        break;
      default:
        value = "0";
      }
    this.setValue(value);
    logGui.trace("execConnectCount.judgeValue() - end - ");
    };
  // 
  execConnectPrgrs.judgeValue = function()
    {
    logGui.trace("execConnectPrgrs.judgeValue() - begin - ");
    var state = stateConnect.getState();
    var value = "";
    var range = 0;
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "";
        break;
      case EventState.Static.STATE_READY:
        value = "0%";
        break;
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        range = stateConnect.getRange();
        value = Math.floor(range * 100) + "%";
        break;
      default:
        value = "";
      }
    this.setValue(value);
    // o[̒𒲐
    var obj = this.getObject();
    if(obj)
      {
      obj.style.width = Math.floor(range * 200) + "px";
      }
    logGui.trace("execConnectPrgrs.judgeValue() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - NsI
  
  // id
  var EXEC_LINK_CHECK = "execLink";
  var EXEC_LINK_COUNT = "countLink";
  var EXEC_LINK_PRGRS = "progressLinkBar";
  
  // CX^X
  var execLinkCheck = new ElementControl(EXEC_LINK_CHECK, WINDOW_EXEC, EXEC_LINK_CHECK, true, false, false);
  var execLinkCount = new NodeControl(EXEC_LINK_COUNT, WINDOW_EXEC, EXEC_LINK_COUNT, "0", true, true);
  var execLinkPrgrs = new NodeControl(EXEC_LINK_PRGRS, WINDOW_EXEC, EXEC_LINK_PRGRS, "", true, true);
  
  // 
  execLinkCount.judgeValue = function()
    {
    logGui.trace("execLinkCount.judgeValue() - begin - ");
    var state = stateLink.getState();
    var value = "";
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "0";
        break;
      case EventState.Static.STATE_READY:
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        value = stateLink.getLength() + "";
        break;
      default:
        value = "0";
      }
    this.setValue(value);
    logGui.trace("execLinkCount.judgeValue() - end - ");
    };
  // 
  execLinkPrgrs.judgeValue = function()
    {
    logGui.trace("execLinkPrgrs.judgeValue() - begin - ");
    var state = stateLink.getState();
    var value = "";
    var range = 0;
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "";
        break;
      case EventState.Static.STATE_READY:
        value = "0%";
        break;
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        range = stateLink.getRange();
        value = Math.floor(range * 100) + "%";
        break;
      default:
        value = "";
      }
    this.setValue(value);
    // o[̒𒲐
    var obj = this.getObject();
    if(obj)
      {
      obj.style.width = Math.floor(range * 200) + "px";
      }
    logGui.trace("execLinkPrgrs.judgeValue() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - ݎsI
  
  // id
  var EXEC_WRITE_CHECK = "execWrite";
  var EXEC_WRITE_COUNT = "countWrite";
  var EXEC_WRITE_PRGRS = "progressWriteBar";
  
  // CX^X
  var execWriteCheck = new ElementControl(EXEC_WRITE_CHECK, WINDOW_EXEC, EXEC_WRITE_CHECK, true, false, false);
  var execWriteCount = new NodeControl(EXEC_WRITE_COUNT, WINDOW_EXEC, EXEC_WRITE_COUNT, "0", true, true);
  var execWritePrgrs = new NodeControl(EXEC_WRITE_PRGRS, WINDOW_EXEC, EXEC_WRITE_PRGRS, "", true, true);
  
  // 
  execWriteCount.judgeValue = function()
    {
    logGui.trace("execWriteCount.judgeValue() - begin - ");
    var state = stateWrite.getState();
    var value = "";
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "0";
        break;
      case EventState.Static.STATE_READY:
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        value = stateWrite.getLength() + "";
        break;
      default:
        value = "0";
      }
    this.setValue(value);
    logGui.trace("execWriteCount.judgeValue() - end - ");
    };
  // 
  execWritePrgrs.judgeValue = function()
    {
    logGui.trace("execWritePrgrs.judgeValue() - begin - ");
    var state = stateWrite.getState();
    var value = "";
    var range = 0;
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "";
        break;
      case EventState.Static.STATE_READY:
        value = "0%";
        break;
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        range = stateWrite.getRange();
        value = Math.floor(range * 100) + "%";
        break;
      default:
        value = "";
      }
    this.setValue(value);
    // o[̒𒲐
    var obj = this.getObject();
    if(obj)
      {
      obj.style.width = Math.floor(range * 200) + "px";
      }
    logGui.trace("execWritePrgrs.judgeValue() - end - ");
    };
  
  // Cxg
  execWriteCheck.onclick = function()
    {
    logGui.trace("execWriteCheck.onclick() - begin - ");
    savingWay.judgeState();
    savingWay.judgeValue();
    encoding.judgeOptions();
    encoding.flashOptions();
    fileExtension.judgeState();
    execXslTypeO.judgeState();
    execXslTypeR.judgeState();
    execXslTypeO.judgeValue();
    execXslTypeR.judgeValue();
    execIdxCheck.judgeState();
    execIdxFrame.judgeState();
    execIndexFile.judgeState();
    execContentsFile.judgeState();
    execHtmlCheck.judgeState();
    execHtmlFile.judgeState();
    logGui.trace("execWriteCheck.onclick() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - XSLϊsI
  
  // id
  var EXEC_XSL_CHECK = "xslTransform";
  var EXEC_XSL_TYPE_O = "xslTransformType_Order";
  var EXEC_XSL_TYPE_R = "xslTransformType_Result";
  var EXEC_XSL_SELECT = "xslSelect";
  
  // CX^X
  var execXslCheck = new ElementControl(EXEC_XSL_CHECK, WINDOW_EXEC, EXEC_XSL_CHECK, true, false, false);
  var execXslTypeO = new ElementControl(EXEC_XSL_TYPE_O, WINDOW_EXEC, EXEC_XSL_TYPE_O, true, false, false);
  var execXslTypeR = new ElementControl(EXEC_XSL_TYPE_R, WINDOW_EXEC, EXEC_XSL_TYPE_R, false, false, false);
  var execXslSelect = new SelectBox(EXEC_XSL_SELECT, WINDOW_EXEC, EXEC_XSL_SELECT, "", false, false);
  execXslSelect.addOption(new SelectOption("t@Cw...", "", true));
  (function()
    {
    var initOptions = getInitParam("xsl");
    if(initOptions)
      {
      for(var name in initOptions)
        {
        var val = initOptions[name].file;
        if(val && ((typeof val) == "string"))
          {
          execXslSelect.addOption(new SelectOption(name, name, true));
          }
        }
      }
    })();
  
  // XSLt@CRs[gp\
  function isUsableXslCopy()
    {
    var using_w = execWriteCheck.getValue();
    var using_x = execXslCheck.getValue();
    var writeWay = savingWay.getValue();
    return (using_x && using_w && ((writeWay == "ADODB.Stream") || (writeWay == "FileSystemObject")));
    }
  
  // 
  execXslCheck.judgeState = function()
    {
    };
  execXslTypeO.judgeState = function()
    {
    logGui.trace("execXslTypeO.judgeState() - begin - ");
    var using = execXslCheck.getValue();
    var another = (execXslSelect.getValue() == "");
    this.setDisabled((!using || !another) && !isUsableXslCopy());
    logGui.trace("execXslTypeO.judgeState() - end - ");
    };
  execXslTypeO.judgeValue = function()
    {
    if(execXslSelect.getValue() && !isUsableXslCopy())
      {
      this.setValue(false);
      }
    };
  execXslTypeR.judgeState = function()
    {
    logGui.trace("execXslTypeR.judgeState() - begin - ");
    var using = execXslCheck.getValue();
    this.setDisabled(!using);
    logGui.trace("execXslTypeR.judgeState() - end - ");
    };
  execXslTypeR.judgeValue = function()
    {
    if(execXslSelect.getValue() && !isUsableXslCopy())
      {
      this.setValue(true);
      }
    };
  execXslSelect.judgeOptions = function()
    {
    };
  execXslSelect.judgeState = function()
    {
    logGui.trace("execXslSelect.judgeState() - begin - ");
    var using = execXslCheck.getValue();
    this.setDisabled(!using);
    logGui.trace("execXslSelect.judgeState() - end - ");
    };
  
  // Cxg
  execXslCheck.onclick = function()
    {
    logGui.trace("execXslCheck.onclick() - begin - ");
    execXslTypeO.judgeState();
    execXslTypeR.judgeState();
    execXslTypeO.judgeValue();
    execXslTypeR.judgeValue();
    execXslSelect.judgeState();
    execXslFileFrame.judgeState();
    execXslFile.judgeState();
    logGui.trace("execXslCheck.onclick() - end - ");
    };
  execXslSelect.onchange = function()
    {
    logGui.trace("execXslSelect.onchange() - begin - ");
    execXslTypeO.judgeState();
    execXslTypeR.judgeState();
    execXslTypeO.judgeValue();
    execXslTypeR.judgeValue();
    execXslFileFrame.judgeState();
    execXslFile.judgeState();
    logGui.trace("execXslSelect.onchange() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - XSLϊsi
  
  // id
  var EXEC_XSL_COUNT = "countXsl";
  var EXEC_XSL_PRGRS = "progressXslBar";
  
  // CX^X
  var execXslCount = new NodeControl(EXEC_XSL_COUNT, WINDOW_EXEC, EXEC_XSL_COUNT, "0", true, true);
  var execXslPrgrs = new NodeControl(EXEC_XSL_PRGRS, WINDOW_EXEC, EXEC_XSL_PRGRS, "", true, true);
  
  // 
  execXslCount.judgeValue = function()
    {
    logGui.trace("execXslCount.judgeValue() - begin - ");
    var state = stateXsl.getState();
    var value = "";
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "0";
        break;
      case EventState.Static.STATE_READY:
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        value = stateXsl.getLength() + "";
        break;
      default:
        value = "0";
      }
    this.setValue(value);
    logGui.trace("execXslCount.judgeValue() - end - ");
    };
  // 
  execXslPrgrs.judgeValue = function()
    {
    logGui.trace("execXslPrgrs.judgeValue() - begin - ");
    var state = stateXsl.getState();
    var value = "";
    var range = 0;
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        value = "";
        break;
      case EventState.Static.STATE_READY:
        value = "0%";
        break;
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
      case EventState.Static.STATE_END:
        range = stateXsl.getRange();
        value = Math.floor(range * 100) + "%";
        break;
      default:
        value = "";
      }
    this.setValue(value);
    // o[̒𒲐
    var obj = this.getObject();
    if(obj)
      {
      obj.style.width = Math.floor(range * 200) + "px";
      }
    logGui.trace("execXslPrgrs.judgeValue() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - XSLϊt@Cw
  
  // id
  var EXEC_XSL_FILE_FRAME = "xslFileFrame";
  var EXEC_XSL_FILE = "xslFile";
  
  // CX^X
  var execXslFileFrame = new NodeControl(EXEC_XSL_FILE_FRAME, WINDOW_EXEC, EXEC_XSL_FILE_FRAME, null, true, true);
  var execXslFile = new ElementControl(EXEC_XSL_FILE, WINDOW_EXEC, EXEC_XSL_FILE, "", false, false);
  
  // 
  execXslFileFrame.judgeState = function()
    {
    logGui.trace("execXslFileFrame.judgeState() - begin - ");
    var using = execXslCheck.getValue();
    var other = (execXslSelect.getValue() == "");
    this.setDisplay(using && other);
    logGui.trace("execXslFileFrame.judgeState() - end - ");
    };
  execXslFile.judgeState = function()
    {
    logGui.trace("execXslFile.judgeState() - begin - ");
    var using = execXslCheck.getValue();
    var other = (execXslSelect.getValue() == "");
    this.setDisabled(!using || !other);
    logGui.trace("execXslFile.judgeState() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // s - CfbNX
  
  // id
  var EXEC_IDX_CHECK = "execIndex";
  
  // CX^X
  var execIdxCheck = new ElementControl(EXEC_IDX_CHECK, WINDOW_EXEC, EXEC_IDX_CHECK, true, false, false);
  
  // 
  execIdxCheck.judgeState = function()
    {
    var isWritable = execWriteCheck.getValue();
    this.setDisabled(!isWritable);
    };
  
  // Cxgݒ
  execIdxCheck.onclick = function()
    {
    execIdxFrame.judgeState();
    execIndexFile.judgeState();
    execContentsFile.judgeState();
    execHtmlCheck.judgeState();
    execHtmlFile.judgeState();
    };
  
  //------------------------------------------------------------------------------
  // s - CfbNXt@Cw
  
  // id
  var EXEC_IDX_FRAME     = "FrameIndex";
  var EXEC_INDEX_FILE    = "IndexFileName";
  var EXEC_CONTENTS_FILE = "ContentsFileName";
  var EXEC_HTML_CHECK    = "FrameHtmlUsing";
  var EXEC_HTML_FILE     = "FrameHtmlName";
  
  // CX^X
  var execIdxFrame = new NodeControl(EXEC_IDX_FRAME, WINDOW_EXEC, EXEC_IDX_FRAME, null, true, true);
  var execIndexFile = new ElementControl(EXEC_INDEX_FILE, WINDOW_EXEC, EXEC_INDEX_FILE, "index", false, false);
  var execContentsFile = new ElementControl(EXEC_CONTENTS_FILE, WINDOW_EXEC, EXEC_CONTENTS_FILE, "contents", false, false);
  var execHtmlCheck = new ElementControl(EXEC_HTML_CHECK, WINDOW_EXEC, EXEC_HTML_CHECK, true, false, false);
  var execHtmlFile = new ElementControl(EXEC_HTML_FILE, WINDOW_EXEC, EXEC_HTML_FILE, "frame", false, false);
  
  execIndexFile.setPattern(/^[\w\d_]*$/);
  execContentsFile.setPattern(/^[\w\d_]*$/);
  execHtmlFile.setPattern(/^[\w\d_]*$/);
  
  // 
  execIdxFrame.judgeState = function()
    {
    var isWritable = execWriteCheck.getValue();
    var createIndex = execIdxCheck.getValue();
    this.setDisplay(isWritable && createIndex);
    };
  execIndexFile.judgeState = function()
    {
    var isWritable = execWriteCheck.getValue();
    var createIndex = execIdxCheck.getValue();
    this.setDisabled(!isWritable || !createIndex);
    };
  execContentsFile.judgeState = function()
    {
    var isWritable = execWriteCheck.getValue();
    var createIndex = execIdxCheck.getValue();
    this.setDisabled(!isWritable || !createIndex);
    };
  execHtmlCheck.judgeState = function()
    {
    var isWritable = execWriteCheck.getValue();
    var createIndex = execIdxCheck.getValue();
    this.setDisabled(!isWritable || !createIndex);
    };
  execHtmlFile.judgeState = function()
    {
    var isWritable = execWriteCheck.getValue();
    var createIndex = execIdxCheck.getValue();
    var createFrame = execHtmlCheck.getValue();
    this.setDisabled(!isWritable || !createIndex || !createFrame);
    };
  
  // Cxg
  execHtmlCheck.onclick = function()
    {
    execHtmlFile.judgeState();
    };
  
  //------------------------------------------------------------------------------
  // Cj[ - Jn
  
  // id
  var MAIN_MENU_START = "MainMenu_Start";
  
  // CX^X
  var mainMenuStart = new ElementControl(MAIN_MENU_START, WINDOW_MENU, MAIN_MENU_START, "쐬Jn", false, false);
  
  // 
  mainMenuStart.judgeState = function()
    {
    logGui.trace("mainMenuStart.judgeState() - begin - ");
    var state = stateAll.getState();
    var usable = false;
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        usable = true;
        break;
      case EventState.Static.STATE_READY:
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
        usable = false;
        break;
      case EventState.Static.STATE_END:
        usable = true;
        break;
      default:
      }
    this.setDisabled(!usable);
    logGui.trace("mainMenuStart.judgeState() - end - ");
    };
  
  // Cxg
  mainMenuStart.onclick = function()
    {
    startCompile();
    };
  
  //------------------------------------------------------------------------------
  // Cj[ - ~
  
  // id
  var MAIN_MENU_STOP = "MainMenu_Stop";
  
  // CX^X
  var mainMenuStop = new ElementControl(MAIN_MENU_STOP, WINDOW_MENU, MAIN_MENU_STOP, "f", false, true);
  
  // 
  mainMenuStop.judgeState = function()
    {
    logGui.trace("mainMenuStop.judgeState() - begin - ");
    var state = stateAll.getState();
    var usable = false;
    switch(state)
      {
      case EventState.Static.STATE_NULL:
      case EventState.Static.STATE_IDLE:
        usable = false;
        break;
      case EventState.Static.STATE_READY:
      case EventState.Static.STATE_RUNNING:
      case EventState.Static.STATE_PAUSE:
        usable = true;
        break;
      case EventState.Static.STATE_END:
        usable = false;
        break;
      default:
      }
    this.setDisabled(!usable);
    logGui.trace("mainMenuStop.judgeState() - end - ");
    };
  
  // Cxg
  mainMenuStop.onclick = function()
    {
    stateAll.stop();
    };
  
  //------------------------------------------------------------------------------
  // Cj[ - O\
  
  // id
  var MAIN_MENU_DISP_LOG = "MainMenu_DisplayLog";
  
  // CX^X
  var mainMenuDispLog = new NodeControl(MAIN_MENU_DISP_LOG, WINDOW_MENU, MAIN_MENU_DISP_LOG, "ؑ", true, true);
  
  // Cxg
  mainMenuDispLog.onmouseover = function()
    {
    var obj = this.getObject();
    if(obj)
      {
      obj.style.textDecoration = "underline";
      }
    };
  mainMenuDispLog.onmouseout = function()
    {
    var obj = this.getObject();
    if(obj)
      {
      obj.style.textDecoration = "none";
      }
    };
  mainMenuDispLog.onclick = function()
    {
    logGui.trace("mainMenuDispLog.onclick() - begin - ");
    var state = stateAll.getState();
    if((state != EventState.Static.STATE_READY) && (state != EventState.Static.STATE_RUNNING))
      {
      var dispTypes = [0, 2, 3];
      var type = frameDisplayIndex;
      var next = -1;
      for(var i = 0; i < dispTypes.length; i++)
        {
        if(type == dispTypes[i])
          {
          i++;
          i %= dispTypes.length;
          next = dispTypes[i];
          break;
          }
        }
      if(next < 0)
        {
        next = 3;
        }
      changeFrameDisplay(next);
      }
    logGui.trace("mainMenuDispLog.onclick() - end - ");
    };
  
  //------------------------------------------------------------------------------
  // Cj[ - Oۑ
  
  // id
  var MAIN_MENU_SAVE_LOG = "MainMenu_SaveLog";
  
  // CX^X
  var mainMenuSaveLog = new NodeControl(MAIN_MENU_SAVE_LOG, WINDOW_MENU, MAIN_MENU_SAVE_LOG, "ۑ", true, true);
  
  // Cxg
  mainMenuSaveLog.onmouseover = function()
    {
    var obj = this.getObject();
    if(obj)
      {
      obj.style.textDecoration = "underline";
      }
    };
  mainMenuSaveLog.onmouseout = function()
    {
    var obj = this.getObject();
    if(obj)
      {
      obj.style.textDecoration = "none";
      }
    };
  mainMenuSaveLog.onclick = function()
    {
    var date = new Date();
    var y = date.getFullYear();
    var m = date.getMonth() + 1;
    var d = date.getDate();
    var H = date.getHours();
    var M = date.getMinutes();
    var S = date.getSeconds();
    function zero2str(num)
      {
      return ((num < 10) ? "0" : "") + num;
      }
    var name = "compile" + y + zero2str(m) + zero2str(d) + zero2str(H) + zero2str(M) + zero2str(S) + ".log";
    window[WINDOW_LOGS].document.execCommand("SaveAs", true, name);
    };
  
  //------------------------------------------------------------------------------
  // Cj[ - O
  
  // id
  var MAIN_MENU_CLEAR_LOG = "MainMenu_ClearLog";
  
  // CX^X
  var mainMenuClearLog = new NodeControl(MAIN_MENU_CLEAR_LOG, WINDOW_MENU, MAIN_MENU_CLEAR_LOG, "", true, true);
  
  // Cxg
  mainMenuClearLog.onmouseover = function()
    {
    var obj = this.getObject();
    if(obj)
      {
      obj.style.textDecoration = "underline";
      }
    };
  mainMenuClearLog.onmouseout = function()
    {
    var obj = this.getObject();
    if(obj)
      {
      obj.style.textDecoration = "none";
      }
    };
  mainMenuClearLog.onclick = function()
    {
    window[WINDOW_LOGS].document.close();
    window[WINDOW_LOGS].location.replace("about:blank");
    };
  
  //------------------------------------------------------------------------------
  // Cj[ - bZ[W
  
  // id
  var MESSAGE_AREA = "MessageArea";
  
  // CX^X
  var messageArea = new ElementControl(MESSAGE_AREA, WINDOW_MENU, MESSAGE_AREA, "", true, false);
  
  //##############################################################################
  //
  // pCxg\bh
  //
  
  //------------------------------------------------------------------------------
  // bZ[Wo
  function Msg(msg)
    {
    messageArea.setValue(msg);
    // status = msg;
    // alert(msg);
    // WScript.Echo(msg);
    }
  
  // bZ[Wǉ
  function MsgAdd(msg)
    {
    Msg(messageArea.getValue() + msg);
    }
  
  //------------------------------------------------------------------------------
  // p[^[擾
  function getInitParam(key)
    {
    var initValue;
    if((typeof initParams) == "object")
      {
      initValue = initParams[key];
      }
    return initValue;
    }
  
  //------------------------------------------------------------------------------
  // t[ύX\
  
  // Ǘԍ
  var frameDisplayIndex = 0;
  
  // t[(id)
  var FRAME   = "FRAME";
  var MAIN    = "MAIN";
  var SETTING = "SETTING";
  var OPTIONS = "OPTIONS";
  
  // t[`
  var frameDisplayDefinitions = [];
  // ftHg
  frameDisplayDefinitions[0] = {};
  frameDisplayDefinitions[0][FRAME] = "40,*";
  frameDisplayDefinitions[0][MAIN] = "100%,0%";
  frameDisplayDefinitions[0][SETTING] = "30%,70%";
  frameDisplayDefinitions[0][OPTIONS] = "55%,45%";
  // s
  frameDisplayDefinitions[1] = {};
  frameDisplayDefinitions[1][MAIN] = "50%,50%";
  frameDisplayDefinitions[1][SETTING] = "30%,70%";
  frameDisplayDefinitions[1][OPTIONS] = "0%,100%";
  // Sĕ\
  frameDisplayDefinitions[2] = {};
  frameDisplayDefinitions[2][MAIN] = "50%,50%";
  frameDisplayDefinitions[2][SETTING] = "30%,70%";
  frameDisplayDefinitions[2][OPTIONS] = "55%,45%";
  // Ôݕ\
  frameDisplayDefinitions[3] = {};
  frameDisplayDefinitions[3][MAIN] = "0%,100%";
  
  // t[ύX
  function changeFrameDisplay(index)
    {
    logGui.trace("changeFrameDisplay() - begin - ", index);
    // 
    if((typeof index) == "number")
      {
      frameDisplayIndex = index;
      }
    if(frameDisplayDefinitions.length > 0)
      {
      if(frameDisplayIndex < 0)
        {
        frameDisplayIndex %= frameDisplayDefinitions.length;
        frameDisplayIndex += frameDisplayDefinitions.length;
        }
      else if(frameDisplayDefinitions.length <= frameDisplayIndex)
        {
        frameDisplayIndex %= frameDisplayDefinitions.length;
        }
      // ύX
      logGui.debug("t[ύX܂B", "frameDisplayIndex=", frameDisplayIndex);
      var def = frameDisplayDefinitions[frameDisplayIndex];
      var obj = null;
      if(def[FRAME])
        {
        obj = top.document.getElementById(FRAME);
        if(obj)
          {
          obj.rows = def[FRAME];
          }
        }
      if(def[MAIN])
        {
        obj = top.document.getElementById(MAIN);
        if(obj)
          {
          obj.rows = def[MAIN];
          }
        }
      if(def[SETTING])
        {
        obj = top.document.getElementById(SETTING);
        if(obj)
          {
          obj.cols = def[SETTING];
          }
        }
      if(def[OPTIONS])
        {
        obj = top.document.getElementById(OPTIONS);
        if(obj)
          {
          obj.rows = def[OPTIONS];
          }
        }
      }
    logGui.trace("changeFrameDisplay() - end - ");
    }
  
  //------------------------------------------------------------------------------
  // RpC
  
  // RpCΏ
  var targets = null;
  // RpCΏ(pbP[W`t@C)
  var definitions = null;
  // RpC
  var cond = null;
  // RpC
  var compiler = null;
  // XMLIuWFNg
  var xmlObjs = null;
  // XMLIuWFNg(pbP[W`t@C)
  var xmlDefs = null;
  // CfbNXRpC
  var indexCompiler = null;
  
  // (RpC)̊Jn
  function startCompile()
    {
    logEvt.trace("startCompile() - begin - ");
    Msg("Jn܂...");
    //--------------------------------------
    // 000.RpCΏ
    var _target = null;
    // 001.RpCΏ(pbP[W`t@C)
    var _targetDef = null;
    //--------------------------------------
    // RpC
    // 131.XMLOԖ
    var _xmlnsName = null;
    // 132.XMLOURI
    var _xmlnsUri = null;
    // 101.CfbNX()
    var _indexFile = null;
    // 102.CfbNX(\)
    var _contentsFile = null;
    // 103.CfbNX(HTML)
    var _frameHtml = null;
    // 140.N^O
    var _links = [];
    // 150.pbP[W`t@C
    var _define = {};
    // 154.pbP[W`t@C̃IvV
    var _defOpts = {};
    // 160.x[XfBNg
    var _base = {};
    // 161.x[XfBNg̊gq
    var _baseExt = {};
    // 140.NNX
    function _LinkNode(rel, rev, type, media, href, target, cSet, hrefln)
      {
      this.rel      = rel    ? rel    : null;
      this.rev      = rev    ? rev    : null;
      this.type     = type   ? type   : null;
      this.media    = media  ? media  : null;
      this.href     = href   ? href   : null;
      this.target   = target ? target : null;
      this.charset  = cSet   ? cSet   : null;
      this.hreflang = hrefln ? hrefln : null;
      return this;
      }
    _LinkNode.prototype.toString = function()
      {
      var str = '<link';
      if(this.rel)
        {
        str += ' rel="' + this.rel + '"';
        }
      if(this.rev)
        {
        str += ' rev="' + this.rev + '"';
        }
      if(this.type)
        {
        str += ' type="' + this.type + '"';
        }
      if(this.media)
        {
        str += ' media="' + this.media + '"';
        }
      if(this.href)
        {
        str += ' href="' + this.href + '"';
        }
      if(this.target)
        {
        str += ' target="' + this.target + '"';
        }
      if(this.charset)
        {
        str += ' charset="' + this.charset + '"';
        }
      if(this.hreflang)
        {
        str += ' hreflang="' + this.hreflang + '"';
        }
      str += '/>';
      return str;
      };
    //--------------------------------------
    // s
    // 211.[gpbP[W
    var _rootPackage = null;
    // 212.fvCtH_
    var _deployFolder = null;
    // 231.񓯊s
    var _asyncExec = null;
    // 232.VKRpC
    var _isNewCompile = null;
    // 221.ۑ@
    var _savingWay = null;
    // 222.R[h
    var _encoding = null;
    // 223.sR[h
    var _lineSeparator = null;
    // 224.gq
    var _extension = null;
    // 240.Ox
    var _logLevel = null;
    // 233.RpCs
    var _execCompile = null;
    // 234.RlNVs
    var _execConnect = null;
    // 235.Ns
    var _execLink = null;
    // 236.ݎs
    var _execWrite = null;
    // 237.XSLϊs
    var _execXslt = null;
    // 251.XSLϊ
    var _execXslType = null;
    // 252.XSLϊt@C
    var _execXslFile = null;
    // 253.XSLt@CRs[
    var _execXslCopy = null;
    //--------------------------------------
    // l̎擾ƃ`FbN
    function varidate()
      {
      logEvt.trace("startCompile().varidate() - begin - ");
      var temp, answer = true;
      // 231.񓯊s
      _asyncExec = asyncCheck.getValue();
      logEvt.info("񓯊s=", _asyncExec);
      // 232.VKRpC
      _isNewCompile = newCompile.getValue();
      logEvt.info("VKRpC=", _isNewCompile);
      // VK/p̃`FbN
      if(!_isNewCompile && (!targets || !cond || !compiler || !xmlObjs))
        {
        answer = false;
        logEvt.error("RpCς݂̃f[^݂Ȃ̂ŁAuVKRpCvIȂ΂Ȃ܂B");
        }
      // 000.RpCΏ
      temp = selectTree.getItems(true, true);
      if(temp && (temp.length > 0))
        {
        logEvt.info("ΏۃNX́Av", temp.length, "NX");
        _target = [];
        for(var i = 0; i < temp.length; i++)
          {
          _target[i] = temp[i].getValue();
          logEvt.debug("ΏۃNX", "[", i, "]=", _target[i]);
          }
        // ΏۃZbg
        if(_isNewCompile)
          {
          targets = _target;
          }
        // `FbN
        else if(targets)
          {
          for(var i = 0; i < _target.length; i++)
            {
            temp = false;
            for(var j = 0; j < targets.length; j++)
              {
              if(_target[i] == targets[j])
                {
                temp = true;
                break;
                }
              }
            if(!temp)
              {
              answer = false;
              logEvt.error("ÕRpCΏۂɊ܂܂ȂNXIĂ܂B", _target[i]);
              }
            }
          }
        }
      else
        {
        answer = false;
        logEvt.warn("ΏۃNXP܂B");
        }
      // 130.XMLO
      if(xmlnsUsing.getValue())
        {
        // 131.XMLOԖ
        if(xmlnsName.varidate())
          {
          _xmlnsName = xmlnsName.getValue();
          logEvt.debug("XMLOԖ=", _xmlnsName);
          }
        else
          {
          answer = false;
          logEvt.warn("XMLOԖ܂B");
          }
        // 132.XMLOURI
        if(xmlnsUri.varidate())
          {
          _xmlnsUri = xmlnsUri.getValue();
          logEvt.debug("XMLOURI=", _xmlnsUri);
          }
        else
          {
          answer = false;
          logEvt.warn("XMLOURI܂B");
          }
        // 130.O+URI
        if(_xmlnsName || _xmlnsUri)
          {
          logEvt.info("xmlns:", _xmlnsName, "=\"", _xmlnsUri, "\"");
          }
        }
      // 100.CfbNX
      if(execIdxCheck.getValue())
        {
        // 101.CfbNX()
        if(execIndexFile.varidate())
          {
          _indexFile = execIndexFile.getValue();
          logEvt.debug("t@C=", _indexFile);
          }
        else
          {
          answer = false;
          logEvt.warn("t@C܂B");
          }
        // 102.CfbNX(\)
        if(execContentsFile.varidate())
          {
          _contentsFile = execContentsFile.getValue();
          logEvt.debug("\t@C=", _contentsFile);
          }
        else
          {
          answer = false;
          logEvt.warn("\t@C܂B");
          }
        // 103.CfbNX(HTML)
        if(execHtmlCheck.getValue())
          {
          if(execHtmlFile.varidate())
            {
            _frameHtml = execHtmlFile.getValue();
            logEvt.debug("t[HTML=", _frameHtml);
            }
          else
            {
            answer = false;
            logEvt.warn("t[HTMLt@C܂B");
            }
          }
        }
      // 140.N^O
      var u = 0;
      for(var i = 0; i < linkNodes.length; i++)
        {
        var linkObj = linkNodes[i];
        if(linkObj)
          {
          u++;
          }
        if(linkObj && linkObj.enable.getValue())
          {
          temp = true;
          // 141.rel
          if(!linkObj.rel.varidate())
            {
            temp = false;
            logEvt.warn("N^Orel܂B");
            }
          // 142.rev
          if(!linkObj.rev.varidate())
            {
            temp = false;
            logEvt.warn("N^Orev܂B");
            }
          // 143.type
          if(!linkObj.type.varidate())
            {
            temp = false;
            logEvt.warn("N^Otype܂B");
            }
          // 144.media
          if(!linkObj.media.varidate())
            {
            temp = false;
            logEvt.warn("N^Omedia܂B");
            }
          // 145.href
          if(!linkObj.href.varidate())
            {
            temp = false;
            logEvt.warn("N^Ohref܂B");
            }
          // 146.target
          if(!linkObj.target.varidate())
            {
            temp = false;
            logEvt.warn("N^Otarget܂B");
            }
          // 147.charset
          if(!linkObj.charset.varidate())
            {
            temp = false;
            logEvt.warn("N^Ocharset܂B");
            }
          // 148.hreflang
          if(!linkObj.hreflang.varidate())
            {
            temp = false;
            logEvt.warn("N^Ohreflang܂B");
            }
          // 140.m[h񐶐
          if(temp)
            {
            temp = new _LinkNode(linkObj.rel.getValue(), linkObj.rev.getValue(), linkObj.type.getValue(), linkObj.media.getValue(), linkObj.href.getValue(), linkObj.target.getValue(), linkObj.charset.getValue(), linkObj.hreflang.getValue());
            _links[_links.length] = temp;
            logEvt.info("N^O=", temp.toString());
            }
          else
            {
            answer = false;
            logEvt.warn("N^O̓e܂B", "iォ", (u + 1), "Ԗځj", "CfbNX=[", i, "]");
            }
          }
        }
      // 150.pbP[W`t@C
      var u = 0;
      for(var i = 0; i < defFileNodes.length; i++)
        {
        var defObj = defFileNodes[i];
        if(defObj)
          {
          u++;
          }
        if(defObj && defObj.enable.getValue())
          {
          temp = true;
          // 151.pbP[W
          if(!defObj.pkg.varidate())
            {
            temp = false;
            logEvt.warn("pbP[W`t@C̃pbP[WI܂B");
            }
          // 152.pbP[W`t@C
          if(!defObj.fileName.varidate())
            {
            temp = false;
            logEvt.warn("pbP[W`t@C̃t@C܂B");
            }
          // 154.pbP[W`t@C̃IvV
          if(!defObj.options.varidate())
            {
            temp = false;
            logEvt.warn("pbP[W`t@C̃IvV܂B");
            }
          // 150.񐶐
          if(temp)
            {
            temp = defObj.pkg.getValue();
            _define[temp] = defObj.fileName.getValue();
            _defOpts[temp] = defObj.options.getValue();
            logEvt.info("pbP[W`t@C - ", temp, "=\"", _define[temp], "\" (", _defOpts[temp], ")");
            }
          else
            {
            answer = false;
            logEvt.warn("pbP[W`t@C̓e܂B", "iォ", (u + 1), "Ԗځj", "CfbNX=[", i, "]");
            }
          }
        }
      // 001.RpCΏ(pbP[W`t@C)
      if(_target && _define)
        {
        _targetDef = [];
        for(var i in _define)
          {
          for(var j = 0; j < _target.length; j++)
            {
            if((_target[j].indexOf((i + "."), 0) == 0) || ((i == "this") && (_target[j].indexOf(".", 0) < 0)))
              {
              _targetDef[_targetDef.length] = _define[i];
              break;
              }
            }
          }
        // ΏۃZbg
        if(_isNewCompile)
          {
          definitions = _targetDef;
          }
        // `FbN
        else if(definitions)
          {
          for(var i = 0; i < _targetDef.length; i++)
            {
            temp = false;
            for(var j = 0; j < definitions.length; j++)
              {
              if(_targetDef[i] == definitions[j])
                {
                temp = true;
                break;
                }
              }
            if(!temp)
              {
              answer = false;
              logEvt.error("ÕRpCΏۂɊ܂܂ȂpbP[W`t@CIĂ܂B", _targetDef[i]);
              }
            }
          }
        }
      else
        {
        answer = false;
        logEvt.warn("ΏۃNXA܂̓pbP[W`t@CP܂B");
        }
      // 160.x[XfBNg
      var u = 0;
      for(var i = 0; i < deployNodes.length; i++)
        {
        var deploy = deployNodes[i];
        if(deploy)
          {
          u++;
          }
        if(deploy && deploy.enable.getValue())
          {
          temp = true;
          // 161.pbP[W
          if(!deploy.pkg.varidate())
            {
            temp = false;
            logEvt.warn("fvCx[XfBNg̃pbP[WI܂B");
            }
          // 162.fvCfBNg
          if(!deploy.directory.varidate())
            {
            temp = false;
            logEvt.warn("fvCx[XfBNg̃fBNg܂B");
            }
          // 163.gq
          if(!deploy.extension.varidate())
            {
            temp = false;
            logEvt.warn("fvCx[XfBNg̊gq܂B");
            }
          // 150.񐶐
          if(temp)
            {
            temp = deploy.pkg.getValue();
            if(temp == "this")
              {
              temp = "";
              }
            _base[temp]    = deploy.directory.getValue();
            _baseExt[temp] = deploy.extension.getValue();
            logEvt.info("fvCx[XfBNg - ", (temp ? temp : "O[oIuWFNg"), "=\"", _base[temp], "\"", "FΉgq=", _baseExt[temp]);
            }
          else
            {
            answer = false;
            logEvt.warn("fvCx[XfBNg̓e܂B", "iォ", (u + 1), "Ԗځj", "CfbNX=[", i, "]");
            }
          }
        }
      // 211.[gpbP[W
      if(rootPackage.varidate())
        {
        _rootPackage = rootPackage.getValue();
        logEvt.info("[gpbP[W=", _rootPackage);
        }
      else
        {
        answer = false;
        logEvt.warn("[gpbP[W̑I܂B");
        }
      // 212.fvCtH_
      if(rootDirectory.varidate())
        {
        _deployFolder = rootDirectory.getValue();
        logEvt.info("zutH_=", _deployFolder);
        }
      else
        {
        answer = false;
        logEvt.warn("zutH_̓e܂B");
        }
      // 221.ۑ@
      if(savingWay.varidate())
        {
        _savingWay = savingWay.getValue();
        logEvt.info("ۑ@=", _savingWay);
        }
      else
        {
        answer = false;
        logEvt.warn("ۑ@̑I܂B");
        }
      // 222.R[h
      if(encoding.varidate())
        {
        _encoding = encoding.getValue();
        logEvt.info("R[h=", _encoding);
        }
      else
        {
        answer = false;
        logEvt.warn("R[h̑I܂B");
        }
      // 223.sR[h
      if(lineSeparator.varidate())
        {
        _lineSeparator = lineSeparator.getValue();
        logEvt.info("sR[h=", _lineSeparator);
        }
      else
        {
        answer = false;
        logEvt.warn("sR[h̑I܂B");
        }
      // 224.gq
      if(fileExtension.varidate())
        {
        _extension = fileExtension.getValue();
        logEvt.info("gq=", _extension);
        }
      else
        {
        answer = false;
        logEvt.warn("gq̓͂܂B");
        }
      // 240.Ox
      if(logLevel.varidate())
        {
        _logLevel = logLevel.getValue();
        logEvt.info("Ox=", _logLevel);
        }
      else
        {
        answer = false;
        logEvt.warn("Ox̑I܂B");
        }
      // 233.RpCs
      _execCompile = execCompileCheck.getValue();
      logEvt.info("RpCs=", _execCompile);
      // 234.RlNVs
      _execConnect = execConnectCheck.getValue();
      logEvt.info("RlNVs=", _execConnect);
      // 235.Ns
      _execLink = execLinkCheck.getValue();
      logEvt.info("Ns=", _execLink);
      // 236.ݎs
      _execWrite = execWriteCheck.getValue();
      logEvt.info("ݎs=", _execWrite);
      // 237.XSLϊs
      _execXslt = execXslCheck.getValue();
      logEvt.info("XSLϊs=", _execXslt);
      if(_execXslt)
        {
        // 251.XSLϊ
        if(execXslTypeO.getValue())
          {
          _execXslType = "Order";
          logEvt.info("XSLϊ=", _execXslType);
          }
        else if(execXslTypeR.getValue())
          {
          _execXslType = "Result";
          logEvt.info("XSLϊ=", _execXslType);
          }
        else
          {
          answer = false;
          logEvt.info("XSLϊނIĂ܂B");
          }
        // 252.XSLϊt@C
        if(execXslSelect.varidate())
          {
          temp = execXslSelect.getValue();
          if(temp)
            {
            var xslMap = getInitParam("xsl");
            _execXslFile = xslMap[temp].file;
            logEvt.info("XSLϊt@C=", _execXslFile);
            // 253.XSLt@CRs[
            if(_execXslType == "Order")
              {
              _execXslCopy = [_execXslFile];
              temp = xslMap[temp].copy;
              if(temp && ((typeof temp) == "string"))
                {
                _execXslCopy[_execXslCopy.length] = temp;
                }
              else if(temp instanceof Array)
                {
                for(var i = 0; i < temp.length; i++)
                  {
                  if(temp[i] && ((typeof temp[i]) == "string"))
                    {
                    _execXslCopy[_execXslCopy.length] = temp[i];
                    }
                  }
                }
              }
            else
              {
              _execXslCopy = null;
              }
            logEvt.info("XSLt@CRs[Ώ=", _execXslCopy);
            }
          else if(execXslFile.varidate())
            {
            _execXslFile = execXslFile.getValue();
            logEvt.info("XSLϊt@C=", _execXslFile);
            }
          else
            {
            answer = false;
            logEvt.warn("XSLϊt@C̓e܂B");
            }
          }
        else
          {
          answer = false;
          logEvt.warn("XSLϊt@C̑I܂B");
          }
        }
      // l̃`FbNƎ擾̏I
      logEvt.trace("startCompile().varidate() - end - ", answer);
      return answer;
      }
    //--------------------------------------
    // RpC
    function createCondition()
      {
      logEvt.trace("startCompile().createCondition() - begin - ");
      var cond = new jsd.compiler.CompileCondition();
      cond.setExtension(_extension);
      jsd.compiler.AbstractCompiler.Static.XML_NAMESPACE = _xmlnsName;
      jsd.compiler.ClassCompiler.Static.XMLNS_URI = _xmlnsUri;
      if(_indexFile)
        {
        var iFile = new File(_indexFile);
        iFile.addExtension(_extension);
        cond.setIndexUri(iFile.getName());
        }
      if(_contentsFile)
        {
        var cFile = new File(_contentsFile);
        cFile.addExtension(_extension);
        cond.setContentsUri(cFile.getName());
        }
      for(var i in _define)
        {
        cond.setDefinitionFile(i, _define[i]);
        if(i == "this")
          {
          (function(cond)
            {
            var getDefinitionFile = cond.getDefinitionFile;
            cond.getDefinitionFile = function(name)
              {
              switch(name)
                {
                case "this":
                case "Object":
                case "Function":
                case "Boolean":
                case "Number":
                case "String":
                case "Array":
                case "RegExp":
                case "Date":
                case "Error":
                case "EvalError":
                case "RangeError":
                case "ReferenceError":
                case "SyntaxError":
                case "TypeError":
                case "URIError":
                case "Math":
                  return getDefinitionFile.call(cond, "this");
                default:
                  return getDefinitionFile.apply(cond, arguments);
                }
              };
            }
          )(cond);
          }
        }
      for(var i in _defOpts)
        {
        cond.setDefinitionOptions(i, _defOpts[i]);
        }
      for(var i in _base)
        {
        cond.setBaseDirectory(i, _base[i], _baseExt[i]);
        }
      logEvt.trace("startCompile().createCondition() - end - ", cond);
      return cond;
      }
    //--------------------------------------
    // CX^X
    function createInstance(cond)
      {
      logEvt.trace("startCompile().createInstance() - begin - ");
      var ins = new jsd.compiler.Compiler(cond);
      for(var i = 0; i < _target.length; i++)
        {
        ins.addTarget(_target[i]);
        }
      logEvt.trace("startCompile().createInstance() - end - ", ins);
      return ins;
      }
    //--------------------------------------
    // CfbNX
    function createIndex()
      {
      logEvt.trace("startCompile().createIndex() - begin - ");
      var ins = new jsd.compiler.IndexCompiler();
      for(var i in _define)
        {
        var def = _define[i];
        if(def && ((typeof def) == "string"))
          {
          ins.putDefinition(i, def);
          }
        }
      logEvt.trace("startCompile().createIndex() - end - ", ins);
      return ins;
      }
    //--------------------------------------
    // RpCs
    function executeCompile()
      {
      logEvt.trace("startCompile().executeCompile() - begin - ");
      try
        {
        var check = null;
        var index = stateCompile.getCount();
        // NXRpC
        if(check == null)
          {
          if(index < _target.length)
            {
            check = executeCompileClass(index);
            }
          else
            {
            index -= _target.length;
            }
          }
        // pbP[W`t@CRpC
        if(check == null)
          {
          if(index < _targetDef.length)
            {
            check = executeCompileDefinition(index);
            }
          else
            {
            index -= _targetDef.length;
            }
          }
        // ps
        if(check)
          {
          stateCompile.step();
          }
        else
          {
          stateCompile.stop();
          }
        }
      catch(e)
        {
        stateCompile.stop();
        logEvt.fatal("RpCɃG[܂B", e.message);
        MsgAdd("\r\nG[܂BOmFĂB");
        }
      logEvt.trace("startCompile().executeCompile() - end - ");
      }
    //--------------------------------------
    // RpC(NX)s
    function executeCompileClass(index)
      {
      logEvt.trace("startCompile().executeCompileClass() - begin - ", index);
      var isSuccess = false;
      if((targets != _target) && (targets[index] != _target[index]))
        {
        for(var i = 0; i < targets.length; i++)
          {
          if(targets[i] == _target[index])
            {
            index = i;
            break;
            }
          }
        }
      // RpC
      logEvt.info("RpCs܂B", "index=", index, "/Ώ=", targets[index]);
      Msg("RpC[" + (stateCompile.getCount() + 1) + "]=" + targets[index]);
      xmlObjs[index] = compiler.compile(index);
      if(xmlObjs[index] && xmlObjs[index].documentElement)
        {
        // R[hݒiRpCj
        xmlObjs[index].documentDeclaration.setAttribute("encoding", _encoding);
        // ݈ʒu̓
        var relFile = targets[index];
        if(_rootPackage && (_rootPackage != "this") && (relFile.indexOf(_rootPackage, 0) == 0))
          {
          relFile = relFile.substring(_rootPackage.length, relFile.length);
          }
        relFile = relFile.replace(/\./g, Path.DIRECTORY_TOKEN);
        if(relFile.charAt(0) == Path.DIRECTORY_TOKEN)
          {
          relFile = "." + relFile;
          }
        var fileRef = new Reference(clsBase.toString());
        fileRef.setPath(fileRef.getPath().getAbsolutePath(new Path(relFile)));
        fileRef.getPath().getFile().addExtension(_extension);
        xmlObjs[index].path = fileRef;
        logEvt.info("ݗ\F", fileRef.toString());
        isSuccess = true;
        logEvt.info("RpCI܂B", "ʁF");
        }
      else
        {
        isSuccess = false;
        logEvt.error("RpCI܂B", "ʁFs");
        }
      logEvt.trace("startCompile().executeCompileClass() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // RpC(pbP[W`t@C)s
    function executeCompileDefinition(index)
      {
      logEvt.trace("startCompile().executeCompileDefinition() - begin - ", index);
      var isSuccess = false;
      if((definitions != _targetDef) && (definitions[index] != _targetDef[index]))
        {
        for(var i = 0; i < definitions.length; i++)
          {
          if(definitions[i] == _targetDef[index])
            {
            index = i;
            break;
            }
          }
        }
      // RpC
      logEvt.info("RpCs܂B", "index=", index, "/Ώ=", definitions[index]);
      Msg("RpC[" + (stateCompile.getCount() + 1) + "]=" + definitions[index]);
      xmlDefs[index] = compiler.compileDefinition(index);
      if(xmlDefs[index] && xmlDefs[index].documentElement)
        {
        // R[hݒiRpCj
        xmlDefs[index].documentDeclaration.setAttribute("encoding", _encoding);
        // ݈ʒu̓
        var fileRef = new Reference(defBase.toString());
        fileRef.getPath().setFile(new File(definitions[index]));
        fileRef.getPath().getFile().addExtension(_extension);
        xmlDefs[index].path = fileRef;
        logEvt.info("ݗ\F", fileRef.toString());
        isSuccess = true;
        logEvt.info("RpCI܂B", "ʁF");
        }
      else
        {
        isSuccess = false;
        logEvt.error("RpCI܂B", "ʁFs");
        }
      logEvt.trace("startCompile().executeCompileDefinition() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // RlNVs
    function executeConnect()
      {
      logEvt.trace("startCompile().executeConnect() - begin - ");
      try
        {
        var check = null;
        var index = stateConnect.getCount();
        // NXRlNV
        if(check == null)
          {
          if(index < _target.length)
            {
            check = executeConnectClass(index);
            }
          else
            {
            index -= _target.length;
            }
          }
        // ps
        if(check)
          {
          stateConnect.step();
          }
        else
          {
          stateConnect.stop();
          }
        }
      catch(e)
        {
        stateConnect.stop();
        logEvt.fatal("pNɃG[܂B", e.message);
        MsgAdd("\r\nG[܂BOmFĂB");
        }
      logEvt.trace("startCompile().executeConnect() - end - ");
      }
    //--------------------------------------
    // RlNV(NX)s
    function executeConnectClass(index)
      {
      logEvt.trace("startCompile().executeConnectClass() - begin - ", index);
      var isSuccess = false;
      if((targets != _target) && (targets[index] != _target[index]))
        {
        for(var i = 0; i < targets.length; i++)
          {
          if(targets[i] == _target[index])
            {
            index = i;
            break;
            }
          }
        }
      logEvt.info("pNs܂B", "index=", index, "/Ώ=", targets[index]);
      Msg("pN[" + (stateConnect.getCount() + 1) + "]=" + targets[index]);
      compiler.connect(index);
      isSuccess = true;
      logEvt.info("pNI܂B");
      logEvt.trace("startCompile().executeConnectClass() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // link^OɃN쐬
    function createLink(xmlDoc)
      {
      logEvt.trace("startCompile().createLink() - begin - ", xmlDoc);
      var links = xmlDoc.getElementsByTagName("link");
      for(var i = 0; i < links.length; i++)
        {
        var rel = links[i].getAttribute("rel");
        var targetRef = null;
        switch(rel)
          {
          case "DefinitionFile":
            var name = links[i].getAttribute("name");
            if(name)
              {
              for(var d = 0; d < definitions.length; d++)
                {
                if(definitions[d] == name)
                  {
                  targetRef = xmlDefs[d].path;
                  break;
                  }
                }
              }
            break;
          case "Index":
            targetRef = indexRef;
            break;
          case "Contents":
            targetRef = toppgRef;
            break;
          default:
          }
        if(targetRef)
          {
          var href;
          if((targetRef.getProtocol() == xmlDoc.path.getProtocol()) && (("" + targetRef.getHost()) == ("" + xmlDoc.path.getHost())))
            {
            href = new Reference();
            href.setPath(xmlDoc.path.getPath().getRelativePath(targetRef.getPath()));
            }
          else
            {
            href = targetRef.getURL();
            }
          href.getPath().token = Path.DIRECTORY_TOKEN;
          links[i].setAttribute("href", href.toString());
          }
        }
      logEvt.trace("startCompile().createLink() - end - ");
      }
    //--------------------------------------
    // Ns
    function executeLink()
      {
      logEvt.trace("startCompile().executeLink() - begin - ");
      try
        {
        var check = null;
        var index = stateLink.getCount();
        // NXN
        if(check == null)
          {
          if(index < _target.length)
            {
            check = !!executeLinkClass(index);
            }
          else
            {
            index -= _target.length;
            }
          }
        // pbP[W`t@CN
        if(check == null)
          {
          if(index < _targetDef.length)
            {
            check = !!executeLinkDefinition(index);
            }
          else
            {
            index -= _targetDef.length;
            }
          }
        // ps
        if(check)
          {
          stateLink.step();
          }
        else
          {
          stateLink.stop();
          }
        }
      catch(e)
        {
        stateLink.stop();
        logEvt.fatal("NɃG[܂B", e.message);
        MsgAdd("\r\nG[܂BOmFĂB");
        }
      logEvt.trace("startCompile().executeLink() - end - ");
      }
    //--------------------------------------
    // N(NX)s
    function executeLinkClass(index)
      {
      logEvt.trace("startCompile().executeLinkClass() - begin - ", index);
      var isSuccess = false;
      if((targets != _target) && (targets[index] != _target[index]))
        {
        for(var i = 0; i < targets.length; i++)
          {
          if(targets[i] == _target[index])
            {
            index = i;
            break;
            }
          }
        }
      // eXML̃N쐬
      logEvt.info("Ns܂B", "index=", index, "/Ώ=", targets[index]);
      Msg("N[" + (stateLink.getCount() + 1) + "]=" + targets[index]);
      createLink(xmlObjs[index]);
      compiler.link(index);
      logEvt.info("NI܂B");
      // CfbNXɒǉ
      if(indexCompiler && _indexFile)
        {
        var href = indexRef.getPath().getRelativePath(xmlObjs[index].path.getPath());
        href.token = Path.DIRECTORY_TOKEN;
        logEvt.info("CfbNX쐬܂B", "NAME=", targets[index], "/HREF=" + href);
        indexCompiler.putClassLink(targets[index], href.toString(), (function()
          {
          switch(targets[index])
            {
            case "this":
            case "Object":
            case "Function":
            case "Boolean":
            case "Number":
            case "String":
            case "Array":
            case "RegExp":
            case "Date":
            case "Error":
            case "EvalError":
            case "RangeError":
            case "ReferenceError":
            case "SyntaxError":
            case "TypeError":
            case "URIError":
            case "Math":
              var defFile = cond.getDefinitionFile("this");
              return defFile ? defFile : undefined;
            default:
              return undefined;
            }
          }
        )());
        logEvt.info("CfbNX̐I܂B");
        }
      isSuccess = true;
      logEvt.trace("startCompile().executeLinkClass() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // N(pbP[W`t@C)s
    function executeLinkDefinition(index)
      {
      logEvt.trace("startCompile().executeLinkDefinition() - begin - ", index);
      var isSuccess = false;
      if((definitions != _targetDef) && (definitions[index] != _targetDef[index]))
        {
        for(var i = 0; i < definitions.length; i++)
          {
          if(definitions[i] == _targetDef[index])
            {
            index = i;
            break;
            }
          }
        }
      // eXML̃N쐬
      logEvt.info("Ns܂B", "index=", index, "/Ώ=", definitions[index]);
      Msg("N[" + (stateLink.getCount() + 1) + "]=" + definitions[index]);
      createLink(xmlDefs[index]);
      // N쐬()
      var classIndexCache = {};
      for(var c = 0; c < targets.length; c++)
        {
        classIndexCache[targets[c]] = c;
        }
      var classes = xmlDefs[index].getElementsByTagName("class-name");
      for(var c = 0; c < classes.length; c++)
        {
        var cls = classes[c];
        var val = cls.firstChild.nodeValue;
        if(val)
          {
          var idx = classIndexCache[val];
          if((typeof idx) == "number")
            {
            var href = new Reference();
            href.setPath(xmlDefs[index].path.getPath().getRelativePath(xmlObjs[idx].path.getPath()));
            href.getPath().token = Path.DIRECTORY_TOKEN;
            cls.setAttribute("href", href.toString());
            }
          }
        }
      classes = xmlDefs[index].getElementsByTagName("define-class");
      for(var c = 0; c < classes.length; c++)
        {
        var cls = classes[c];
        var val = cls.getAttribute("base");
        if(val)
          {
          var idx = classIndexCache[val];
          if((typeof idx) == "number")
            {
            var href = new Reference();
            href.setPath(xmlDefs[index].path.getPath().getRelativePath(xmlObjs[idx].path.getPath()));
            href.getPath().token = Path.DIRECTORY_TOKEN;
            cls.setAttribute("href", href.toString());
            }
          }
        }
      delete classIndexCache;
      // N쐬(܂)
      logEvt.info("NI܂B");
      // CfbNXɒǉ
      if(indexCompiler && _indexFile)
        {
        var href = indexRef.getPath().getRelativePath(xmlDefs[index].path.getPath());
        href.token = Path.DIRECTORY_TOKEN;
        logEvt.info("CfbNX쐬܂B", "NAME=", definitions[index], "/HREF=" + href);
        indexCompiler.putDefinitionLink(definitions[index], href.toString());
        logEvt.info("CfbNX̐I܂B");
        }
      isSuccess = true;
      logEvt.trace("startCompile().executeLinkDefinition() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    //--------------------------------------
    // XSLt@CRs[
    function copyXslFiles()
      {
      logEvt.trace("startCompile().copyXslFiles() - begin - ");
      var newXslRef = null;
      try
        {
        for(var i = 0; i < _execXslCopy.length; i++)
          {
          var file = new Reference(_execXslCopy[i]);
          // Rs[(copy base)
          var cb = new Reference(file.toString());
          if(!cb.isAbsolute())
            {
            var thisRef = new Reference(location.toString());
            thisRef.setPath(thisRef.getPath().getAbsolutePath(cb.getPath()));
            cb = thisRef;
            }
          if(cb.getProtocol())
            {
            if(cb.getProtocol() == "file")
              {
              var dirs = cb.getPath().getDirectories();
              cb.setProtocol(null);
              cb.setDrive(dirs[0]);
              dirs[0] == "";
              cb.getPath().token = Path.FOLDER_TOKEN;
              cb.getPath().setDirectory(dirs.join(Path.FOLDER_TOKEN));
              }
            else
              {
              cb.getPath().token = Path.DIRECTORY_TOKEN;
              }
            }
          else
            {
            cb.getPath().token = Path.FOLDER_TOKEN;
            }
          logEvt.info("XSLt@CRs[[" + i + "](Rs[)=", cb.toString());
          //Rs[(copy target)
          var ct = new Reference(setBase.toString());
          if(file.isAbsolute() || file.getPath().isAbsolute())
            {
            ct.getPath().setFile(file.getPath().getFile() ? new File(file.getPath().getFile().toString()) : null);
            }
          else
            {
            ct.setPath(ct.getPath().getAbsolutePath(file.getPath()));
            }
          ct.getPath().token = Path.FOLDER_TOKEN;
          logEvt.info("XSLt@CRs[[" + i + "](Rs[)=", ct.toString());
          if(i == 0)
            {
            newXslRef = ct.getURL();
            logEvt.info("VRs[XSLt@C̎QƐ=", newXslRef);
            }
          //Rs[
          if(cb.getProtocol())
            {
            logEvt.warn("Rs[ɂ̓[J\[XȊOwł܂BiXLbv܂j", cb);
            }
          else
            {
            TextFileWriter.copy(cb.getPath().toString(), ct.getPath().toString());
            }
          }
        }
      catch(e)
        {
        logEvt.error("XSLt@C̃Rs[ɃG[܂B", e.message);
        }
      logEvt.trace("startCompile().copyXslFiles() - end - ", newXslRef);
      return newXslRef;
      }
    //--------------------------------------
    // ʒu
    var xslRef = null;
    // XSLϊ
    function readyToXslt()
      {
      logEvt.trace("startCompile().readyToXslt() - begin - ");
      var isReady = false;
      xslRef = null;
      if(_execXslCopy)
        {
        xslRef = copyXslFiles();
        }
      else
        {
        try
          {
          var thisRef = new Reference(location.toString());
          var target  = new Reference(_execXslFile);
          if(target.isAbsolute())
            {
            xslRef = target.getURL();
            }
          if(!xslRef)
            {
            thisRef.setPath(thisRef.getPath().getAbsolutePath(target.getPath()));
            xslRef = thisRef;
            //xslRef.getPath.token = Path.FOLDER_TOKEN;
            }
          }
        catch(e)
          {
          xslRef = null;
          logEvt.error("XSL(XML)t@C̃pX͒ɃG[܂B", e.message);
          }
        }
      if(xslRef)
        {
        logEvt.info("XSL(XML)t@CF", xslRef);
        isReady = true;
        }
      else
        {
        logEvt.warn("XSL(XML)t@C̃pXł܂B");
        }
      logEvt.trace("startCompile().readyToXslt() - end - ", isReady);
      return isReady;
      }
    //--------------------------------------
    // XSLϊs
    function executeXslt()
      {
      logEvt.trace("startCompile().executeXslt() - begin - ");
      try
        {
        var check = null;
        var index = stateXsl.getCount();
        // NXRpC
        if(check == null)
          {
          if(index < _target.length)
            {
            check = !!executeXsltClass(index);
            }
          else
            {
            index -= _target.length;
            }
          }
        // pbP[W`t@CRpC
        if(check == null)
          {
          if(index < _targetDef.length)
            {
            check = !!executeXsltDefinition(index);
            }
          else
            {
            index -= _targetDef.length;
            }
          }
        // CfbNXRpC
        if((check == null) && _indexFile)
          {
          if(index == 0)
            {
            check = !!executeXsltIndex();
            }
          index--;
          }
        // RecRpC
        if((check == null) && _contentsFile)
          {
          if(index == 0)
            {
            check = !!executeXsltContents();
            }
          index--;
          }
        // ps
        if(check)
          {
          stateXsl.step();
          }
        else
          {
          stateXsl.stop();
          }
        }
      catch(e)
        {
        stateXsl.stop();
        logEvt.fatal("XSL̓KpɃG[܂B", e.message);
        MsgAdd("\r\nG[܂BOmFĂB");
        }
      logEvt.trace("startCompile().executeXslt() - end - ");
      }
    //--------------------------------------
    // XSLϊ[ʋ@\]s
    function executeXsltAtOne(targetDoc, targetRef, xslRef)
      {
      logEvt.trace("startCompile().executeXsltAtOne() - begin - ", targetDoc, targetRef, xslRef);
      // t@Cʒu(pX)擾
      var fileRef = targetRef.getURL();
      var myXslRef = xslRef.getURL();
      if((myXslRef.getProtocol() == fileRef.getProtocol()) && (("" + myXslRef.getHost()) == ("" + fileRef.getHost())))
        {
        fileRef.setPath(fileRef.getPath().getRelativePath(myXslRef.getPath()));
        myXslRef = fileRef;
        myXslRef.setProtocol(null);
        myXslRef.setHost(null);
        }
      // ߂̒ǉ
      if(_execXslType == "Order")
        {
        logEvt.info("߂ƂXMLX^CV[g(XSL)ݒ肵܂B");
        targetDoc.setDocumentStyleSheet(myXslRef.toString());
        delete targetDoc.toString;
        }
      // XSLϊ
      else if(_execXslType == "Result")
        {
        logEvt.info("w肳ꂽXSLt@CɂXMLϊ܂B");
        var type, xml = null;
        try
          {
          xml = new ActiveXObject("Msxml2.DOMDocument");
          type = 2;
          }
        catch(e)
          {
          try
            {
            xml = new ActiveXObject("MSXML.DOMDocument");
            type = 1;
            }
          catch(e2)
            {
            throw e;
            }
          }
        var xsl = null;
        if(type == 2)
          {
          xsl = new ActiveXObject("Msxml2.DOMDocument");
          }
        else if(type == 1)
          {
          xsl = new ActiveXObject("MSXML.DOMDocument");
          }
        if(xml && xsl)
          {
          xml.async = false;
          xml.resolveExternals = false;
          delete targetDoc.toString;
          if(!xml.loadXML(targetDoc.toString()))
            {
            logEvt.error("XML̉͂Ɏs܂B");
            logEvt.info(targetDoc);
            throw new Error("XML̉͂Ɏs܂B");
            }
          xsl.async = false;
          if(!xsl.load(xslRef.toString()))
            {
            logEvt.error("XSL̃[hɎs܂B");
            logEvt.info(xslRef.toString());
            throw new Error("XSL̃[hɎs܂B");
            }
          var out = xml.transformNode(xsl);
          (function(str)
            {
            if(str.indexOf("<?xml ", 0) == 0)
              {
              var b = str.indexOf("encoding=", 0);
              var d = str.indexOf("?>", 0);
              if((b >= 0) && (b < d))
                {
                b += "encoding=".length;  // point of " or '
                var c = str.charAt(b);
                var e = str.indexOf(c, (b + 1));
                if((e >= 0) && (e < d))
                  {
                  var encoding = str.substring((b + 1), e);
                  if(encoding != _encoding)
                    {
                    str = str.substring(0, (b + 1)) + _encoding + str.substring(e, str.length);
                    }
                  }
                }
              }
            targetDoc.toString = function()
              {
              return str;
              };
            })(out);
          }
        }
      logEvt.trace("startCompile().executeXsltAtOne() - end - ");
      }
    //--------------------------------------
    // XSLϊ(NX)s
    function executeXsltClass(index)
      {
      logEvt.trace("startCompile().executeXsltClass() - begin - ", index);
      var isSuccess = false;
      if((targets != _target) && (targets[index] != _target[index]))
        {
        for(var i = 0; i < targets.length; i++)
          {
          if(targets[i] == _target[index])
            {
            index = i;
            break;
            }
          }
        }
      logEvt.info("XSLKp܂B", "index=", index, "/Ώ=", targets[index]);
      Msg("XSLϊ[" + (stateXsl.getCount() + 1) + "]=" + targets[index]);
      executeXsltAtOne(xmlObjs[index], xmlObjs[index].path, xslRef);
      isSuccess = true;
      logEvt.info("XSL̓KpI܂B");
      logEvt.trace("startCompile().executeXsltClass() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // XSLϊ(pbP[W`t@C)s
    function executeXsltDefinition(index)
      {
      logEvt.trace("startCompile().executeXsltDefinition() - begin - ", index);
      var isSuccess = false;
      if((definitions != _targetDef) && (definitions[index] != _targetDef[index]))
        {
        for(var i = 0; i < definitions.length; i++)
          {
          if(definitions[i] == _targetDef[index])
            {
            index = i;
            break;
            }
          }
        }
      logEvt.info("XSLKp܂B", "index=", index, "/Ώ=", definitions[index]);
      Msg("XSLϊ[" + (stateXsl.getCount() + 1) + "]=" + definitions[index]);
      executeXsltAtOne(xmlDefs[index], xmlDefs[index].path, xslRef);
      isSuccess = true;
      logEvt.info("XSL̓KpI܂B");
      logEvt.trace("startCompile().executeXsltDefinition() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // XSLϊ(CfbNX)s
    function executeXsltIndex()
      {
      logEvt.trace("startCompile().executeXsltIndex() - begin - ");
      logEvt.info("XSLKp܂B", "Ώ=CfbNX");
      Msg("XSLϊ[" + (stateXsl.getCount() + 1) + "]=CfbNX");
      executeXsltAtOne(indexCompiler.getXmlDocument(), indexRef, xslRef);
      isSuccess = true;
      logEvt.info("XSL̓KpI܂B");
      logEvt.trace("startCompile().executeXsltIndex() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // XSLϊ(Rec)s
    function executeXsltContents()
      {
      logEvt.trace("startCompile().executeXsltContents() - begin - ");
      logEvt.info("XSLKp܂B", "Ώ=\t@C");
      Msg("XSLϊ[" + (stateXsl.getCount() + 1) + "]=Rec");
      // TODO executeXsltAtOne(indexCompiler.getXmlDocument(), toppgRef, xslRef);
      isSuccess = true;
      logEvt.info("XSL̓KpI܂B");
      logEvt.trace("startCompile().executeXsltContents() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // ʒu
    var baseRef = null;
    // ʒu(NXt@C)
    var clsBase = null;
    // ʒu(`t@C)
    var defBase = null;
    // ʒu(ݒt@C)
    var setBase = null;
    // t@Cʒu(t[)
    var frameRef = null;
    // t@Cʒu(CfbNX=c[)
    var indexRef = null;
    // t@Cʒu(Rec=gbvy[W)
    var toppgRef = null;
    // ݏ
    function readyToWrite()
      {
      logEvt.trace("startCompile().readyToWrite() - begin - ");
      var initBase = getInitParam("baseDir");
      var thisRef = new Reference(location.toString());
      var folder = _deployFolder;
      if(folder.charAt(folder.length - 1) != Path.FOLDER_TOKEN)
        {
        folder += Path.FOLDER_TOKEN;
        }
      // ʒu
      baseRef = new Reference(folder);
      if(!baseRef.isAbsolute())
        {
        baseRef.setPath(thisRef.getPath().getAbsolutePath(baseRef.getPath()));
        }
      logEvt.debug("zutH_m=", baseRef.toString());
      // ʒu(NXt@C)
      var cf = (initBase && ((typeof initBase.classes) == "string")) ? initBase.classes : ".";
      var cp = (new Reference(cf)).getPath();
      if(cp.isAbsolute())
        {
        cf = ".";
        }
      else
        {
        if(cf.charAt(cf.length - 1) != cp.token)
          {
          cf += cp.token;
          }
        }
      var cr = new Reference(cf);
      clsBase = new Reference(baseRef.toString());
      if(!cr.isAbsolute())
        {
        cr.getPath().token = Path.FOLDER_TOKEN;
        clsBase.setPath(clsBase.getPath().getAbsolutePath(cr.getPath()));
        }
      logEvt.debug("zutH_(NXt@C)m=", clsBase.toString());
      // ʒu(`t@C)
      var bf = (initBase && ((typeof initBase.definitions) == "string")) ? initBase.definitions : ".";
      var bp = (new Reference(bf)).getPath();
      if(bp.isAbsolute())
        {
        bf = ".";
        }
      else
        {
        if(bf.charAt(bf.length - 1) != bp.token)
          {
          bf += bp.token;
          }
        }
      var br = new Reference(bf);
      defBase = new Reference(baseRef.toString());
      if(!br.isAbsolute())
        {
        br.getPath().token = Path.FOLDER_TOKEN;
        defBase.setPath(defBase.getPath().getAbsolutePath(br.getPath()));
        }
      logEvt.debug("zutH_(`t@C)m=", defBase.toString());
      // ʒu(ݒt@C)
      var sf = (initBase && ((typeof initBase.settings) == "string")) ? initBase.settings : ".";
      var sp = (new Reference(sf)).getPath();
      if(sp.isAbsolute())
        {
        sf = ".";
        }
      else
        {
        if(sf.charAt(sf.length - 1) != sp.token)
          {
          sf += sp.token;
          }
        }
      var sr = new Reference(sf);
      setBase = new Reference(baseRef.toString());
      if(!sr.isAbsolute())
        {
        sr.getPath().token = Path.FOLDER_TOKEN;
        setBase.setPath(setBase.getPath().getAbsolutePath(sr.getPath()));
        }
      logEvt.debug("zutH_(ݒt@C)m=", setBase.toString());
      // t@Cʒu(t[)
      if(_frameHtml)
        {
        frameRef = new Reference(baseRef.toString());
        if(!frameRef.getPath())
          {
          frameRef.setPath(new Path("./"));
          }
        if(!frameRef.getPath().getFile())
          {
          frameRef.getPath().setFile(new File());
          }
        frameRef.getPath().getFile().setName(_frameHtml);
        frameRef.getPath().getFile().addExtension("html");
        logEvt.debug("t@Cʒu(t[HTML)m=", frameRef.toString());
        }
      else
        {
        frameRef = null;
        logEvt.info("ut[HTMLv̎w肪Ȃ̂ŁAt[HTMLt@C͍쐬܂B");
        }
      // t@Cʒu(CfbNX)
      if(_indexFile)
        {
        indexRef = new Reference(baseRef.toString());
        if(!indexRef.getPath())
          {
          indexRef.setPath(new Path("./"));
          }
        if(!indexRef.getPath().getFile())
          {
          indexRef.getPath().setFile(new File());
          }
        indexRef.getPath().getFile().setName(_indexFile);
        indexRef.getPath().getFile().addExtension(_extension);
        logEvt.debug("t@Cʒu(CfbNX)m=", indexRef.toString());
        }
      else
        {
        indexRef = null;
        logEvt.info("ut@Cv̎w肪Ȃ̂ŁACfbNXt@C͍쐬܂B");
        }
      // t@Cʒu(Rec)
      if(_contentsFile)
        {
        toppgRef = new Reference(baseRef.toString());
        if(!toppgRef.getPath())
          {
          toppgRef.setPath(new Path("./"));
          }
        if(!toppgRef.getPath().getFile())
          {
          toppgRef.getPath().setFile(new File());
          }
        toppgRef.getPath().getFile().setName(_contentsFile);
        toppgRef.getPath().getFile().addExtension(_extension);
        logEvt.debug("t@Cʒu(\t@C)m=", toppgRef.toString());
        }
      else
        {
        toppgRef = null;
        logEvt.info("u\t@Cv̎w肪Ȃ̂ŁA\t@C͍쐬܂B");
        }
      // ܂
      logEvt.trace("startCompile().readyToWrite() - end - ");
      }
    //--------------------------------------
    // ݂s
    function executeWrite()
      {
      logEvt.trace("startCompile().executeWrite() - begin - ");
      try
        {
        var check = null;
        var index = stateWrite.getCount();
        // NXt@C̏
        if(check == null)
          {
          if(index < _target.length)
            {
            check = !!executeWriteClass(index);
            }
          else
            {
            index -= _target.length;
            }
          }
        // pbP[W`t@C̏
        if(check == null)
          {
          if(index < _targetDef.length)
            {
            check = !!executeWriteDefinition(index);
            }
          else
            {
            index -= _targetDef.length;
            }
          }
        // CfbNX̏
        if((check == null) && _indexFile)
          {
          if(index == 0)
            {
            check = !!executeWriteIndex();
            }
          index--;
          }
        // RecRpC
        if((check == null) && _contentsFile)
          {
          if(index == 0)
            {
            check = !!executeWriteContents();
            }
          index--;
          }
        // t[̏
        if((check == null) && _frameHtml)
          {
          if(index == 0)
            {
            check = !!executeWriteFrame();
            }
          index--;
          }
        // ps
        if(check)
          {
          stateWrite.step();
          }
        else
          {
          stateWrite.stop();
          }
        }
      catch(e)
        {
        stateWrite.stop();
        logEvt.fatal("ݒɃG[܂B", e.message);
        MsgAdd("\r\nG[܂BOmFĂB");
        }
      logEvt.trace("startCompile().executeWrite() - end - ");
      }
    //--------------------------------------
    // ݂P
    function write1File(ref, doc)
      {
      var mimeType = (_execXslt && (_execXslType == "Result")) ? null : "text/xml";
      var separator = null;
      switch(_lineSeparator)
        {
        case "CR+LF":
          separator = "\r\n";
          break;
        case "LF":
          separator = "\n";
          break;
        case "CR":
          separator = "\r";
          break;
        default:
          separator = "";
        }
      var WriterClass = _savingWay ? TextFileWriter : WindowWriter;
      var writer = new WriterClass(ref.toString(), _encoding, mimeType);
      if(doc instanceof XmlDocument)
        {
        doc.documentDeclaration.setAttribute("encoding", _encoding);
        }
      logEvt.info("ݐF", (_savingWay ? ref.toString() : "EBhE"));
      logEvt.info("R[hF", _encoding);
      logEvt.info("sR[hF", _lineSeparator);
      logEvt.info("MIME^CvF", mimeType);
      MsgAdd("\r\nۑ=.."+baseRef.getPath().getAbsolutePath(new Path("../")).getRelativePath(ref.getPath()).toString());
      writer.open(_savingWay, window[WINDOW_MENU]);
      writer.write(doc.toString("  ", separator, true));
      writer.close();
      }
    //--------------------------------------
    // (NX)
    function executeWriteClass(index)
      {
      logEvt.trace("startCompile().executeWriteClass() - begin - ", index);
      var isSuccess = false;
      if((targets != _target) && (targets[index] != _target[index]))
        {
        for(var i = 0; i < targets.length; i++)
          {
          if(targets[i] == _target[index])
            {
            index = i;
            break;
            }
          }
        }
      logEvt.info("݂s܂B", "index=", index, "/Ώ=", targets[index]);
      Msg("[" + (stateWrite.getCount() + 1) + "]=" + targets[index]);
      write1File(xmlObjs[index].path, xmlObjs[index])
      isSuccess = true;
      logEvt.info("݂I܂B");
      logEvt.trace("startCompile().executeWriteClass() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // (pbP[W`t@C)
    function executeWriteDefinition(index)
      {
      logEvt.trace("startCompile().executeWriteDefinition() - begin - ", index);
      var isSuccess = false;
      if((definitions != _targetDef) && (definitions[index] != _targetDef[index]))
        {
        for(var i = 0; i < definitions.length; i++)
          {
          if(definitions[i] == _targetDef[index])
            {
            index = i;
            break;
            }
          }
        }
      logEvt.info("݂s܂B", "index=", index, "/Ώ=", definitions[index]);
      Msg("[" + (stateWrite.getCount() + 1) + "]=" + definitions[index]);
      write1File(xmlDefs[index].path, xmlDefs[index])
      isSuccess = true;
      logEvt.info("݂I܂B");
      logEvt.trace("startCompile().executeWriteDefinition() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // (CfbNX)
    function executeWriteIndex()
      {
      logEvt.trace("startCompile().executeWriteIndex() - begin - ");
      var isSuccess = false;
      logEvt.info("݂s܂B", "Ώ=CfbNXit@Cj");
      Msg("=CfbNXit@Cj");
      var indexDoc = indexCompiler.getXmlDocument();
      write1File(indexRef, indexDoc);
      isSuccess = true;
      logEvt.info("݂I܂B");
      logEvt.trace("startCompile().executeWriteIndex() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // (Rec)
    function executeWriteContents()
      {
      logEvt.trace("startCompile().executeWriteContents() - begin - ");
      var isSuccess = false;
      logEvt.info("݂s܂B", "Ώ=CfbNXi\t@Cj");
      Msg("=CfbNXi\t@Cj");
      // TODO  contentsDoc
      var contentsDoc = null;  // contentsCompiler.getXmlDocument();
      //write1File(toppgRef, contentsDoc);
      isSuccess = true;
      logEvt.info("݂I܂B");
      logEvt.trace("startCompile().executeWriteContents() - end - ");
      return isSuccess;
      }
    //--------------------------------------
    // (t[)
    function executeWriteFrame()
      {
      logEvt.trace("startCompile().executeWriteFrame() - begin - ");
      var isSuccess = false;
      logEvt.info("݂s܂B", "Ώ=t[HTMLt@C");
      Msg("=t[HTMLt@C");
      var html = (function()
        {
        var root = new XmlDocument(1.0);
        var html = new XmlNode("html");
        root.documentElement = html;
        var head = new XmlNode("head");
        html.appendChild(head);
        var meta = new XmlNode("meta");
            meta.setAttribute("http-equiv", "Content-Type");
            meta.setAttribute("content", "text/html");
        head.appendChild(meta);
            meta = new XmlNode("meta");
            meta.setAttribute("http-equiv", "Content-Script-Type");
            meta.setAttribute("content", "text/javascript");
        head.appendChild(meta);
            meta = new XmlNode("meta");
            meta.setAttribute("http-equiv", "Content-Style-Type");
            meta.setAttribute("content", "text/css");
        head.appendChild(meta);
            meta = new XmlNode("meta");
            meta.setAttribute("name", "author");
            meta.setAttribute("content", "mug");
        head.appendChild(meta);
            meta = new XmlNode("meta");
            meta.setAttribute("name", "Generator");
            meta.setAttribute("content", "JSDCompiler");
        head.appendChild(meta);
        var title = new XmlNode("title");
            title.appendChild(new XmlNode("#text", "JavaScriptDocument"));
        head.appendChild(title);
        var frameset = new XmlNode("frameset");
        frameset.setAttribute("cols", "20%,*");
        html.appendChild(frameset);
        var frame = new XmlNode("frame");
            frame.setAttribute("name", "index");
            frame.setAttribute("src", ((indexRef && indexRef.getPath().getFile()) ? indexRef.getPath().getFile().toString() : "about:blank"));
        frameset.appendChild(frame);
            frame = new XmlNode("frame");
            frame.setAttribute("name", "explanation");
            frame.setAttribute("src", ((toppgRef && toppgRef.getPath().getFile()) ? toppgRef.getPath().getFile().toString() : "about:blank"));
            frame.setAttribute("onload", "document.title=frames[this.name].document.title;");
        frameset.appendChild(frame);
        return root;
        }
      )();
      write1File(frameRef, html);
      isSuccess = true;
      logEvt.info("݂I܂B");
      logEvt.trace("startCompile().executeWriteFrame() - end - ", isSuccess);
      return isSuccess;
      }
    //--------------------------------------
    // RpCpϐ̏
    function initParams()
      {
      logEvt.trace("startCompile().initParams() - begin - ");
      var len = 0;
      if(_execCompile)
        {
        len = _target.length + _targetDef.length;
        stateCompile.ready(len);
        cond = null;
        compiler = null;
        xmlObjs = [];
        xmlDefs = [];
        indexCompiler = null;
        }
      if(_execConnect)
        {
        len = _target.length;
        stateConnect.ready(len);
        }
      if(_execLink)
        {
        len = _target.length + _targetDef.length;
        stateLink.ready(len);
        }
      if(_execXslt)
        {
        len = _target.length + _targetDef.length;
        if(_indexFile)
          {
          len += 1;
          }
        if(_contentsFile)
          {
          len += 1;
          }
        stateXsl.ready(len);
        }
      if(_execWrite)
        {
        len = _target.length + _targetDef.length;
        if(_indexFile)
          {
          len += 1;
          }
        if(_contentsFile)
          {
          len += 1;
          }
        if(_frameHtml)
          {
          len += 1;
          }
        stateWrite.ready(len);
        }
      logEvt.trace("startCompile().initParams() - end - ");
      }
    //--------------------------------------
    // ԊǗ̔j
    function destroyState()
      {
      stateAll.destroy();
      stateCompile.destroy();
      stateConnect.destroy();
      stateLink.destroy();
      stateWrite.destroy();
      stateXsl.destroy();
      }
    // ԊǗ̏
    function initState()
      {
      // S
      stateAll.init();
      stateAll.onready = function()
        {
        mainMenuStart.judgeState();
        mainMenuStop.judgeState();
        changeFrameDisplay(1);
        // TODO bZ[W
        };
      stateAll.onstop = function()
        {
        mainMenuStart.judgeState();
        mainMenuStop.judgeState();
        if(this.getResult())
          {
          changeFrameDisplay(0);
          }
        else
          {
          changeFrameDisplay(2);
          }
        // TODO bZ[W
        };
      stateAll.onfinish = function()
        {
        // TODO bZ[W
        };
      // RpC
      stateCompile.init();
      stateCompile.onready = function()
        {
        execCompileCount.judgeValue();
        };
      stateCompile.onstep = function()
        {
        execCompilePrgrs.judgeValue();
        if(this.getRange() < 1)
          {
          if(_asyncExec)
            {
            setTimeout(executeCompile, 0);
            }
          else
            {
            executeCompile();
            }
          }
        };
      stateCompile.onstop = function()
        {
        if(!this.getResult())
          {
          stateAll.stop();
          }
        };
      stateCompile.onfinish = function()
        {
        executeNextStep();
        };
      stateCompile.ondestroy = function()
        {
        execCompileCount.judgeValue();
        execCompilePrgrs.judgeValue();
        };
      // RlNV
      stateConnect.init();
      stateConnect.onready = function()
        {
        execConnectCount.judgeValue();
        };
      stateConnect.onstep = function()
        {
        execConnectPrgrs.judgeValue();
        if(this.getRange() < 1)
          {
          if(_asyncExec)
            {
            setTimeout(executeConnect, 0);
            }
          else
            {
            executeConnect();
            }
          }
        };
      stateConnect.onstop = function()
        {
        if(!this.getResult())
          {
          stateAll.stop();
          }
        };
      stateConnect.onfinish = function()
        {
        executeNextStep();
        };
      stateConnect.ondestroy = function()
        {
        execConnectCount.judgeValue();
        execConnectPrgrs.judgeValue();
        };
      // N
      stateLink.init();
      stateLink.onready = function()
        {
        execLinkCount.judgeValue();
        };
      stateLink.onstep = function()
        {
        execLinkPrgrs.judgeValue();
        if(this.getRange() < 1)
          {
          if(_asyncExec)
            {
            setTimeout(executeLink, 0);
            }
          else
            {
            executeLink();
            }
          }
        };
      stateLink.onstop = function()
        {
        if(!this.getResult())
          {
          stateAll.stop();
          }
        };
      stateLink.onfinish = function()
        {
        executeNextStep();
        };
      stateLink.ondestroy = function()
        {
        execLinkCount.judgeValue();
        execLinkPrgrs.judgeValue();
        };
      // XSLϊ
      stateXsl.init();
      stateXsl.onready = function()
        {
        execXslCount.judgeValue();
        };
      stateXsl.onstep = function()
        {
        execXslPrgrs.judgeValue();
        if(this.getRange() < 1)
          {
          if(_asyncExec)
            {
            setTimeout(executeXslt, 0);
            }
          else
            {
            executeXslt();
            }
          }
        };
      stateXsl.onstop = function()
        {
        if(!this.getResult())
          {
          stateAll.stop();
          }
        };
      stateXsl.onfinish = function()
        {
        executeNextStep();
        };
      stateXsl.ondestroy = function()
        {
        execXslCount.judgeValue();
        execXslPrgrs.judgeValue();
        };
      // 
      stateWrite.init();
      stateWrite.onready = function()
        {
        execWriteCount.judgeValue();
        };
      stateWrite.onstep = function()
        {
        execWritePrgrs.judgeValue();
        if(this.getRange() < 1)
          {
          if(_asyncExec)
            {
            setTimeout(executeWrite, 0);
            }
          else
            {
            executeWrite();
            }
          }
        };
      stateWrite.onstop = function()
        {
        if(!this.getResult())
          {
          stateAll.stop();
          }
        };
      stateWrite.onfinish = function()
        {
        executeNextStep();
        };
      stateWrite.ondestroy = function()
        {
        execWriteCount.judgeValue();
        execWritePrgrs.judgeValue();
        };
      }
    // ԊǗ̏
    function readyState()
      {
      var len = 0;
      if(_execCompile)
        {
        len = _target.length + _targetDef.length;
        stateCompile.ready(len);
        }
      if(_execConnect)
        {
        len = _target.length;
        stateConnect.ready(len);
        }
      if(_execLink)
        {
        len = _target.length + _targetDef.length;
        stateLink.ready(len);
        }
      if(_execWrite)
        {
        len = _target.length + _targetDef.length;
        if(_indexFile)
          {
          len += 1;
          }
        if(_contentsFile)
          {
          len += 1;
          }
        stateWrite.ready(len);
        }
      if(_execXslt)
        {
        len = _target.length + _targetDef.length;
        if(_indexFile)
          {
          len += 1;
          }
        if(_contentsFile)
          {
          len += 1;
          }
        if(_frameHtml)
          {
          len += 1;
          }
        stateXsl.ready(len);
        }
      }
    //--------------------------------------
    // ̃Xebvs
    function executeNextStep()
      {
      setTimeout((function()
        {
        stateAll.step();
        }), 0);
      }
    //--------------------------------------
    // s
    destroyState();
    initState();
    stateAll.onstep = function()
      {
      var nextIndex = this.getCount();
      switch(nextIndex)
        {
        // `FbNs
        case 1:
          Msg("ʓ͒l̃`FbNł...");
          if(varidate())
            {
            logEvt.info("̓`FbNnj");
            MsgAdd("\r\n`FbNnj");
            initParams();
            readyToWrite();
            executeNextStep();
            }
          else
            {
            logEvt.warn("ݒ肳ꂽ͒l܂B");
            MsgAdd("\r\n`FbNmfiOmFĂj");
            stateAll.stop();
            }
          break;
        // ̍쐬
        case 2:
          if(_isNewCompile)
            {
            cond = createCondition();
            logEvt.info("s쐬܂B");
            }
          executeNextStep();
          break;
        // RpC̍쐬
        case 3:
          if(_isNewCompile)
            {
            compiler = createInstance(cond);
            if(_indexFile)
              {
              indexCompiler = createIndex();
              }
            // TODO Rec̐
            logEvt.info("RpC쐬܂B");
            }
          executeNextStep();
          break;
        // RpC
        case 4:
          if(_execCompile)
            {
            logEvt.info("RpCJn܂B");
            executeCompile();
            }
          else
            {
            executeNextStep();
            }
          break;
        // TuNX̐ݒ
        case 5:
          if(_execConnect)
            {
            compiler.setSubClasses();
            }
          executeNextStep();
          break;
        // RlNV
        case 6:
          if(_execConnect)
            {
            logEvt.info("pNJn܂B");
            executeConnect();
            }
          else
            {
            executeNextStep();
            }
          break;
        // N
        case 7:
          if(_execLink)
            {
            logEvt.info("NJn܂B");
            executeLink();
            }
          else
            {
            executeNextStep();
            }
          break;
        // XSLϊ
        case 8:
          if(_execXslt)
            {
            if(readyToXslt())
              {
              logEvt.info("XSL̓KpJn܂B");
              executeXslt();
              }
            else
              {
              logEvt.warn("XSLϊ̓XLbv܂B");
              executeNextStep();
              }
            }
          else
            {
            executeNextStep();
            }
          break;
        // 
        case 9:
          if(_execWrite)
            {
            logEvt.info("݂Jn܂B");
            executeWrite();
            }
          else
            {
            executeNextStep();
            }
          break;
        // I
        case 10:
          stateAll.step();
          logEvt.info("I܂B");
          Msg("I܂B");
          break;
        // ̑
        default:
          stateAll.stop();
        }
      };
    stateAll.ready(10);
    executeNextStep();
    logEvt.trace("startCompile() - end - ");
    }
  
  
  
  //##############################################################################
  //
  // s\bh
  //
  
  //------------------------------------------------------------------------------
  // f[^̎
  function autoDataSetting()
    {
    // ECMAScriptlCeBu̒ǉ
    if(arguments.callee.withECMAScript)
      {
      var def = appendDefFile();
      def.pkg.getOptions().length = 0;
      def.pkg.addOption(new SelectOption("O[oIuWFNg", "this", true));
      def.pkg.init();
      def.pkg.setValue("this");
      def.fileName.setValue("ECMAScript");
      def.fileName.setPattern(null);
      def.btnDel.setDisabled(true);
      def.judgeState();
      }
    // script^Ot@C𒊏oApbP[W`t@Cɓ
    var scripts = document.scripts;
    if(!scripts)
      {
      scripts = document.getElementsByTagName("script");
      }
    if(scripts)
      {
      for(var s = 0; s < scripts.length; s++)
        {
        var opt = (function(node)
          {
          var opts = ["type", "language", "charset", "defer"];
          for(var i = 0; i < opts.length; i++)
            {
            if(node[opts[i]])
              {
              opts[i] = opts[i] + "=" + node[opts[i]];
              }
            else
              {
              opts = opts.slice(0, i).concat(opts.slice((i + 1), opts.length));
              i--;
              }
            }
          return (opts.length > 0) ? opts.join(",") : "";
          })(scripts[s]);
        var src = scripts[s].src;
        if(!src)
          {
          src = scripts[s].getAttribute("src");
          }
        if(src)
          {
          src = new Reference(src);
          if(src && src.getPath() && src.getPath().getFile())
            {
            src = src.getPath().getFile();
            }
          if(src && src.toString())
            {
            var def = appendDefFile();
            def.fileName.setValue(src.toString());
            def.options.setValue(opt);
            def.btnDel.setDisabled(true);
            def.judgeState();
            }
          }
        else
          {
          src = scripts[s].innerHTML;
          if((/\W*include\(.*?\);\W*/).test(src))
            {
            break;
            }
          }
        }
      }
    }
  
  //#####################################
  // ʍڂ̏
  GLOBAL_OBJ.onload = function()
    {
    var withECMAScript = ((Class.getDefinition("Object") != Class.getDefinition("Object")));
    
    selectTree.flash();
    selectTree.judgeMenu(withECMAScript);
    selectTree.init();
    selectTree.create();
    selectTree.mark();
    selectTree.nestFlash();
    
    xmlnsUsing.init();
    xmlnsInput.init();
    xmlnsName.init();
    xmlnsUri.init();
    
    buttonLinkAppend.init();
    buttonDefFileAppend.init();
    buttonDeployAppend.init();
    
    rootPackage.init();
    rootPackage.judgeOptions();
    rootPackage.flashOptions();
    
    rootDirectory.init();
    openDirectory.init();
    
    asyncCheck.init();
    newCompile.init();
    
    savingWay.init();
    savingWay.judgeOptions();
    savingWay.flashOptions();
    
    encoding.init();
    encoding.judgeOptions();
    encoding.flashOptions();
    
    lineSeparator.init();
    lineSeparator.judgeOptions();
    lineSeparator.flashOptions();
    
    fileExtension.init();
    
    logLevel.init();
    logLevel.judgeOptions();
    logLevel.flashOptions();
    
    execCompileCheck.init();
    execCompileCount.init();
    execCompilePrgrs.init();
    
    execConnectCheck.init();
    execConnectCount.init();
    execConnectPrgrs.init();
    
    execLinkCheck.init();
    execLinkCount.init();
    execLinkPrgrs.init();
    
    execWriteCheck.init();
    execWriteCount.init();
    execWritePrgrs.init();
    
    execXslCheck.init();
    execXslTypeO.init();
    execXslTypeR.init();
    execXslSelect.init();
    execXslSelect.judgeOptions();
    execXslSelect.flashOptions();
    
    execXslCount.init();
    execXslPrgrs.init();
    
    execXslFileFrame.init();
    execXslFile.init();
    
    execIdxCheck.init();
    execIdxFrame.init();
    execIndexFile.init();
    execContentsFile.init();
    execHtmlCheck.init();
    execHtmlFile.init();
    
    mainMenuStart.init();
    mainMenuStop.init();
    mainMenuDispLog.init();
    mainMenuSaveLog.init();
    mainMenuClearLog.init();
    messageArea.init();
    
    if(withECMAScript)
      {
      autoDataSetting.withECMAScript = withECMAScript;
      }
    setTimeout(autoDataSetting, 0);
    
    };
  
  
  
  })();

