/******************************************************************************/
/*                                                                            */
/*      Tv            JavaScriptDocumentRpC                          */
/*      \            JSDCompilerpbP[W`                             */
/*      pbP[W`  jsd                                                   */
/*      ŏIXV      2006/10/08(Sun)                                       */
/*      o[W      1.01.00                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

(function()
  {
  //------------------------------------------------------------------------------
  // NXpX
  
  //:V Package Function js.cpt.PackageNX
  var Package = js.cpt.Package;
  
  //:V Class Function js.cpt.ClassNX
  var Class = js.cpt.Class;
  
  //------------------------------------------------------------------------------
  // pbP[W
  
  //:V jsd js.cpt.Package JSDpbP[W
  var jsd = Package.getInstance("jsd");
  
  //------------------------------------------------------------------------------
  // NX`
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // XML֌W
  
  //:V xml js.cpt.Package XMLǗ
  var xml = Package.getInstance("jsd.xml");
  
  //:I XmlNode@jsd.xml js.cpt.Class XmlNodeNX
  xml.XmlNode = new Class("XmlNode",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I XmlDocument@jsd.xml js.cpt.Class XmlDocumentNX
  xml.XmlDocument = new Class("XmlDocument",
    ["jsd.xml.XmlNode"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // o
  
  //:V io js.cpt.Package o
  var io = Package.getInstance("jsd.io");
  
  //:I AbstractIO@jsd.io js.cpt.Class jsd.io.AbstractIONX
  io.AbstractIO = new Class("AbstractIO", 
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I TextFileWriter@jsd.io js.cpt.Class jsd.io.TextFileWriterNX
  io.TextFileWriter = new Class("TextFileWriter", 
    ["jsd.io.AbstractIO"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I WindowWriter@jsd.io js.cpt.Class jsd.io.WindowWriterNX
  io.WindowWriter = new Class("WindowWriter", 
    ["jsd.io.AbstractIO"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // Q
  
  //:V ref js.cpt.Package Q
  var ref = Package.getInstance("jsd.ref");
  
  //:I File@jsd.ref js.cpt.Class jsd.ref.FileNX
  ref.File = new Class("File", 
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Path@jsd.ref js.cpt.Class jsd.ref.PathNX
  ref.Path = new Class("Path", 
    ["jsd.ref.File"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Host@jsd.ref js.cpt.Class jsd.ref.HostNX
  ref.Host = new Class("Host", 
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Reference@jsd.ref js.cpt.Class jsd.ref.ReferenceNX
  ref.Reference = new Class("Reference", 
    ["jsd.ref.Path", "jsd.ref.Host"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // RpC
  
  //:V cpl js.cpt.Package RpC
  var cpl = Package.getInstance("jsd.compiler");
  
  //:I AbstractCompiler@jsd.cpt js.cpt.Class AbstractCompilerNX
  cpl.AbstractCompiler = new Class("AbstractCompiler", 
    ["jsd.xml.XmlNode"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I BaseCompiler@jsd.cpt js.cpt.Class BaseCompilerNX
  cpl.BaseCompiler = new Class("BaseCompiler", 
    ["jsd.compiler.AbstractCompiler"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I DefinitionCompiler@jsd.cpt js.cpt.Class DefinitionCompilerNX
  cpl.DefinitionCompiler = new Class("DefinitionCompiler", 
    ["jsd.xml.XmlNode", "jsd.compiler.AbstractCompiler", "jsd.compiler.BaseCompiler"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I CommandCompiler@jsd.cpt js.cpt.Class CommandCompilerNX
  cpl.CommandCompiler = new Class("CommandCompiler", 
    ["jsd.compiler.AbstractCompiler", "jsd.compiler.BaseCompiler", "js.debug.jsd.command.AbstractCommand"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I JsdCompiler@jsd.cpt js.cpt.Class JsdCompilerNX
  cpl.JsdCompiler = new Class("JsdCompiler", 
    ["jsd.compiler.AbstractCompiler", "jsd.compiler.CommandCompiler", "js.debug.jsd.JavaScriptDocument"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I MemberCompiler@jsd.cpt js.cpt.Class MemberCompilerNX
  cpl.MemberCompiler = new Class("MemberCompiler", 
    ["jsd.compiler.AbstractCompiler", "jsd.compiler.JsdCompiler", "js.debug.jsd.JavaScriptDocument"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I CreatorCompiler@jsd.cpt js.cpt.Class CreatorCompilerNX
  cpl.CreatorCompiler = new Class("CreatorCompiler", 
    ["jsd.compiler.MemberCompiler", "jsd.compiler.JsdCompiler", "js.debug.jsd.JavaScriptDocument"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I ClassCompiler@jsd.cpt js.cpt.Class ClassCompilerNX
  cpl.ClassCompiler = new Class("ClassCompiler", 
    ["jsd.compiler.AbstractCompiler", "jsd.compiler.DefinitionCompiler", "jsd.compiler.MemberCompiler", "jsd.xml.XmlNode", "jsd.compiler.CompileCondition", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.JsdFactory"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I PackageCompiler@jsd.cpt js.cpt.Class PackageCompilerNX
  cpl.PackageCompiler = new Class("PackageCompiler", 
    ["jsd.compiler.AbstractCompiler", "jsd.compiler.DefinitionCompiler", "jsd.ref.File", "jsd.xml.XmlNode", "jsd.compiler.CompileCondition", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.JsdFactory"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I CompileCondition@jsd.cpt js.cpt.Class CompileConditionNX
  cpl.CompileCondition = new Class("CompileCondition", 
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Compiler@jsd.cpt js.cpt.Class CompilerNX
  cpl.Compiler = new Class("Compiler", 
    ["jsd.xml.XmlDocument", "jsd.compiler.ClassCompiler", "jsd.compiler.PackageCompiler", "jsd.compiler.CompileCondition"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I IndexCompiler@jsd.cpt js.cpt.Class IndexCompilerNX
  cpl.IndexCompiler = new Class("IndexCompiler", 
    ["jsd.xml.XmlDocument", "jsd.ref.Reference"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // ʑ
  
  //:V cnt jsd.cpt.Package Rei
  var cnt = Package.getInstance("jsd.container");
  
  //:I EventState@jsd.container jsd.cpt.Class EventStateNX
  cnt.EventState = new Class("EventState",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I DisplayControl@jsd.container jsd.cpt.Class DisplayControlNX
  cnt.DisplayControl = new Class("DisplayControl",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I ElementControl@jsd.container jsd.cpt.Class ElementControlNX
  cnt.ElementControl = new Class("ElementControl",
    ["jsd.container.DisplayControl"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I SelectOption@jsd.container jsd.cpt.Class SelectOptionNX
  cnt.SelectOption = new Class("SelectOption",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I SelectBox@jsd.container jsd.cpt.Class SelectBoxNX
  cnt.SelectBox = new Class("SelectBox",
    ["jsd.container.ElementControl", "jsd.container.SelectOption"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I NodeControl@jsd.container jsd.cpt.Class NodeControlNX
  cnt.NodeControl = new Class("NodeControl",
    ["jsd.container.DisplayControl"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I ExtensibleTree@jsd.container jsd.cpt.Class ExtensibleTreeNX
  cnt.ExtensibleTree = new Class("ExtensibleTree",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I TreeMenu@jsd.container jsd.cpt.Class TreeMenuNX
  cnt.TreeMenu = new Class("TreeMenu",
    ["jsd.container.ElementControl"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I SelectTree@jsd.container jsd.cpt.Class SelectTreeNX
  cnt.SelectTree = new Class("SelectTree",
    ["jsd.container.NodeControl", "jsd.container.TreeMenu", "jsd.container.ExtensibleTree"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  
  
  
  }
)();

