/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpNXRpCNX                 */
/*      \            ClassCompiler                                         */
/*      pbP[W  jsd.compiler                                          */
/*      ŏIXV      2006/10/08(Sun)                                       */
/*      o[W      1.01.00                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * NXRpCNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.compiler.ClassCompilerNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.compiler.ClassCompiler";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V _CLASS_ Function js.cpt.Class
  var _CLASS_ = js.cpt.Class;
  //:V XmlNode Function jsd.xml.XmlNode
  var XmlNode = jsd.xml.XmlNode;
  //:V CompileCondition Function jsd.compiler.CompileCondition
  var CompileCondition = jsd.compiler.CompileCondition;
  //:V DefinitionCompiler Function jsd.compiler.DefinitionCompiler
  var DefinitionCompiler = jsd.compiler.DefinitionCompiler;
  //:V CreatorCompiler Function jsd.compiler.CreatorCompiler
  var CreatorCompiler = jsd.compiler.CreatorCompiler;
  //:V MemberCompiler Function jsd.compiler.MemberCompiler
  var MemberCompiler = jsd.compiler.MemberCompiler;
  //:V JsdFactory Function js.debug.jsd.JsdFactory
  var JsdFactory = js.debug.jsd.JsdFactory;
  //:V JavaScriptDocument Function js.debug.jsd.JavaScriptDocument
  var JavaScriptDocument = js.debug.jsd.JavaScriptDocument;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //:V ROOT_NODE_NAME String [gm[h
  var ROOT_NODE_NAME = "class";
  //:V HEAD_NODE_NAME String wb_m[h
  var HEAD_NODE_NAME = "head";
  //:V BODY_NODE_NAME String {fBm[h
  var BODY_NODE_NAME = "body";
  //:V LINK_NODE_NAME String Nm[h
  var LINK_NODE_NAME = "link";
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S XMLNS_URI String XMLOURI
  Static.XMLNS_URI = "";
  
  //------------------------------------------------------------------------------
  Static.functionToString = function(func)
   /**
    * ֐𕶎񉻂
    * @param func Function ֐
    * @return String|null 񉻂ꂽ֐
    */
    {
    log.trace("S:functionToString - begin - ", func);
    var str = null;
    if((typeof func) == "function")
      {
      var nativeToString = (function(){}).toString;
      var originalToString;
      if(func.toString != nativeToString)
        {
        originalToString = func.toString;
        delete func.toString;
        }
      str = func.toString(0);
      if(originalToString)
        {
        func.toString = originalToString;
        }
      }
    log.trace("S:functionToString - end - ", str);
    return str;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P definitionCompiler jsd.compiler.DefinitionCompiler|null NX`RpC̃CX^X
  Proto.definitionCompiler = null;
  //:P creatorCompiler jsd.compiler.CreatorCompiler|null NG[^[RpC̃CX^X
  Proto.creatorCompiler = null;
  //:P memberCompiler jsd.compiler.MemberCompiler|null oRpC̃CX^X
  Proto.memberCompiler = null;
  
  //------------------------------------------------------------------------------
  Proto.compile = function(source, cond)
   /**
    * RpCs
    * @param source String \[X(SCNX)
    * @param cond jsd.compiler.CompileCondition RpC
    * @return jsd.xml.XmlNode|null RpC
    */
    {
    log.trace("P:compile - begin - ", source, cond);
    var node = null;
    if(!source || ((typeof source) != "string"))
      {
      return node;
      }
    if(!cond || ((typeof cond) != "object") || !(cond instanceof CompileCondition))
      {
      return node;
      }
    log.trace("NXRpCJn");
    var define, creator, target;
    try
      {
      define  = _CLASS_.getDefinition(source);
      creator = _CLASS_.getCreator(source);
      target  = _CLASS_.getClass(source, true);
      log.trace("IuWFNg", " NX`=", !!define, " NG[^[=", !!creator, " ΏۃNX=", !!target);
      if(define && creator && target)
        {
        // et@C
        var defineFile  = cond.getDefinitionFile(source);
        log.trace("`t@C=", defineFile);
        // 	OD[g쐬
        node = Super.prototype.compile.call(this, null, ROOT_NODE_NAME);
        node.setAttribute("id", source);
        var xmlns = Static.XML_NAMESPACE;
        if(xmlns)
          {
          node.setAttribute(("xmlns:" + xmlns), Static.XMLNS_URI);
          }
        log.trace("[gm[h쐬", node);
        // PDwb_쐬
        var head = Super.prototype.compile.call(this, null, HEAD_NODE_NAME);
        node.appendChild(head);
        log.trace("wb_m[h쐬", head);
        (function()
          {
          var link;
          // P|PDpbP[W`t@C
          link = Super.prototype.compile.call(this, null, LINK_NODE_NAME);
            {
            link.setAttribute("rel", "DefinitionFile");
            link.setAttribute("name", (defineFile ? defineFile : ""));
            }
          head.appendChild(link);
          log.trace("pbP[W`t@Cm[h쐬", link);
          // P|QDfvCx[X
          var nameList = cond.getBaseDirectories();
          if(nameList)
            {
            for(var i = 0; i < nameList.length; i++)
              {
              var name = nameList[i];
              var dir  = cond.getBaseDirectory(name);
              var ext  = cond.getBaseExtension(name);
              link = Super.prototype.compile.call(this, null, LINK_NODE_NAME);
                {
                link.setAttribute("rel", "Base");
                link.setAttribute("class", name);
                link.setAttribute("href", dir);
                if((typeof ext) == "string")
                  {
                  link.setAttribute("extension", ext);
                  }
                }
              head.appendChild(link);
              log.trace("fvCx[Xm[h(", (i + 1), "/" + nameList.length, ")쐬", link);
              }
            }
          // P|RD
          var uri = cond.getIndexUri();
          if(uri)
            {
            link = Super.prototype.compile.call(this, null, LINK_NODE_NAME);
              {
              link.setAttribute("rel", "Index");
              //link.setAttribute("href", uri);
              }
            head.appendChild(link);
            log.trace("m[h쐬", link);
            }
          // P|SDڎ
          var uri = cond.getContentsUri();
          if(uri)
            {
            link = Super.prototype.compile.call(this, null, LINK_NODE_NAME);
              {
              link.setAttribute("rel", "Contents");
              //link.setAttribute("href", uri);
              }
            head.appendChild(link);
            log.trace("ڎm[h쐬", link);
            }
          })();
        // QD{fB쐬
        var body = Super.prototype.compile.call(this, null, BODY_NODE_NAME);
        node.appendChild(body);
        log.trace("{fBm[h쐬", body);
          {
          // X[p[NX̎擾
          var supNames = [];
          for(var supClass = target.Super; supClass; supClass = supClass.Super)
            {
            try
              {
              if(!supClass)
                {
                break;
                }
              else if(supClass == Array)
                {
                supNames[supNames.length] = "Array";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == Boolean)
                {
                supNames[supNames.length] = "Boolean";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == Date)
                {
                supNames[supNames.length] = "Date";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == (((typeof js.cpt.Error) == "function") ? js.cpt.Error.Super : Error))
                {
                supNames[supNames.length] = "Error";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == Function)
                {
                supNames[supNames.length] = "Function";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == Math)
                {
                supNames[supNames.length] = "Math";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == Number)
                {
                supNames[supNames.length] = "Number";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == Object)
                {
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == RegExp)
                {
                supNames[supNames.length] = "RegExp";
                supNames[supNames.length] = "Object";
                break;
                }
              else if(supClass == String)
                {
                supNames[supNames.length] = "String";
                supNames[supNames.length] = "Object";
                break;
                }
              else
                {
                var supName = supClass.toString(supClass);
                if(supName && ((typeof supName) == "string") && (_CLASS_.getClass(supName, true) == supClass))
                  {
                  supNames[supNames.length] = supName;
                  }
                else
                  {
                  break;
                  }
                }
              }
            catch(e)
              {
              break;
              }
            }
          log.trace("X[p[NXo", supNames);
          // Q|PDNX` - ꕔ̏͌ォ
          var def_cp = (this.definitionCompiler instanceof DefinitionCompiler) ? this.definitionCompiler : (this.definitionCompiler = new DefinitionCompiler());
          var packageName = source.substring(0, Math.max(0, source.lastIndexOf(".", source.length)));
          body.appendChild(def_cp.compile(define, (defineFile ? defineFile : null), (packageName ? packageName : null), supNames));
          log.trace("NX`m[h쐬", body.lastChild);
          // Q|QDNX{
          var jsdList = (new JsdFactory(Static.functionToString(creator))).create();
          var creatorJsd = null;
          if(jsdList instanceof JavaScriptDocument)
            {
            creatorJsd = jsdList;
            jsdList = creatorJsd.getChildren();
            }
          else if(jsdList && !(jsdList instanceof Array))
            {
            jsdList = null;
            }
          // Q|RDNG[^[
          var cre_cp = (this.creatorCompiler instanceof CreatorCompiler) ? this.creatorCompiler : (this.creatorCompiler = new CreatorCompiler());
          var creatorNode = cre_cp.compile(creatorJsd);
          if(creatorNode)
            {
            body.appendChild(creatorNode);
            log.trace("NG[^[m[h쐬", creatorNode);
            }
          // Q|SDo
          (function()
            {
            // vpeB֐
            var has = (function(has)
              {
              return function(obj, name, type, value)
                {
                return has.call(obj, name) && (!type || ((typeof obj[name]) == type)) && ((arguments.length < 4) || (obj[name] === value));
                };
              }
            )(({}).hasOwnProperty);
            // oǉRg[
            function Control(jsdList)
              {
              var ins = [];
              var map = {};
              if(jsdList)
                {
                for(var i = 0; i < jsdList.length; i++)
                  {
                  map[name(jsdList[i])] = jsdList[i];
                  }
                }
              function name(jsd)
                {
                var n = jsd.getCommandByName("name");
                var d = jsd.getCommandByName("def");
                var key = text(d) + ":" + text(n, "@");
                return key;
                }
              function text(cmd, token)
                {
                var str = "";
                if(cmd)
                  {
                  var names = cmd.getNames();
                  for(var i = 0; i < names.length; i++)
                    {
                    var val = cmd.getValue(names[i]);
                    if(str && token)
                      {
                      str += token;
                      }
                    str += val ? val : "";
                    }
                  }
                return str;
                }
              this.add = function(jsd)
                {
                if((typeof jsd) == "string")
                  {
                  jsd = (new JsdFactory(jsd)).create();
                  if(jsd instanceof Array)
                    {
                    if(jsd.length > 0)
                      {
                      jsd = jsd[0];
                      }
                    }
                  }
                if(jsd instanceof JavaScriptDocument)
                  {
                  var key = name(jsd);
                  if(!map[key])
                    {
                    ins[ins.length] = jsd;
                    map[key] = jsd;
                    log.trace("  EǉvpeB̉m = ", key);
                    }
                  }
                };
              this.fix = function()
                {
                var list = ins.concat(jsdList);
                delete ins;
                delete map;
                log.trace("  ǉmŃXg");
                return list;
                };
              return this;
              }
            // ǉ`FbN
            var check = has(creator, "CompleteName", "string") && has(target, "Super") && has(target, "Static") && has(target, "prototype", "object") && has(target.prototype, "Super") && has(target.prototype, "constructor");
            // ǉ
            if(check)
              {
              log.trace("oǉ");
              var ctrl = new Control(jsdList);
              if(has(target, "Super", "function"))
                {
                ctrl.add("//:C Super Function X[p[NXւ̎Q");
                }
              if(has(target, "Static", "object"))
                {
                ctrl.add("//:C Static Object X^eBbNIuWFNg");
                }
              if(has(target, "prototype", "object"))
                {
                ctrl.add("//:C prototype Object vg^CvIuWFNg");
                }
              if(has(target.prototype, "Super", "function"))
                {
                ctrl.add("//:P Super Function X[p[NXւ̎Q");
                }
              if(has(target.prototype, "constructor", "function"))
                {
                ctrl.add("//:P constructor Function RXgN^ւ̎Q");
                }
              jsdList = ctrl.fix();
              delete ctrl;
              }
            }
          )();
          // Q|TDo
          var mbr_cp = (this.memberCompiler instanceof MemberCompiler) ? this.memberCompiler : (this.memberCompiler = new MemberCompiler());
          var membersNode = mbr_cp.compile(jsdList);
          body.appendChild(membersNode);
          log.trace("om[h쐬", membersNode);
          }
        }
      }
    catch(e)
      {
      log.error(e);
      log.error("Message = " + e.message);
      log.error("StackTrace = " + e.stackTrace);
      node = null;
      }
    log.trace("P:compile - end - ", node);
    return node;
    };
  //------------------------------------------------------------------------------
  Proto.setSubClasses = function(xmlMap)
   /**
    * m̃TuNXݒ肷
    * @param xmlMap Object SCNXL[ɂjsd.xml.XmlNodẽ}bv
    */
    {
    log.trace("P:setSubClasses - begin -");
    DefinitionCompiler.setSubClasses(xmlMap, (this.definitionCompiler ? this.definitionCompiler.baseCompiler : null));
    log.trace("P:setSubClasses - end -");
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * NXRpCNX
    * @return jsd.compiler.ClassCompiler CX^X
    */
    {
    log.trace("F:Class - begin -");
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    log.trace("F:Class - end -");
    return this;
    }
  
  return Class;
  }, jsd.compiler.AbstractCompiler);

