/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpR}hRpCNX               */
/*      \            CommandCompiler                                       */
/*      pbP[W  jsd.compiler                                          */
/*      ŏIXV      2007/03/30(Fri)                                       */
/*      o[W      1.00.02                                               */
/*      쌠\      Copyright (C) 2006-2007 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * R}hRpCNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.compiler.CommandCompilerNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.compiler.CommandCompiler";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V AbstractElement Function js.debug.jsd.command.element.AbstractElement
  var AbstractElement = js.debug.jsd.command.element.AbstractElement;
  //:V AbstractCommand Function js.debug.jsd.command.AbstractCommand
  var AbstractCommand = js.debug.jsd.command.AbstractCommand;
  //:V BaseCompiler Function jsd.compiler.BaseCompiler
  var BaseCompiler = jsd.compiler.BaseCompiler;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //:V TYPE_UNDEF_BEGIN String ȗ\ȏꍇ̊Jn
  var TYPE_UNDEF_BEGIN = "[";
  //:V TYPE_UNDEF_END String ȗ\ȏꍇ̏I
  var TYPE_UNDEF_END   = "]";
  //:V TYPE_OR_TOKEN String or\؂蕶
  var TYPE_OR_TOKEN    = "|";
  //:V ATTRIB_OMITTABLE String omittablȇ
  var ATTRIB_OMITTABLE = "omittable";
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P baseCompiler jsd.compiler.BaseCompiler|null RpCCX^X
  Proto.baseCompiler = null;
  
  //------------------------------------------------------------------------------
  Proto.compile = function(source)
   /**
    * RpCs
    * @param source js.debug.jsd.command.AbstractCommand \[X(JSDR}h)
    * @return jsd.xml.XmlNode|null RpC
    */
    {
    log.trace("P:compile - begin - ", source);
    var node = null;
    if(!source || !(source instanceof AbstractCommand))
      {
      return node;
      }
    var prefix = "command-";
    var base_cp = (this.baseCompiler instanceof BaseCompiler) ? this.baseCompiler : (this.baseCompiler = new BaseCompiler());
    var cmd = source.constructor.name;
    node = Super.prototype.compile.call(this, null, (prefix + cmd));
    log.trace("R}h ", cmd, " łB");
    // R}h̗vfݒ
    var Elements = source.constructor.Static.getElements();
    for(var e = 0; e < Elements.length; e++)
      {
      var elm = source.getValue(Elements[e].name);
      if((cmd == "name") && (Elements[e].Static.type == AbstractElement.Static.TYPE_CLASS))
        {
        if(elm)
          {
          node.setAttribute("base", elm);
          }
        }
      else
        {
        switch(Elements[e].Static.type)
          {
          case AbstractElement.Static.TYPE_NAME:
            node.appendChild(base_cp.compile(elm, BaseCompiler.Static.MEAN_VARIABLE_NAME));
            break;
          case AbstractElement.Static.TYPE_PACKAGE:
            node.appendChild(base_cp.compile(elm, BaseCompiler.Static.MEAN_PACKAGE_NAME));
            break;
          case AbstractElement.Static.TYPE_CLASS:
            if((elm.indexOf(TYPE_UNDEF_BEGIN, 0) == 0) && (elm.lastIndexOf(TYPE_UNDEF_END, elm.length) == (elm.length - TYPE_UNDEF_END.length)))
              {
              node.setAttribute(ATTRIB_OMITTABLE, true);
              elm = elm.substring(TYPE_UNDEF_BEGIN.length, (elm.length - TYPE_UNDEF_END.length));
              }
            var types = elm.split(TYPE_OR_TOKEN);
            for(var i = 0; i < types.length; i++)
              {
              node.appendChild(base_cp.compile(types[i], BaseCompiler.Static.MEAN_CLASS_NAME));
              }
            break;
          case AbstractElement.Static.TYPE_DATE:
            node.appendChild(base_cp.compile(elm, BaseCompiler.Static.MEAN_DATE_TIME));
            break;
          case AbstractElement.Static.TYPE_TEXT:
            node.appendChild(base_cp.compile(elm, BaseCompiler.Static.MEAN_CDATA));
            break;
          case AbstractElement.Static.TYPE_VERSION:
          case AbstractElement.Static.TYPE_CODE:
          case AbstractElement.Static.TYPE_URI:
            node.appendChild(base_cp.compile(elm, BaseCompiler.Static.MEAN_TEXT));
            break;
          default:
          }
        }
      }
    log.trace("P:compile - end - ", node);
    return node;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * R}hRpCNX
    * @return jsd.compiler.CommandCompiler CX^X
    */
    {
    log.trace("F:Class - begin -");
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    log.trace("F:Class - end -");
    return this;
    }
  
  return Class;
  }, jsd.compiler.AbstractCompiler);

