/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCNX                                   */
/*      \            Compiler                                              */
/*      pbP[W  jsd.compiler                                          */
/*      ŏIXV      2007/05/18(Thu)                                       */
/*      o[W      1.02.01                                               */
/*      쌠\      Copyright (C) 2006-2007 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * JSDRpCNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.compiler.CompilerNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.compiler.Compiler";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V XmlDocument Function jsd.xml.XmlDocument
  var XmlDocument = jsd.xml.XmlDocument;
  //:V ClassCompiler Function jsd.compiler.ClassCompiler
  var ClassCompiler = jsd.compiler.ClassCompiler;
  //:V PackageCompiler Function jsd.compiler.PackageCompiler
  var PackageCompiler = jsd.compiler.PackageCompiler;
  //:V CompileCondition Function jsd.compiler.CompileCondition
  var CompileCondition = jsd.compiler.CompileCondition;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P onerror Function|null RpCG[Ɏs郁\bh
  Proto.onerror = null;
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(condition)
   /**
    * JSDRpCNX
    * @param condition [jsd.compiler.CompileCondition|null] RpC
    * @return jsd.compiler.Compiler CX^X
    * @throws ParameterFormatException s
    */
    {
    log.trace("F:Class - begin - ", condition);
    if((condition != null) && (condition !== undefined) && !(condition instanceof CompileCondition))
      {
      throw new Error("ParameterFormatException", Creator.CompleteName, null, condition, "condition", "jsd.compiler.CompileCondition", "FAIL");
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v cond jsd.compiler.CompileCondition RpC
    var cond = condition ? condition : new CompileCondition();
    
    //:v clsCmp jsd.compiler.ClassCompiler|null NXRpCCX^X
    var clsCmp = null;
    //:v targets Array Ώ(SCNX)Xg
    var targets = [];
    //:v xmlDocs Array|null (NX)RpCXMLXg
    var xmlDocs = null;
    //:v docMap Object (NX)RpCXML}bv(L[=SCNX/l=XmlDocumentCX^X)
    var docMap = {};
    
    //:v defCmp jsd.compiler.DefinitionCompiler|null pbP[W`t@CRpCCX^X
    var defCmp = null;
    //:v basePacksDirs Array Ώ(pbP[W)Xg
    var defPacks = cond.getDefinitionPackages();
    //:v defDocs Array|null (pbP[W`t@C)RpCXMLXg
    var defDocs = null;
    //:v defMap Object (pbP[W`t@C)RpCXML}bv(L[=pbP[W`t@C/l=XmlDocumentCX^X)
    var defMap = {};
    
    //------------------------------------------------------------------------------
    function hasTarget(className)
     /**
      * RpCΏۂɊ܂܂Ă邩ǂ
      * @param className String NX̊SCNX
      * @return Boolean RpCΏۂɊ܂܂Ă邩ǂ
      */
      {
      log.trace("F:hasTarget - begin - ", className);
      var hasThis = false;
      for(var i = 0; i < targets.length; i++)
        {
        if(targets[i] == className)
          {
          hasThis = true;
          break;
          }
        }
      log.trace("F:hasTarget - end - ", hasThis);
      return hasThis;
      }
    //------------------------------------------------------------------------------
    function executeCompile(index)
     /**
      * RpCs
      * @param index Number Ώۂ̃CfbNX
      * @return jsd.xml.XmlDocument|null RpC
      * @through Exception
      */
      {
      log.trace("F:executeCompile - begin - ", index);
      if(((typeof index) != "number") || (index < 0) || (targets.length <= index))
        {
        return null;
        }
      var xmlDoc = new XmlDocument(1.0);
      if(!clsCmp)
        {
        clsCmp = new ClassCompiler();
        }
      var rootNode = clsCmp.compile(targets[index], cond);
      if(rootNode)
        {
        xmlDoc.documentElement = rootNode;
        }
      log.trace("F:executeCompile - end - ", xmlDoc);
      return xmlDoc;
      }
    //------------------------------------------------------------------------------
    function compile(index)
     /**
      * RpC
      * @param index Number Ώۂ̃CfbNX
      * @return Boolean f̗v
      */
      {
      log.trace("F:compile - begin - ", index);
      var abort = false;
      try
        {
        xmlDocs[index] = executeCompile(index);
        }
      catch(e)
        {
        log.warn("RpCɃG[I", e);
        log.warn("StackTrace = " + e.stackTrace);
        xmlDocs[index] = null;
        if((typeof this.onerror) == "function")
          {
          try
            {
            abort = !this.onerror(e, targets[index]);
            }
          catch(e2)
            {
            abort = true;
            }
          }
        }
      finally
        {
        docMap[targets[index]] = xmlDocs[index];
        }
      log.trace("F:compile - end - ", abort);
      return abort;
      }
    //------------------------------------------------------------------------------
    function executeCompileDefinition(index)
     /**
      * RpCs
      * @param index Number Ώۂ̃CfbNX
      * @return jsd.xml.XmlDocument|null RpC
      * @through Exception
      */
      {
      log.trace("F:executeCompileDefinition - begin - ", index);
      if(((typeof index) != "number") || (index < 0) || (defPacks.length <= index))
        {
        return null;
        }
      var xmlDoc = new XmlDocument(1.0);
      if(!defCmp)
        {
        defCmp = new PackageCompiler();
        }
      cond.findClassDoc = function(className)
        {
        return (docMap[className] instanceof XmlDocument) ? docMap[className] : null;
        };
      var rootNode = defCmp.compile(defPacks[index], cond);
      delete cond.findClassDoc;
      if(rootNode)
        {
        xmlDoc.documentElement = rootNode;
        }
      log.trace("F:executeCompileDefinition - end - ", xmlDoc);
      return xmlDoc;
      }
    //------------------------------------------------------------------------------
    function compileDefinition(index)
     /**
      * RpC(pbP[W`t@C)
      * @param index Number Ώۂ̃CfbNX
      * @return Boolean f̗v
      */
      {
      log.trace("F:compileDefinition - begin - ", index);
      var abort = false;
      try
        {
        defDocs[index] = executeCompileDefinition(index);
        }
      catch(e)
        {
        log.warn("RpCɃG[I", e);
        log.warn("StackTrace = " + e.stackTrace);
        defDocs[index] = null;
        if((typeof this.onerror) == "function")
          {
          try
            {
            abort = !this.onerror(e, cond.getDefinitionFile(defPacks[index]));
            }
          catch(e2)
            {
            abort = true;
            }
          }
        }
      finally
        {
        defMap[cond.getDefinitionFile(defPacks[index])] = defDocs[index];
        }
      log.trace("F:compileDefinition - end - ", abort);
      return abort;
      }
    //------------------------------------------------------------------------------
    function connect(index)
     /**
      * pN쐬
      * @param index Number Ώۂ̃CfbNX
      * @return jsd.xml.XmlDocument|null N
      */
      {
      log.trace("F:connect - begin - ", index);
      if(!xmlDocs || ((typeof index) != "number") || (index < 0) || (xmlDocs.length <= index))
        {
        return null;
        }
      var xmlDoc = xmlDocs[index];
      var rootNode = xmlDoc ? xmlDoc.documentElement : null;
      var clsName = rootNode ? rootNode.getAttribute("id") : null;
      if(xmlDoc && rootNode)
        {
        // XmlDocIuWFNg"/classes/body/members/member"m[hɑ΂visiter\bhsB
        function visitMember(doc, visiter)
          {
          var members = doc ? doc.getElementsByTagName("members") : null;
          var list = (members && (members.length > 0)) ? members[0].childNodes : [];
          for(var i = 0; i < list.length; i++)
            {
            if(list[i].nodeName == "member")
              {
              visiter(list[i]);
              }
            }
          }
        // X[p[NXXmlDocIuWFNg擾\bh
        function getSuperDoc(subDoc)
          {
          var superDoc = null;
          var superList = subDoc ? subDoc.getElementsByTagName("super-class") : null;
          if(superList && (superList.length > 0))
            {
            var cNameNode = superList[0].firstChild;
            var superName = cNameNode ? (cNameNode.firstChild ? cNameNode.firstChild : cNameNode).nodeValue : null;
            if(superName)
              {
              superDoc = docMap[superName];
              }
            }
          return superDoc;
          }
        // poƂĒǉ
        function addInheritMember(member, className)
          {
          var node = member.cloneNode();
          var imsl = xmlDoc.getElementsByTagName("inherit-members");
          var ims  = null;
          if(imsl)
            {
            for(var i = 0; i < imsl.length; i++)
              {
              if(imsl[i].getAttribute("base") == className)
                {
                ims = imsl[i];
                break;
                }
              }
            }
          if(!ims)
            {
            ims = XmlDocument.createElement("inherit-members");
            ims.setAttribute("base", className);
            rootNode.lastChild.appendChild(ims);
            }
          ims.appendChild(node);
          }
        // X[p[NX̃hLg擾
        var target = getSuperDoc(xmlDoc);
        if(target)
          {
          // o[LbV}bv
          var mbrMap = {};
          visitMember(xmlDoc, function(member)
            {
            var name = member.getAttribute("name");
            if(name)
              {
              var def = null;
              for(var i = 0; i < member.childNodes.length; i++)
                {
                if(member.childNodes[i].nodeName == "command-def")
                  {
                  def = (member.childNodes[i].firstChild ? member.childNodes[i].firstChild : member.childNodes[i]).nodeValue;
                  break;
                  }
                }
              if(def && ((def == "S") || (def == "P") || (def == "I")))
                {
                var key = def + "." + name;
                mbrMap[key] = clsName;
                }
              }
            });
          // X[p[NXɃoǉ
          do{
            var targetName = target.documentElement ? target.documentElement.getAttribute("id") : null;
            if(!targetName)
              {
              break;
              }
            visitMember(target, function(member)
              {
              var name = member.getAttribute("name");
              if(name)
                {
                var def = null;
                for(var i = 0; i < member.childNodes.length; i++)
                  {
                  if(member.childNodes[i].nodeName == "command-def")
                    {
                    def = (member.childNodes[i].firstChild ? member.childNodes[i].firstChild : member.childNodes[i]).nodeValue;
                    break;
                    }
                  }
                if(def && ((def == "S") || (def == "P") || (def == "I")))
                  {
                  var key = def + "." + name;
                  if(!mbrMap[key])
                    {
                    addInheritMember(member, targetName);
                    mbrMap[key] = targetName;
                    }
                  }
                }
              });
            }while(target = getSuperDoc(target))
          }
        }
      else
        {
        xmlDoc = null;
        }
      log.trace("F:connect - end - ", xmlDoc);
      return xmlDoc;
      }
    //------------------------------------------------------------------------------
    function link(index)
     /**
      * N쐬
      * @param index Number Ώۂ̃CfbNX
      * @return jsd.xml.XmlDocument|null N
      */
      {
      log.trace("F:link - begin - ", index);
      if(!xmlDocs || ((typeof index) != "number") || (index < 0) || (xmlDocs.length <= index))
        {
        return null;
        }
      var xmlDoc = xmlDocs[index];
      var rootNode = xmlDoc ? xmlDoc.documentElement : null;
      var clsName = rootNode ? rootNode.getAttribute("id") : null;
      if(xmlDoc && rootNode)
        {
        // ΃pX\bh
        var getRelative = function(basePath, targetPath)
          {
          var href = "";
          var temp = basePath;
          do{
            temp = temp.substring(0, Math.max(0, temp.lastIndexOf(".", temp.length)));
            if(!temp || (targetPath.indexOf((temp + "."), 0) == 0))
              {
              break;
              }
            else
              {
              href += "../";
              }
            }while(temp)
          temp = targetPath.substring(temp.length, targetPath.length);
          while(temp && (temp.charAt(0) == "."))
            {
            temp = temp.substring(1, temp.length);
            }
          href += temp.replace(/\./g, "/");
          return href;
          };
        // x[XfBNg擾\bh
        var getDirectory = function(packageName, withGlobalObj)
          {
          var base = cond.getBaseDirectory(packageName, withGlobalObj);
          return base;
          };
        // x[XfBNggq擾\bh
        var getExtension = function(packageName, withGlobalObj)
          {
          var ext = cond.getBaseExtension(packageName, withGlobalObj);
          return ext;
          };
        // N擾\bh
        var getTargetHref = function(className)
          {
          if((className == "null") || (className == "undefined") || (className == "Variant"))
            {
            return null;
            }
          var pkg = className.substring(0, Math.max(0, className.lastIndexOf(".", className.length)));
          var dir = pkg ? getDirectory(pkg) : getDirectory(pkg, true);
          var ext = pkg ? getExtension(pkg) : getExtension(pkg, true);
          var href = null;
          if(dir)
            {
            href = dir + (pkg ? className.substring(pkg.length + 1, className.length) : className) + (ext ? "." + ext : "");
            }
          else
            {
            ext = cond.getExtension();
            for(var i = 0; i < targets.length; i++)
              {
              if((targets[i] == className) && xmlDocs[i])
                {
                href = getRelative(clsName, className) + (ext ? "." + ext : "");
                break;
                }
              }
            }
          return href;
          };
        // `t@C̃Nlink^O猩
        var getDefinitionHref = function(defName)
          {
          var href = null;
          var links = xmlDoc ? xmlDoc.getElementsByTagName("link") : null;
          for(var i = 0; i < links.length; i++)
            {
            var name = links[i].getAttribute("name");
            if(name == defName)
              {
              href = links[i].getAttribute("href");
              break;
              }
            }
          return href;
          };
        // LbV
        var cache = {};
        // N摮̒ǉ
        var classes = xmlDoc ? xmlDoc.getElementsByTagName("class-name") : [];
        for(var c = 0; c < classes.length; c++)
          {
          var cls = classes[c];
          var val = cls.firstChild.nodeValue;
          if(val)
            {
            var href = cache[val];
            if(!href)
              {
              href = getTargetHref(val);
              if(href)
                {
                cache[val] = href;
                }
              }
            if(href)
              {
              classes[c].setAttribute("href", href);
              }
            }
          }
        // N摮̒ǉQ
        var bases = xmlDoc ? xmlDoc.getElementsByTagName("inherit-members") : [];
        for(var b = 0; b < bases.length; b++)
          {
          var node = bases[b];
          var base = node.getAttribute("base");
          if(base)
            {
            var href = cache[base];
            if(!href)
              {
              href = getTargetHref(base);
              if(href)
                {
                cache[base] = href;
                }
              }
            if(href)
              {
              node.setAttribute("href", href);
              }
            }
          }
        // N摮̒ǉR
        var defs = xmlDoc ? xmlDoc.getElementsByTagName("definition") : [];
        for(var d = 0; d < defs.length; d++)
          {
          var uri = defs[d].firstChild;
          if(uri && (uri.nodeName == "uri-value"))
            {
            var val = uri.firstChild.nodeValue;
            if(val)
              {
              var href = getDefinitionHref(val);
              if(href)
                {
                uri.setAttribute("href", href);
                }
              }
            }
          }
        }
      else
        {
        xmlDoc = null;
        }
      log.trace("F:link - end - ", xmlDoc);
      return xmlDoc;
      }
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.addTarget = function(className)
     /**
      * RpCΏۃNXǉ
      * @param className String ΏۂɒǉNX̊SCNX
      * @throws StringFormatException s
      */
      {
      log.trace("I:addTarget - begin - ", className);
      if(!className || ((typeof className) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, className, "className", "NotEmptyString", "FAIL");
        }
      if(!hasTarget(className))
        {
        targets[targets.length] = className;
        }
      log.trace("I:addTarget - end");
      };
    //------------------------------------------------------------------------------
    this.getTargetLength = function()
     /**
      * RpCΏۃNX̌擾
      * @return Number RpCΏۃNX̌
      */
      {
      log.trace("I:getTargetLendth - begin");
      var len = targets ? Math.max(0, targets.length) : 0;
      log.trace("I:getTargetLendth - end - ", len);
      return len;
      };
    //------------------------------------------------------------------------------
    this.getDefinitionLength = function()
     /**
      * RpCΏۃpbP[W`t@Č擾
      * @return Number RpCΏۃpbP[W`t@Č
      */
      {
      log.trace("I:getDefinitionLength - begin");
      var len = defPacks ? Math.max(0, defPacks.length) : 0;
      log.trace("I:getDefinitionLength - end - ", len);
      return len;
      };
    //------------------------------------------------------------------------------
    this.hasTarget = function(className)
     /**
      * RpCΏۂɊ܂܂Ă邩ǂ
      * @param className String NX̊SCNX
      * @return Boolean RpCΏۂɊ܂܂Ă邩ǂ
      * @throws StringFormatException s
      */
      {
      log.trace("I:hasTarget - begin - ", className);
      if(!className || ((typeof className) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, className, "className", "NotEmptyString", "FAIL");
        }
      log.trace("I:hasTarget - end");
      return hasTarget(className);
      };
    //------------------------------------------------------------------------------
    this.removeTarget = function(className)
     /**
      * RpCΏۂ̃NX菜
      * @param className String 菜NX̊SCNX
      * @throws StringFormatException s
      */
      {
      log.trace("I:removeTarget - begin - ", className);
      if(!className || ((typeof className) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, className, "className", "NotEmptyString", "FAIL");
        }
      for(var i = 0; i < targets.length; i++)
        {
        if(targets[i] == className)
          {
          targets = targets.slice(0, i).concat(targets.slice((i + 1), targets.length));
          i--;
          }
        }
      log.trace("I:removeTarget - end");
      };
    //------------------------------------------------------------------------------
    this.clearTargets = function()
     /**
      * RpCΏۂNA
      */
      {
      log.trace("I:clearTarget - begin");
      targets = [];
      log.trace("I:clearTarget - end");
      };
    //------------------------------------------------------------------------------
    this.compile = function(index)
     /**
      * RpCs
      * @param index [Number] CfbNX
      * @return jsd.xml.XmlDocument|Array|null RpC(jsd.xml.XmlDocument)܂͂̔z
      * @throws NumberFormatException|NumberRangeException s
      */
      {
      log.trace("I:compile - begin - ", index);
      if((index !== undefined) && ((typeof index) != "number"))
        {
        throw new Error("NumberFormatException", Creator.CompleteName, null, index, "index", "[Number]", "FAIL");
        }
      else if((index < 0) || (targets.length <= index))
        {
        throw new Error("NumberRangeException", Creator.CompleteName, null, index, "index", (">=0&<"+targets.length), "FAIL");
        }
      // PRpC
      if((typeof index) == "number")
        {
        if(!xmlDocs)
          {
          xmlDocs = [];
          }
        var xmlDoc = null;
        var abort = compile(index);
        if(!abort && xmlDocs[index])
          {
          xmlDoc = xmlDocs[index];
          }
        log.trace("I:compile - end - ", xmlDoc);
        return xmlDoc;
        }
      // SăRpC
      else
        {
        xmlDocs = [];
        for(var i = 0; i < targets.length; i++)
          {
          var abort = compile(i);
          if(abort)
            {
            break;
            }
          }
        }
      log.trace("I:compile - end - ", xmlDocs);
      return xmlDocs;
      };
    //------------------------------------------------------------------------------
    this.compileDefinition = function(index)
     /**
      * pbP[W`t@C̃RpCs
      * @param index [Number] CfbNX
      * @return jsd.xml.XmlDocument|Array|null RpC(jsd.xml.XmlDocument)܂͂̔z
      * @throws NumberFormatException|NumberRangeException s
      */
      {
      log.trace("I:compileDefinition - begin - ", index);
      if((index !== undefined) && ((typeof index) != "number"))
        {
        throw new Error("NumberFormatException", Creator.CompleteName, null, index, "index", "[Number]", "FAIL");
        }
      else if((index < 0) || (defPacks.length <= index))
        {
        throw new Error("NumberRangeException", Creator.CompleteName, null, index, "index", (">=0&<"+defPacks.length), "FAIL");
        }
      // PRpC
      if((typeof index) == "number")
        {
        if(!defDocs)
          {
          defDocs = [];
          }
        var defDoc = null;
        var abort = compileDefinition(index);
        if(!abort && defDocs[index])
          {
          defDoc = defDocs[index];
          }
        log.trace("I:compileDefinition - end - ", defDoc);
        return defDoc;
        }
      // SăRpC
      else
        {
        defDocs = [];
        for(var i = 0; i < defPacks.length; i++)
          {
          var abort = compileDefinition(i);
          if(abort)
            {
            break;
            }
          }
        }
      log.trace("I:compileDefinition - end - ", defDocs);
      return defDocs;
      };
    //------------------------------------------------------------------------------
    this.setSubClasses = function()
     /**
      * m̃TuNXݒ肷
      */
      {
      log.trace("I:setSubClasses - begin");
      var xmlMap = {};
      for(var i = 0; i < xmlDocs.length; i++)
        {
        var xmlDoc = xmlDocs[i];
        var className = (xmlDoc && xmlDoc.documentElement) ? xmlDoc.documentElement.getAttribute("id") : null;
        if(className)
          {
          xmlMap[className] = xmlDoc.documentElement;
          }
        }
      if(!clsCmp)
        {
        clsCmp = new ClassCompiler();
        }
      clsCmp.setSubClasses(xmlMap);
      log.trace("I:setSubClasses - end");
      };
    //------------------------------------------------------------------------------
    this.connect = function(index)
     /**
      * pNs
      * @param index [Number] CfbNX
      * @throws NumberFormatException s
      */
      {
      log.trace("I:connect - begin - ", index);
      if((index !== undefined) && ((typeof index) != "number"))
        {
        throw new Error("NumberFormatException", Creator.CompleteName, null, index, "index", "[Number]", "FAIL");
        }
      // PN
      if((typeof index) == "number")
        {
        if((0 <= index) && (index < xmlDocs.length))
          {
          connect(index);
          }
        }
      // SăN
      else
        {
        for(var i = 0; i < xmlDocs.length; i++)
          {
          connect(i);
          }
        }
      log.trace("I:connect - end");
      };
    //------------------------------------------------------------------------------
    this.link = function(index)
     /**
      * Ns
      * @param index [Number] CfbNX
      * @throws NumberFormatException s
      */
      {
      log.trace("I:link - begin - ", index);
      if((index !== undefined) && ((typeof index) != "number"))
        {
        throw new Error("NumberFormatException", Creator.CompleteName, null, index, "index", "[Number]", "FAIL");
        }
      // PN
      if((typeof index) == "number")
        {
        if((0 <= index) && (index < xmlDocs.length))
          {
          link(index);
          }
        }
      // SăN
      else
        {
        for(var i = 0; i < xmlDocs.length; i++)
          {
          link(i);
          }
        }
      log.trace("I:link - end");
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    // Kvł΂ŊeRpCCX^Xݒ肷
    log.trace("F:Class - end");
    return this;
    }
  
  return Class;
  });
